// WOCFOSP1.PRG -> EXPLORACIONES / TRATAMIENTOS ESPECIALES = ARGON
#include "FiveWin.ch"
#include "Image.ch"

#define K_ESC   27
#define BTN_WIDTH  50   //45   //18
#define BTN_HEIGHT 18
#define TAB  ' - ' 
#define CRCR chr( 13 )
#define K_F5 (-34)
#define K_F7 (-36)
#define HORZRES     8	//10	//8      
#define VERTRES     10	//11	//10
#define PLANES      15     

static oWnd, oClp
static oBmpW, cFileBmp

		// Variables propias imprescindibles en todos los fuentes
static mNombre  := ''
static mHistoria:= ''
static mPrimero := 0
static multimo  := 0
static mFechaNaci
static mfechaulti
static Date
static a10      := ''
static oBrush   := ''
//atic FileHelp := '' 
static SetAyuda := 0
static lMotivo  := .f., lAnsi := .f.
static oMenu, aListImg := {}
static nNivelacc:= 4
static nUsuario := 1
static cTitular         //:= "DR JUAN PLANELLES LAZAGA"
static contaajeno := ''
static cEleccion:= ''

static lChek := .t.
static ColorDlg 
static ColorTxt
static cTitulo
static cTitEsp
static nExpl
static aValores
static cFlogo
static cViaArchivo 
static cBase
static nRecno
static lAjustar := .f.
static aRest
static nXpR := 0.862, nXpC := 1.34  // Correccion Says
static nXtR := 0.67  , nXtC := 1.16 // Correccion botones
static lVer := .f.

//*******************************************************************
function Special( nExp, cTit, Dat, mNom, mHis, oWn, CDlg, Ctxt, mUlt, lVe )   
//*******************************************************************
local cExt := PADL( AllTrim( str( Lis_red->( RecNo() ), 3 ) ), 3, "0" )

DEFAULT lVe := .f.	// Parametro de ver si hay archivados

lVer := lVe

Date      := Dat
mNombre   := mNom
mHistoria := mHis
oWnd      := oWn
ColorDlg  := CDlg
ColorTxt  := CTxt
mUltimo   := mUlt
cTitulo   := cTit
nExpl     := nExp
aValores  := {}
cFlogo    := 'ArgLogo.Bmp'
cViaArchivo := "\" + CurDir() + '\'
cBase       := 'Argon'


DO CASE

	CASE nExpl == 2
                cFileBmp := 'Argon' + cExt + '.Bmp'     //Dib.Bmp'
                cTitEsp  := 'Dibujos de Laser de Retina'
//              FondoSpec()
 
if ( lVer )
	if File( "ARGON.DBF" ) .and. File( "ARGON.NTX" )
		usa_base( "Argon", .f., "Argon", 5, .t. )
		DbSeek( mHistoria )
		if Argon->Historia == mHistoria
		  Argon->( DbCloseArea() )
		  Return "LASER / " 
		else  	
		  Argon->( DbCloseArea() )
		  Return "" 
	  endif
  else
  	Return "" 
	endif
endif

		Argon()
//CASE
//CASE

ENDCASE

Return nil
//---------

//*************************
static function FondoSpec()
//*************************
Local omenu1, nDate := Date
/*
 MENU omenu1 POPUP

	 MENUITEM OemToAnsi( '&Lser de Argn' ) ;  
	    ACTION Argon() ;
	    MESSAGE OemToAnsi("Hoja clnica de Lser de Retina " )  //Argn ")

	 SEPARATOR

	 MENUITEM OemToAnsi( '&Angio de Retina' ) ;  
	    ACTION MsgInfo( 'Angio de retina..', 'Informacin.' ) ;
	    MESSAGE OemToAnsi("Informes de Angios de retina  ")

	 SEPARATOR

	 MENUITEM OemToAnsi( '&Fibras nerviosas' ) ;  
	    ACTION MsgInfo( 'Haz de fibras..', 'Informacin.' ) ;
	    MESSAGE OemToAnsi("Informes retinografia del haz arciforme" )

 ENDMENU

   ACTIVATE POPUP oMenu1 WINDOW oWnd AT 1, 185
*/
Return oMenu1
*------------
*
//*********************
static function Argon()
//*********************
local nArea := SELECT(), cArea := ALIAS( nArea )
local aFTabla := {}, cDisc, cPath, cFile := 'Argon'
 
iif( !File( '.\bitmaps\Fondo_AO.Bmp' ), ;
	LzCopyFile( 'Fondo_Ao.Bmr', '.\bitmaps\Fondo_Ao.Bmp' ), Nil )

	CreaArgon( "Argon" )

	usa_base( 'Argon', .f., 'Argon', 5, .t. )

if FCount() < 12 .or. ( !Empty( FieldGet( 1 ) ) .and. !Empty( FieldGet( 2 ) ) )

	// Para el clinico, y luego eliminar este bloque !!!!!!!!!!!!!!
	aftabla := dbstruct()
	( 'Argon' )->( DbCloseArea() )
        If FunCopTot( cFile, 'Temp1' )
                FErase( 'ARGON.DBF' )
                CreaArgon( 'Argon' )

                    If FunAppFrom( cFile, 'Temp1' )
                    // Cargar los datos sin Fallo XP
                        FErase( 'TEMP1.DBF' )
                    Else
                        If FunCopTot( 'Temp1', cFile )
                        Endif
                      MsgStop( 'Error al cargar de Temp1 a: ' + cFile, 'Aviso !.' )
                      Return Nil

                    Endif
        endif

/*        copy file argon.dbf to argon2.dbf
	FErase( 'ARGON.DBF' )
	CreaArgon( 'Argon' )
	usa_base( 'Argon', .t., 'Argon', 5, .t. )
	APPEND FROM argon2
	FErase( 'ARGON2.DBF' )
	( 'Argon' )->( DbCloseArea() )
	usa_base( 'Argon', .f., 'Argon', 5, .t. )
*/ 

	usa_base( 'Argon', .f., 'Argon', 5, .t. )
endif

( 'Argon' )->( DbGoto( 1 ) )
cViaArchivo := Argon->Directorio

/*        cDisc      := cFileDisc( cViaArchivo )
	cDisc      := iif( Empty( cDisc ) .or. cDisc == "\", ;
				cFileDisc( ( cBase )->Disco + ':' ), cDisc )
	cPath      := cFilePath( cViaArchivo )
	cViaArchivo := cPath	//cDisc + cPath 

Bloq_reg( 5 )
( cBase )->Directorio := cViaArchivo
Desbloq()
*/
// Listado de archivo del paciente en curso ..
ListaArgon()

//( 'Argon' )->( DbCloseArea() )
CierraDb( 'Argon' )

//   DbSelectArea( cArea )

   Historic->( DbGoto( mUltimo ) )

return nil
//---------

//********************************
       Function CreaArgon( cFile )
//********************************
local aDbf := {}, i := 0, cCurDrive := HB_CurDrive()
FIELD historia, fecha 

if !File( 'Argon.dbf' )

	aadd( aDbf, { 'HISTORIA'  , 'C', 10, 0 } )
	aadd( aDbf, { 'FECHA'     , 'D', 08, 0 } )
	aadd( aDbf, { 'OJO'       , 'C', 02, 0 } )
	aadd( aDbf, { 'DISPAROS'  , 'N', 04, 0 } )
	aadd( aDbf, { 'DIAMETRO'  , 'N', 04, 0 } )
	aadd( aDbf, { 'SEGUNDOS'  , 'N', 04, 2 } )
	aadd( aDbf, { 'INTENSIDAD', 'N', 04, 0 } )
	aadd( aDbf, { 'DESCRIPCIO', 'C', 30, 0 } )
	aadd( aDbf, { 'LASER'     , 'C', 10, 0 } )
	aadd( aDbf, { 'NOMIMAGEN' , 'C', 30, 0 } )
	aadd( aDbf, { 'UNIDAD'    , 'C',  2, 0 } )
	aadd( aDbf, { 'DISCO'     , 'C',  6, 0 } )
	aadd( aDbf, { 'DIRECTORIO', 'C', 90, 0 } )

	   DbCreate( cFile, aDbf )

	usa_base( 'Argon', .t., '', 5, .t. )

	index on ( historia+dtos(fecha) ) to argon.ntx

	appe_reg()

	FieldPut( 03, 'D ' )
	FieldPut( 04, 0300 )
	FieldPut( 05, 0150 )
	FieldPut( 06, 0.10 )
	FieldPut( 07, 0150 )
	FieldPut( 09, 'Argn ' )
	FieldPut( 10, '0'  )
        FieldPut( 11, cCurDrive )
	FieldPut( 12, '1'  )
	FieldPut( 13, "\" + CurDir() + '\' + upper( cFile ) + '\' )

	desbloq()

	( 'Argon' )->( DbCloseArea() )

endif

if !File( 'Argon.ntx' )
	usa_base( 'Argon', .t., '', 5, .t. )
	index on ( historia+dtos(fecha) ) to argon.ntx
	( 'Argon' )->( DbCloseArea() )
endif

return( nil )
//------------

//*******************************
static Function CreaLista( aVal )
//*******************************
//local  aRest    // Variable para acomodar codigo de restaura() // statica
local aDrvs := aDrives(), lDisc := .t.
Field Historia, Fecha

aValores := aVal	// := {}
aRest	 := {}

set exact on
DbSeek( mHistoria )

//if ( lVer )
//	Return( iif( Argon->Historia == mHistoria, "Laser" + " / ", "" ) )
//endif

   do While Argon->Historia == mHistoria .and. !Eof()
//     if !Empty( Historia ) .and. !Empty( Fecha )
	aadd( aValores, { OemToAnsi( DTOC( Argon->Fecha ) ),;
			 OemToAnsi( Argon->Laser ),;
			 OemToAnsi( Argon->Ojo ),;
			 OemToAnsi( str( (Argon->Disparos), 4 ) ),;
			 OemToAnsi( str( (Argon->Diametro), 4 ) ),;
			 OemToAnsi( str( (Argon->Segundos), 4, 2 ) ), ;
			 OemToAnsi( str( (Argon->Intensidad), 4 ) ), ;
			 OemToAnsi( Argon->Descripcio ), Recno(), ;
                         OemToAnsi( Argon->NomImagen ) ,;
			 OemToAnsi( Argon->Unidad ),;
			 OemToAnsi( Argon->Disco ),;
			 OemToAnsi( Argon->Directorio ) } )

        aadd( aListImg,  ;
                         OemToAnsi( AllTrim( Argon->Unidad ) ) + ':' + ;
                         OemToAnsi( AllTrim( Argon->Directorio ) ) + ;
                         OemToAnsi( AllTrim( Argon->NomImagen ) ) ;
           ) // lista de nombres


	aadd( aRest, { OemToAnsi( DTOC( Argon->Fecha ) ),;
			 OemToAnsi( Argon->Disco ),;
			 OemToAnsi( Argon->Unidad ),;
			 OemToAnsi( Argon->Directorio ),;
			 OemToAnsi( Argon->NomImagen ) ,;
			 OemToAnsi( Argon->Descripcio ), Recno() } )

//     endif
        iif( ASCAN( aDrvs, { |x| ;
        Upper( Trim( x ) ) ==  Upper( Trim( Argon->Unidad ) ) .or. ;
        Upper( Trim( x ) ) ==  Upper( Trim( Argon->Unidad ) ) + ':' ;
          } ) > 0 , Nil, lDisc := .f. )

        DbSkip()                     
   enddo
        //MsgList( aListImg )


   if !lDisc
        MsgAlert( 'Revise la UNIDAD de Archivo ' + CRLF + ;
                  'asignada en cada elemento ' + CRLF + ;
                  'de la lista; Alguna No Existe' + CRLF +;
                  'o No esta CONECTADA !.', 'Atencin !.' )
   endif


   if Empty( aValores )
	aadd( aValores, { 'LASER:', '->', '', 'Paciente', 'Sin', 'datos', ;
			'archivados', '', 0, cFlogo, '', '', '' } )
   else
	//MsgInfo( 'Restaurar ficheros' )
	aEval( aValores, { | cEl, nEl | iif( !File( aValores[ nEl, 10 ] ), ;
			Restaura( aRest[ nEl ] ), ) } )
			// Restaura = funcion en wocfun.prg
			// Se extraen de los directorios de archivo
			// los .Bmps del paciente y exploracion actuales
   endif


Return aValores
//--------------

//**************************
       function ListaArgon()
//**************************
local aCampoNom := {}, oBrw, oDlg, oFont, oSay, oBmp, hDC
local aNuevo := {}, nRec := RecNo(), cInfo, cCurDrive := HB_CurDrive()
local nItem := 1, cDisc := '', bDisc, lDisc, bSalva, lVer := .f.
local obt1, obt2, obt3, obt4, obt5, obt6, obt7, obt8, obt9, oBot3, ;
                  oBot12, oBot13, oBot14, oBot15, oBot16, oBot17

local letra := 'A'      //SubsTr( "PFRTMBJCLIVODA", nExpl, 01 ) // Teclas de expl..
local cExt := PADL( AllTrim( str( Lis_red->( RecNo() ), 3 ) ), 3, "0" )
local lUsImg := .t.     //iif( IsWinNT(), .f., .t. )
local aLis := {}, aDir, cVerIso := 'VerISO.' + cExt
local cTarget := Upper( cCurDrive ) + ':', bDir, ;
        cFile := 'SELED.' + cExt, nI := 0, aD := {}, ;
                        bLis := {|| Nil }, bImg := {|| Nil }
local bCarp   := {|| Nil }, cFNam := '', cTemp := ''
local cDirAct := ''

if IsWinNT()
        cFile := cVerISO
        lUsImg := iif( File( cFile ), .f., lUsImg )
//? lUsImg, File( cFile )
endif


cTarget := cTarget + '\' + CurDir( cTarget )        //"C:\" + CurDir( "C:" )
cDirAct := cTarget

cTemp   := letra + 'ARG' + cExt // carpeta para ver
                        // imagenes temporales en XP desde explorer
cTarget := cTarget + '\' + cTemp

bDir := { | carpeta | ;
                iif( !File( carpeta ), ;
                        lMkDir( carpeta ), Nil ) ;
                }

Eval( bDir, cTarget )   // Se crea la carpeta si no la habia


//---------------------------------------------------
cInfo := 'Left Click: Image ADJUST  - ' + CRLF + ;
                        'Right Click: - Maximiza'

bDisc := { || ;
	cDisc := AllTrim( aValores[ nItem, 11 ] ),;
	cDisc := iif( Empty( cDisc ), cCurDrive, cDisc ),;
	cDisc := iif( Len( cDisc ) > 1, Left( cDisc, 1 ), cDisc ),;
	cDisc := iif( Upper( cDisc ) $ 'ABCDEFGHIJKLMNOPQRSTUVXYZ', ;
		cDisc, cCurDrive ), ;
		aValores[ nItem, 11 ] := cDisc }

bSalva := { || ;
	nRec := RecNo(), DbGoto( 1 ), ;
	Bloq_reg( 5 ), ;
	FieldPut( 11, aValores[ nItem, 11 ] ), ;
	FieldPut( 13, aValores[ nItem, 13 ] ), ;
	DesBloq(), ;
	DbGoto( nRec ) }

   aadd( aCampoNom, "Fecha" )
   aadd( aCampoNom, OemToAnsi( "Tcnica" ) )
//   aadd( aCampoNom, OemToAnsi( "Lser" ) )
   aadd( aCampoNom, OemToAnsi( "Ojo " ) )
   aadd( aCampoNom, OemToAnsi( " Nm." ) )
   aadd( aCampoNom, OemToAnsi( "Dim." ) )
   aadd( aCampoNom, OemToAnsi( "Seg." ) )
   aadd( aCampoNom, OemToAnsi( "Intensidad" ) )
   aadd( aCampoNom, OemToAnsi( "  Descripcin" ) )
   aadd( aCampoNom, OemToAnsi( "  Imagen"      ) )
   aadd( aCampoNom, OemToAnsi( "Unidad"      ) )
   aadd( aCampoNom, OemToAnsi( "Disco"         ) )
   aadd( aCampoNom, OemToAnsi( "Directorio"    ) )

   aValores := CreaLista( {} )

   if !( lUsImg )
        // Vaciado carpeta para usarla ..
        aDir := Directory( cTarget + '\' + '*.*' ) 
        aEval( aDir, {| aV | ;
                    cFNam := aV[ 1 ], ;
                    cFNam := cTarget + '\' + cFileName( cFNam ), ;
                    iif( File( cFNam ), Ferase( cFNam ), Nil ) } ) 

        bLis := {|| ;
        aLis := {}, ;
        aEval( aValores, {| aVal | ;
               aadd( aLis, aVal[ 10 ] ) } ) ;
                 }                                                  
        Eval( bLis )    // Se cargan los nombres para la carpeta de marras..

   // Se pasan a la carpeta, se ven en explorer, se
   // salvan por si hay cambios, y se eliminan de la carpeta especial
        // Vaciar posibles ficheros restantes, antes
                                                                    
        bImg := {|| ;
        aEval( aLis, { | c, n | ;
        aD := Directory( aLis[ n ] ), ;
        iif( File( aLis[ n ] ) .and. aD[ 1, 2 ] > 0, ;
              LZCopyFile( aLis[ n ], cTarget + '\' + aLis[ n ] ), Nil ) } ) ;
                  }
        Eval( bImg )    // Cargado de la carpeta de marras
   endif

   cFlogo := if( aValores[ 1, 9 ] > 1, aValores[ 1, 10 ], cFlogo )
   cFLogo := iif( !File( cFLogo ), '.\bitmaps\Bandera.Bmp', cFLogo )

   lAjustar := .t. //.f. // pongo .t. para q se maximize y ajuste al abrirse

   DEFINE FONT oFont NAME 'Arial' SIZE 6, 13 BOLD

   DEFINE DIALOG oDlg FROM 0, 3 TO 28.5, 79 ;
      TITLE OemToAnsi( "Gestin de Hoja Clnica de Lser de Retina" + ;
        ' - Moverse: Flechas, AvPg, RePg' )  ;  //OF oWnd 
	COLOR ColorTxt, ColorDlg

   If lUsImg
           @ 0, 38*nXpC SAY oSay PROMPT "IMAGEN ADJUST" ;
                FONT oFont Size 80, 08 COLOR ColorTxt, ColorDlg
   endif
/*   @ 0.8,  1 BITMAP oBmpW FILE cFLogo SIZE 284, 144 SCROLL OF oDlg ; */
/*   @ 0.8,  1 IMAGE oBmpW FILE cFLogo SIZE 284, 144 SCROLL OF oDlg ; */

   @ 0.8,  1 IMAGE oBmpW  SIZE 284, 144 SCROLL OF oDlg ;
                MESSAGE 'Imagenes archivados..' + cInfo   ;
	  ON LEFT CLICK ( AjustaZoom( oBmpW, "S", oSay ) ) ;
          ON RIGHT CLICK iif( lUsImg, ( lAjustar := Wgraf1( ;
        aValores[ nItem, 10 ], , oWnd, oSay, lAjustar, oBmpW ),  ;
		 iif( lAjustar == .t., ;
			AjustaZoom( oBmpW, "s", oSay ),  ;
                    AjustaZoom( oBmpW, "1", oSay ) ) ), ; 
               WAITRUN( 'EXPLORER ' + cTarget, 3 ) )                         

     //     AjustaZoom( oBmpW, "1", oSay ) ), oBmpW:Refresh(.t.) ), ;

        oBmpW:cToolTip := cInfo
         
      oBmpW:Progress( .f. )
//      oBmpW:bMMoved := {|| iif( lVer, ( MsgInfo( cInfo ), lVer := .f. ), Nil ) }
//        MsgWait( "INSPECCION Terminada.." ,"Ficheros ..", 2 )

//  //    oWndBmp:SetControl( oBmp )

	
   @ 11.2, 1 LISTBOX oBrw FIELDS   ;
	  aValores[ nItem, 1 ], aValores[ nItem, 4 ], ;
	  aValores[ nItem, 8 ], aValores[ nItem, 3 ], ;
	  aValores[ nItem, 5 ], aValores[ nItem, 6 ], ;
	  aValores[ nItem, 7 ], aValores[ nItem, 2 ],   ;
	  aValores[ nItem, 10 ], aValores[ nItem, 11 ], ;
	  aValores[ nItem, 12 ], aValores[ nItem, 13 ]  ;
	  HEADERS aCampoNom[1],aCampoNom[4],aCampoNom[8],;
		  aCampoNom[3],aCampoNom[5],aCampoNom[6],;
		  aCampoNom[7],aCampoNom[2], ;
		  aCampoNom[9],aCampoNom[10], ;
		  aCampoNom[11],aCampoNom[12] ;
	  FIELDSIZES 65, 40, 240, 25, 40, 40, 60, 100, 240, 40, 80, 240  ;
	  OF oDlg SIZE 284, 39   FONT oFont	;
	ON CHANGE ( oBmpW:LoadBmp( aValores[ nItem, 10 ] ), oBmpW:Refresh(), ;
 				oBrw:Refresh(), oBrw:SetFocus() )       

   oBrw:bGoTop    = { || nItem := 1 }
   oBrw:bGoBottom = { || nItem := Eval( oBrw:bLogicLen ) }
   oBrw:bSkip     = { | nWant, nOld | nOld := nItem, nItem += nWant,;
		nItem := Max( 1, Min( nItem, Eval( oBrw:bLogicLen ) ) ),;
		nItem - nOld }
   oBrw:bLogicLen = { || Len( aValores ) }
   oBrw:cAlias    = "Array"                // Just put something
                                                     
     @ 0.1, 0.2 BUTTON obt1 PROMPT "A&yuda" OF oDlg ;
	SIZE 25, 08                     FONT oFont ;
        ACTION  ;
            IIF( FILE( "WOCAYUDA.EXE" ), WAITRUN( "WOCAYUDA 29" ),;
        FwHelp( "Argon.txt" ) ) ;       //, oBrw:SetFocus() )
        MESSAGE 'Ayuda en Busqueda / Introduccion de DATOS..'
		oBt1:cToolTip := 'Ayuda ..'

     @ 0.1, 4.5*nXtC BUTTON obt2 PROMPT "Val&ores" OF oDlg ;
	SIZE 25, 08                       FONT oFont ;
	ACTION ( nRec := Recno(), EditSpec( oBrw, .f., ;
       { '', '', '', '', '', '', '', '', aRest[nItem,7],cFlogo,'','','' } , ;
	oDlg, nRec ), DbGoto( nRec ), oBrw:Refresh(), oBrw:SetFocus() ) ;
        MESSAGE OemToAnsi( 'Modificar valores fichero ACTUAL .. ' )
                oBt2:cToolTip := 'Modificar valores Fichero ACTUAL .. '

     @ 0.1, 8.8*nXtC BUTTON oBot13 PROMPT "Zoo&m 1" OF oDlg ;
        SIZE 25, 08 WHEN ( lUsImg ) ;                      
	FONT oFont ;
	 ACTION ( AjustaZoom( oBmpW, "1", oSay ), oBrw:SetFocus() ) ;
	MESSAGE 'Zoom 100%' 
      oBot13:cToolTip := 'Zoom 100 %' 

     @ 0.1,13.1*nXtC BUTTON oBot14 PROMPT "+ &Zoom" OF oDlg ;
        SIZE 25, 08                       FONT oFont WHEN ( lUsImg ) ;
        ACTION ( AjustaZoom( oBmpW ,"A", oSay ), oBrw:SetFocus() ) ;
	MESSAGE '+ Zoom 10 %' 
      oBot14:cToolTip := '+ Zoom 10 %'

     @ 0.1,17.4*nXtC BUTTON oBot15 PROMPT "- Z&oom" OF oDlg ;
        SIZE 25, 08                       FONT oFont WHEN ( lUsImg ) ;
	ACTION ( AjustaZoom( oBmpW ,"R", oSay ), oBrw:SetFocus() );
	MESSAGE '-- Zoom 10 %' 
      oBot15:cToolTip := '-- Zoom 10 %'

     @ 0.1,21.7*nXtC BUTTON oBot16 PROMPT "&Copy" OF oDlg ;
	SIZE 25, 08                       FONT oFont ;
                ACTION( Copiar( aValores[ nItem, 5 ], 'A', .t., .t. ), ;
			oBrw:SetFocus() );
                MESSAGE 'Importar/Exportar ..' 
      oBot16:cToolTip := 'Importar/Exportar ..'

     @ 0.1,26*nXtC BUTTON oBot17 PROMPT "N&ueva Via" OF oDlg ;
        SIZE 29, 08                       FONT oFont ;
                MESSAGE 'Nueva Via de Archivos por OMISION ..' ;
	ACTION ( nRec := Recno(), EditSpec( oBrw, .f., ;
		{ '', '', '', '', '', '', '', '', 1,cFlogo,'','','' } , ;
        oDlg, nRec ), DbGoto( nRec ), oBrw:Refresh(), oBrw:SetFocus() ) 

/*                ACTION ( ;
                MsgInfo( 'Si desea CREAR un Directorio No existente' + CRLF+;
                        'puede hacerlo desde el boton <Valores>' + CRLF +;
                        'y una vez creado devuelva al fichero' + CRLF +;
                        'que estaba seleccionado, su anterior'+ CRLF+;
                        'directorio, y vuelva a llamar <Nueva Via>' + CRLF +;
                        'para seleccionar el nuevo directorio'+ CRLF+;
                        'que en adelante sera usado por omision'  ),;
                aValores[ nItem, 13 ] := ;
	cGFile( cFLogo, 'A', 'Elija Via de Archivo' ), ;
		aValores[ nItem, 13 ] := cFilePath( aValores[ nItem, 13 ] ), ;
 iif(    MsgYesNo( 'NUEVA Via Archivo' + CRLF + Trim(aValores[ nItem, 13 ]), 'Elija una opcin.' ),;
	( aValores[ nItem, 11 ] := Left( aValores[ nItem, 13 ], ;
		at( ':', aValores[ nItem, 13 ] )-1 ), Eval( bDisc ), ;
	aValores[ nItem, 13 ] := SubsTr( aValores[ nItem, 13 ], ;
		at( ':', aValores[ nItem, 13 ] )+1 ),;	// + '\'
			oBrw:RefresH(), oBrw:SetFocus(), ;
				Eval( bSalva ) ), ;
			MsgAlert( 'NO se ha modificado' + CRLF + ;
				'la Via de Archivos !..', 'Atencin !.' ) ) ) ;
		MESSAGE 'Nueva Via Archivo ..' 
*/
      oBot17:cToolTip := 'Elegir Nueva via de archivo por OMISION ..'

     @ 0.1,31*nXtC BUTTON oBot12 PROMPT if( lUsImg, "&Ver ..", ;
                                '&Visor ..' ) OF oDlg ;
        SIZE 25, 08                       FONT oFont ;
            ACTION iif( lUsImg, lAjustar := Wgraf1( ;
                aListImg, "", oWnd, oSay, lAjustar, oBmpW ),  ;
                     WAITRUN( 'EXPLORER ' + cTarget, 3 )  ) ;
                MESSAGE 'Examinar Archivos ..' 

       oBot12:cToolTip := ;
         iif( lUsImg, OemToAnsi( 'Ver completa imgen actual' + CRLF +;
                                'y otras existentes en' + ;
      CRLF + 'directrios  unidades ..' + CRLF + ;
      'Sobre la imagen: '+ cInfo ), ;
                       OemToAnsi(  'Visualizador de Imgenes de Windows' ) )

  /*              ACTION WGraf1( '', '*.*', oWnd,,,,, .t. ) ; */
                
      @ 16.4*nXtR,  1*nXtC BUTTON oBt3 PROMPT OemToAnsi( "&Nuevo" )    OF oDlg ;
      ACTION ( iif( EditGraf( .t., aValores[ nItem ], , cTarget ), ;
		( oBt4:Enable(), oBt4:Refresh(), ;
		  oBt5:Enable(), oBt5:Refresh() ), ), ;
		aValores := CreaLista( {} ), ;
                iif( !lUsImg, Eval( bLis ), Nil ), ;
		( cBase )->( DbGoto( LastRec() ) ),     ;
		nItem := Len( aValores ), ;
		oBmpW:LoadBmp( aValores[ nItem, 10 ] ),   ;
		oBrw:Refresh(), oBrw:SetFocus() ) ;
		MESSAGE OemToAnsi( 'Aadir nuevo Registro a la lista..' ) ;
		 SIZE 40, 09
	oBt3:cToolTip := OemToAnsi( 'Aadir nuevo Registro a la lista..' )

/*        ( EditGraf( .f., aValores[ nItem ] ), ;
		oBmpW:LoadBmp( aValores[ nItem, 10 ] ) ),   ;
        EditSpec( Nil, .f., aValores[ nItem ], , aValores[nItem,9] ) ), ;
*/
     @ 16.4*nXtR,  8*nXtC BUTTON oBt4 PROMPT "&Editar" OF oDlg  ;
	ACTION ( iif( MsgYesNo( 'Imagen: ' + Trim(aValores[ nItem, 10 ]) + ;
			CRLF + 'Desea Editarla?..', 'Elija una opcin.' ), ;
	( EditGraf( .f., aValores[ nItem ] ), ;
		oBmpW:LoadBmp( aValores[ nItem, 10 ] ) ),   ;
         ), oBrw:Refresh(), oBrw:SetFocus() ) ;
	MESSAGE 'Editar la linea actual';
	SIZE 40, 09 
	if aValores[ 1, 9 ] == 0
		oBt4:Disable()
	endif
		oBt4:cToolTip := 'Editar la linea actual'

     @ 16.4*nXtR, 15*nXtC BUTTON oBt5 PROMPT "E&limina"  OF oDlg   ;
     ACTION ( ;
	DelArgon( oBrw, aValores[ nItem, 9 ], aValores[ nItem, 1 ], ;
		aValores[ nItem, 10 ] ), ;
                aValores := CreaLista( {} ), ;
                iif( !lUsImg, Eval( bLis ), Nil ), ;
                nItem := Min( Len( aValores ), nItem ), ;
		oBmpW:LoadBmp( aValores[ nItem, 10 ] ),   ;
                oBrw:Refresh(), oBmpW:Refresh(), oBrw:SetFocus() )       ;
		MESSAGE 'Eliminar la linea actual';
		SIZE 40, 09      
	if aValores[ 1, 9 ] == 0
		oBt5:Disable()
	endif
		oBt5:cToolTip := 'Eliminar la linea actual'
/*
      @ 16.4*nXtR,  22*nXtC BUTTON oBt6 PROMPT "Im&primir"    OF oDlg          ;
	 ACTION imprimeBmp( aCamponom, aValores[ nItem, 10 ], oBmpW, oBrw ) ;
		MESSAGE 'Imprimir la lista actual';
		SIZE 40, 09
		oBt6:cToolTip := 'Imprimir la lista actual'
//ImprimeBmp esta en wocfosp3.prg
*/

/*                ACTION PrnAngio( aCampoNom, aValores )           ; */
/*                MESSAGE 'Imprimir IMAGEN final y lista actual'; */

      @ 16.4*nXtR,  22*nXtC BUTTON obt6 PROMPT "Im&primir"    OF oDlg          ;
         ACTION imprimirBmp( aValores[ nItem, 10 ], oBmpW ) ;
		MESSAGE 'Imprimir IMAGEN final y lista actual';
		SIZE 40, 09     
		oBt6:cToolTip := 'Imprimir la IMAGEN final y lista actual'
/*ACTION PrnArgon( aCampoNom )           ;*/

      @ 16.4*nXtR,  29*nXtC BUTTON oBt7 PROMPT "In&forme"    OF oDlg      ;
                      ACTION CreaAscMh1( 31, 'Lser de Retina', Date, ;
                mNombre, mHistoria, oWnd,, ColorDlg, ColorTxt, mUltimo ) ;
		MESSAGE 'Crea un fichero de TEXTO en disco';
		SIZE 40, 09
		oBt7:cToolTip := 'Crea un fichero de TEXTO en disco'

   @ 16.4*nXtR, 36*nXtC BUTTON obt8 PROMPT "&Salir"    OF oDlg ;
		MESSAGE 'Salir de la lista a la ventana de exploracion en uso';
		SIZE 40, 09 ;
		ACTION  oDlg:End() 
		oBt8:cToolTip := 'Salir de la ventana actual..'

   oDlg:bRClicked := { | nRow, nCol, nFlags | ( if( !empty( mHistoria ), ;
		VerHist( mHistoria, mNombre ), ) ) }
   oDlg:bLClicked := ;
	{ | nRow, nCol, nFlags | ( if( !empty( mNombre ), VerClient(), ) ) }
   oDlg:cToolTip := cInfo

   ACTIVATE DIALOG oDlg CENTERED ON INIT ( ;
        iif( !Empty( cFLogo ) .and. File( cFLogo ), ;
            oBmpW:Load( cFLogo ), Nil ), SysRefresh(), oBrw:SetFocus() )
/*
if !Empty( oBmpVer )
	oBmpVer:End()
endif
*/		// El area actual es paciente.dbf, se restituye  el
		// orden de indice abierto normalmente, el uno

   if !( lUsImg )       // Recuperar imagenes de la carpeta temporal
                                                            
       aEval( aLis, { | c, n | ;
        aD := Directory( cTarget + '\' + aLis[ n ] ), ;
       iif( File( cTarget + '\' + aLis[ n ] ) .and. aD[ 1, 2 ] > 0, ;
       ( LZCopyFile( cTarget + '\' + aLis[ n ], aLis[ n ] ), ;
               Ferase( cTarget + '\' + aLis[ n ] ) ), Nil ) } ) 
   endif


   // Eliminar los .BMP del directorio actual, si eran temporales ..
   if aValores[ 1, 9 ] > 0	// Si hay registros del paciente
//	MsgInfo( 'Se van a Salvar ficheros' )
      aEval( aValores, { | cEl, nEl | ;
        aD := Directory( cFileName( aValores [ nEl, 10 ] ) ), ;
                Eval( bDisc ), ;
	      iif( Upper( cCurDrive + ':' + ;
		'\' + CurDir() + '\' + ;
			alltrim( cFileName( aValores[ nEl, 10 ] ) ) ) != ;
	Upper( cDisc + ':' + cFilePath( aValores[ nEl, 13 ] ) + ;
			alltrim( cFileName( aValores[ nEl, 10 ] ) ) ), ;
	( ( cBase )->( DbGoto( aValores[ nEl, 9 ] ) ), ;
                    iif( aD[ 1, 2 ] > 0, ( Salva( { ;
				aValores[ nEl, 01 ],  ;
				aValores[ nEl, 12 ],  ;
				aValores[ nEl, 11 ],  ;
				aValores[ nEl, 13 ],  ;
				aValores[ nEl, 10 ],  ;
				aValores[ nEl, 08 ],  ;
				aValores[ nEl, 09 ]  ;
				}, 1 ), ;
              Ferase( cFilename( aValores[ nEl, 10 ] ) ) ), Nil ) ), ) } )
	// Si el directorio actual != no es el establecido para archivar
	// se copia cada .Bmp al directorio de guardar, y se borra del actual
	// Situarse en registro por si al salvar se cambia numero de disco
	// y hay q archivar el nuevo desde salva()
	// Salva() = funcion en wocfun.prg
   endif
   oFont:End()
   oWnd:Refresh()
   oWnd:oCursor(CursorArrow()) 

return( .t. )
//------------

// llamado asi = WGrafRefr( '', 'Opt*.Bmp', oWnd )
// function WGrafRefr( cFileBmp, cTit, oWnd, oSay )
// Comun con Wocfosp1.prg y Refraccion optotipos
//******************************************************
 function WGraf1( cFileBmp, cTit, oWnd, oSay, lAj, oBm, lBusca, lFoto, oMru3 )
//******************************************************
local oWnGraf, oIco, nFila := 20, nCol := 60, lMax := .f.
LOCAL hDib, oFont, oCoors, oBar, oB1, oB2, oB3, oB4, oB5, oB6, oB7, oB8, ;
                oB9, oB10, oB11, oB12, oBot11, oMn, oHand, oMru1
Local oBmpVer, nRazon := 4, nLen := 1, nI := 1, obu1, obu2, obu3, obu4
local nMaxHorz := 300, nMaxVert := 150, nMaxColr := 16, oBot14, oBot15
LOCAL hDC := GetDC(), WnAncho, WnAlto, hBmp, bResiZe, oP1, oP2, oP3, oP4, oP5
local bPrn, bAjust, bMover, bTitulo, bGFile, nWi, nHe, lResiZe := .t.
local cMemo := '', cMasc, cPath, cFileExe, oRow, oCol, ;
                                lArray := ValType( cFileBmp ) == "A"
Local aFiles, aLista := {}

// Desde Wocfosp1 y 3 = cFileBmp es un solo ficher
// Desde Optotipos, menu de wocul3 = es un directorio de optotipos
// La llamada con cfilebmp = Nil y cTit = Nil, = directorio *.bmp
// Llamada nueva 2008 = cFileBmp = Array a ver, cTit := ""  lo q sea
// dando lArray := .t.

//DEFAULT oWnd   := GetWndDefault() // No funciona

// Funciona, llama la ventana principal de Fivewin abierta
DEFAULT oWnd   := GetWndApp()
DEFAULT cTit   := cFileBmp
DEFAULT lAj    := .f.
DEFAULT lBusca := .f.
DEFAULT lFoto  := .f.
//? GetWndDefault()
//? GetWndApp()
cMasc := iif( Empty( cTit ), '*.Bmp', cTit )     //' *.Woc'
cPath := cFilePath( cTit )
// Para que hay un file inicial

oBmpW := oBm
lAjustar := lAj

if !( lArray )
if (lBusca)
   cFileBmp := GetImag2() // oBmpVer )
endif

if !( lFoto )
        nI := 1
        aFiles := Directory( cMasc, "D")

        if Empty( aFiles ) .and. !( lBusca )
                MsgStop( 'Ficheros: ' + cMasc + CRLF + ;
		'No encontrados ..', 'Aviso !.' )
          //      Return( nil )
        endif
        Aeval( aFiles, { | Fichero | ;
                    aadd( aLista, cPath + cFileNoPath( Fichero[ 1 ] ) ) } )
        aLista := ASort( aLista )
        nLen   := Len( aLista )
        if nLen > 0
                // NO poner valor NUMERICO, sino la variable nI
                // si no: funcionar mal
                cFileBmp := aLista[ nI ]        // 1
        else
                cFileBmp := ''
        endif
else
      if ValType( cFileBmp ) == "A"
        aLista := cFileBmp      
      else
        aadd( aLista, cFileBmp )
      endif
      
        nLen   := Len( aLista )

endif

Else    // si no es Array
   
     aLista := cFileBmp
   
     if Len( aLista ) > 0
        cFileBmp := aLista[ 1 ]    
     else
                cFileBmp := ''
     endif
        nLen   := Len( aLista )

Endif // de si es lArray o NO 

if  File( cFileBmp )
 
else
        cFileBmp := GetImag2()  // oBmpVer )
     if Empty( cFileBmp ) .or. !File( cFileBmp ) .or. cFileBmp == '*.*'
        MsgStop( 'Archivo: ' + AllTrim( cValToChar( cFileBmp ) ) + CRLF + ;
                'No puede ser cargado ..!', 'Aviso !.' )
        return .f.
     endif
endif

if File( cFileBmp )
        // Se carga en el MRU..
       // oMru1:Save( cFileBmp )
	hDib := DibRead( cFileBmp )
//        nCol  := DibWidth( hDib ) 
//        nFila := DibHeight( hDib )
        nCol  := Max( nCol, DibWidth( hDib ) )
        nFila := Max( nFila, DibHeight( hDib ) )
        nCol  := nCol / ( oWnd:nHorzRes() / ( MaxCol() + 1 ) ) //+ 8  //13     //5     //0.4
        nFila := nFila / ( oWnd:nVertRes() / ( MaxRow() + 1 ) ) //+ 5 // 7     //5     //1

	nCol  := iif( nCol  > MaxCol()-10, MaxCol(), nCol  )
	nFila := iif( nFila > MaxRow()-10, MaxRow(), nFila )
	// Se adapta mejor asi en los grandes

        nCol  := iif( nCol  < 10, MaxCol()/2, nCol  )
        nFila := iif( nFila < 10, MaxRow()/2, nFila )
        // Se adapta mejor asi en las imagenes NO BMPs

        // Nueva prueba
        nCol := nCol*1.7
        nFila:= nFila*1.6
endif
if !Empty( oBmpVer )
	oBmpVer:End()
endif

if nCol > ( MaxCol()-5 ) .or. ; 	//DibWidth( hDib ) > 470       //450
	    nFila > ( MaxRow() - 5 )	//DibHeight( hDib ) > 220      //200
	lMax := .t.
	nCol := MaxCol() 
	nFila := MaxRow() 
endif
nCol := Max( nCol, 39 )	// Garantizando la barra de botones ..
nRazon := iif( lMax, 2, nRazon )
nMaxHorz := GetDeviceCaps( hDC, HORZRES )
nMaxVert := GetDeviceCaps( hDC, VERTRES )
nMaxColr := GetDeviceCaps( hDC, PLANES  )

cTit := OemToAnsi( 'Resolucin: ' ) + ;
	alltrim( str( nMaxHorz ) ) + 'x' + ;
	alltrim( str( nMaxVert ) ) + ;
		" - Mostrando: " 

   MENU oMn
//oMn:AddFile()
//oMn:AddEdit()
//oMn:AddMdi()
//oMn:AddHelp()
      MENUITEM '&Archivo'
        MENU
           MENUITEM '&Abrir'     ACTION Eval( oBot11:bAction )
           MENUITEM '&Recientes'
      		   MENU
          	   MENUITEM '&Borrar Lista de recientes !' ;
            			ACTION iif( MsgNoYes( 'Seguro de BORRAR Lista?..', 'Elija una opcin.' ), ;
                                oMru1:Clear(), Nil )
           		 MRU oMru1 ;
              		FILENAME ".\WocMru2.ini" ;     // .INI to manipulate. '\.' for local
              		SECTION  "MRU-Imagenes" ;      // The name of the INI section
              		ACTION ;  //  MsgInfo( cMruItem )  // cMruItem is automatically provided
              		( cFileBmp := cMruItem, ;
         								oBmpVer:LoadBmp( cFileBmp ), oWnGraf:SetText( cTit + cFileBmp ), ;
                        oBmpVer:Refresh(), oWnGraf:Refresh(),;
                        oMru1:Save( cFileBmp ) ;
                         ) ;
            			MESSAGE  OemToAnsi( "Imgenes ..." ) ; // The message for all of them
            			SIZE 20                    // The number of MRU items to manage
         	   ENDMENU
 
           MENUITEM '&Guardar como ..' ACTION Eval( oB5:bAction )
           MENUITEM '&Editar'    ACTION Eval( oB11:bAction )
           MENUITEM '&Imprimir'  ACTION Eval( oB4:bAction )
           MENUITEM '&Salir'     ACTION Eval( oB6:bAction )

         ENDMENU

      MENUITEM '&Zoom'
        MENU
              MENUITEM 'A&justar S/N' ACTION Eval( oB3:bAction )
              MENUITEM '&Mas ..'   ACTION Eval( oBot14:bAction )
              MENUITEM 'Me&nos ..'   ACTION Eval( oBot15:bAction )
        ENDMENU
    
      MENUITEM '&Pagina'
        MENU
        
                MENUITEM oBu1 PROMPT '&Inicio'       ACTION Eval( oB7:bAction );
                       WHEN nLen > 1
                MENUITEM oBu2 PROMPT '&Final'        ACTION Eval( oB10:bAction );
                       WHEN nLen > 1
                MENUITEM oBu3 PROMPT '&Previa'       ACTION Eval( oB8:bAction );
                       WHEN nLen > 1
                MENUITEM oBu4 PROMPT '&Siguiente'    ACTION Eval( oB9:bAction );
                       WHEN nLen > 1
       ENDMENU
  
   ENDMENU

if File( cFileBmp )
        // Se carga en el MRU..
         oMru1:Save( cFileBmp )
endif

bMover := { || ;
 CursorWait(), cFileBmp := aLista[ nI ], oBmpVer:LoadBmp( aLista[ nI ] ), ;
oWnGraf:SetText( cTit + aLista[ nI ] ), oBmpVer:Refresh(), ;
        oMru1:Save( cFileBmp ), oMru1:Save( cFileBmp ), CursorArrow() }

bPrn := { || ImprimirBmp( cFileBmp, oBmpVer) }

bAjust := { || iif( !( lAjustar ), ;
	( oWnGraf:Maximize(), AjustaZoom( oBmpVer ,"s" ), ;
		AjustaZoom( oBmpW, "s", oSay ), lAjustar := .t. ),  ;
	( oWnGraf:ReSize( 3, WnAncho, WnAlto ), AjustaZoom( oBmpVer, "1" ), ;
  AjustaZoom( oBmpW, "1", oSay ), oWnGraf:Refresh(), lAjustar := .f. ) ) }
// Se cierra si estaba abierta, para q no se abran varias cada vez
   SendMessage( FindWindow( 0, ;
       cTit + cFileNoPath( cFileBmp ) ), WM_CLOSE )

   IF ( '.BMP' ) $ ( Upper( cFileBmp ) )
      DEFINE BITMAP oBmpVer FILE cFileBmp //PIXEL
   ELSE
      DEFINE IMAGE oBmpVer FILE cFileBmp //PIXEL
   ENDIF
       nWi := oBmpVer:nWidth ; nHe := oBmpVer:nHeight
       oBmpVer:Destroy()
      
   nCol  := nWi / ( oWnd:nHorzRes() / ( MaxCol() + 1 ) )
   nFila := nHe / ( oWnd:nVertRes() / ( MaxRow() + 1 ) ) 
     DEFINE ICON oIco FILE "WOCUL3.ico"
     DEFINE CURSOR oHand HAND

   bReSize := {|| lResize := .t., ;
                oBmpVer:SetSize( oWnGraf:nWidth() - 15*oWnGraf:nHorzRes()/800,;
       oWnGraf:nHeight() - 50*oWnGraf:nVertRes()/600 ),;
                lResize := .t.,;
                SysRefresh() }

   DEFINE WINDOW oWnGraf  FROM 0, 0 TO nFila*2.5, nCol*1.75  NOMINIMIZE  ;
   TITLE cTit + ( cFileBmp )  ICON oIco 
 
   WnAncho := oWnGraf:nHorzRes()
   WnAlto  := oWnGraf:nVertRes()
   oWnGraf:SetMenu( oMn )
 
      DEFINE FONT oFont NAME "Arial" SIZE 4, 12	//5, 13

      @ 29, 1 SAY oCoors PROMPT "   0,   0" SIZE 60, 13 ;
        PIXEL OF oWnGraf FONT oFont CENTERED BORDER COLOR CLR_BLACK, CLR_WHITE

   DEFINE BUTTONBAR oBar SIZE 33, 33 _3D OF oWnGraf ;
   CURSOR oHand    
  // BUTTONSIZE 55, 50 
        oBar:l2007 := .t.
/*
   oBar:bClrGrad = { | lInvert | If( ! lInvert,;
                                     { { 0.50, nRGB( 178, 187, 202 ), nRGB( 137, 155, 179 ) },;
                                       { 0.50, nRGB( 129, 149, 174 ), nRGB( 114, 132, 156 ) } },;
                                     { { 0.50, nRGB( 139, 166, 193 ), nRGB(  69, 119, 170 ) },;
                                       { 0.50, nRGB(  52, 104, 152 ), nRGB(  50, 107, 162 ) } } ) }
   oBar:nClrText = nRGB( 255, 255, 255 )
        
        oBar:cToolTip := { 'Click Dcho: Mover botones ..', 'Barra',,;
                               CLR_BLUE, nRGB( 220, 230, 247 ) }
*/
 
       DEFINE BUTTON oB7 OF oBar FILE ".\bitmaps\TOP.BMP" NOBORDER ;
       WHEN nLen > 1
        oB7:bAction := {|| ( iif( nI == 1, MsgBeep(), ;
              ( nI := 1, Eval( bMover ) ) ) ) }
	oB7:cToolTip := 'Ir al primero'           

       DEFINE BUTTON oB8 OF oBar FILE ".\bitmaps\PREV.BMP" NOBORDER ;
       WHEN nLen > 1
        oB8:bAction := {|| ( Iif( nI == 1, ;
        ( MsgBeep(), nI := nLen ), nI -- ), Eval( bMover ) )}
	oB8:cToolTip := 'Ir al anterior'          

       DEFINE BUTTON oB9 OF oBar FILE ".\bitmaps\NEXT.BMP" NOBORDER  ;
       WHEN nLen > 1
        oB9:bAction := {|| ( Iif( nI == nLen, ;
            ( MsgBeep(), nI := 1 ), nI++ ), Eval( bMover ) )}
	oB9:cToolTip := 'Ir al siguiente'        

       DEFINE BUTTON oB10 OF oBar FILE ".\bitmaps\BOTTOM.BMP" NOBORDER ; 
       WHEN nLen > 1
        oB10:bAction := {||  ( iif( nI == nLen, MsgBeep(), ;
               ( nI := nLen, Eval( bMover ) ) ) )}
	oB10:cToolTip := 'Ir al ultimo'        

       DEFINE BUTTON oB3 OF oBar FILE ".\bitmaps\WZoomOut.BMP"  NOBORDER GROUP
        oB3:bAction := {|| (  Eval( bAjust ) , ;
                                oWnGraf:SetText( cTit + aLista[ nI ] ), ;
                                oBmpVer:Refresh(), CursorArrow() )}
        oB3:cToolTip := 'Maximizar, y recuperar..'
         
       DEFINE BUTTON oBot14  OF oBar FILE ".\bitmaps\PLUS.BMP"  NOBORDER
       oBot14:bAction := ;
                {|| ( AjustaZoom( oBmpVer ,"A" ), oWnGraf:Refresh() ) }
      oBot14:cToolTip := '+ Zoom 10 %'

       DEFINE BUTTON oBot15  OF oBar FILE ".\bitmaps\MINUS.BMP"  NOBORDER
       oBot15:bAction := ;
                {|| ( AjustaZoom( oBmpVer ,"R" ), oWnGraf:Refresh() ) }
      oBot15:cToolTip := '-- Zoom 10 %'
          
   MENU oP3 POPUP
      MENUITEM oBot11 PROMPT "Actual Lista de archivos"
      oBot11:bAction := ;
      {||iif( nLen > 0 .and. ( nI := MsgList( aLista ) ) > 0,;
       ( cFileBmp := aLista[ nI ], ;
       oBmpVer:LoadBmp( cFileBmp ), oBmpVer:Refresh(), ;
       oWnGraf:SetText( cTit + cFileBmp ), ;
       oWnGraf:Refresh(), oMru1:Save( cFileBmp ) ), MsgInfo( 'NO Lista !.', 'Informacin.' );
        ) }

      MENUITEM oP5 PROMPT "Buscar en Arbol de Directorios"
      oP5:bAction := {||;
       cFileBmp := GetImag2(), iif( !Empty( cFileBmp ), ( ;
       oBmpVer:LoadBmp( cFileBmp ), oBmpVer:Refresh(), ;
       oWnGraf:SetText( cTit + cFileBmp ), ;
       oWnGraf:Refresh(), oMru1:Save( cFileBmp ) ), ;
                                MsgInfo( 'NO Elegido !.', 'Informacin.' ) ) }

      MENUITEM "Paste desde Portapapeles" ACTION ;
      ( oBmpVer:LoadFromClipboard(), oBmpVer:Refresh() )

   ENDMENU

       DEFINE BUTTON op4 OF oBar FILE ".\bitmaps\TBROWSE.BMP"  NOBORDER ;
                GROUP ACTION oP4:ShowPopup() MENU oP3

        oP4:cToolTip := {'- Actual Lista de Archivos ' + CRLF + ;
                            '- Buscar Archivo..' + CRLF + ;
                            '- Desde Portapapeles', 'Ver:' }

   MENU oP1 POPUP
      MENUITEM "Al PortaPapeles" ;
      ACTION oBmpver:CopyToClipboard()

      MENUITEM oB11 PROMPT "A PAINT de Windows"
        oB11:bAction := {|| CargarDibujo( cFileBmp ) }

      MENUITEM oB5 PROMPT  "Copiar en otro Destino"
        oB5:bAction := {|| Copiar( cFileBmp, '', .f. ) }
   ENDMENU

   DEFINE BUTTON oP2 OF oBar FILE ".\bitmaps\WBCopy.bmp" ;
        ACTION oP2:ShowPopup() MENU oP1 ;
                TOOLTIP  {'Portapapeles, MS-Paint, Como..', 'Copiar a:' }
                                                                
       DEFINE BUTTON oB4 OF oBar FILE ".\bitmaps\BPrnRece.bmp" NOBORDER 
        oB4:bAction := {|| Eval( bPrn ) }
	oB4:cToolTip := 'Imprimir ..'

       DEFINE BUTTON oB6 OF oBar FILE ".\bitmaps\WExit3.bmp" NOBORDER GROUP
        oB6:bAction := {|| oWnGraf:End() }
	oB6:cToolTip := 'Salir ..'
                               // -6 Y -60
       DEFINE BUTTON oB1 OF oBar ;
                FILE ".\bitmaps\WHELP2.BMP" NOBORDER ACTION ;       
            IIF( FILE( "WOCAYUDA.EXE" ), WAITRUN( "WOCAYUDA 29" ),;
                FWHelp( 'Graficos.Wlp' ) )   //Memoedi2( cMemo ,,,,, 'Ayuda ..' )
		oB1:cToolTip := 'Ayuda ...'

     AEval( oBar:aControls, { | o | o:oCursor := oHand } )

   @ 35, 10  IMAGE oBmpVer ;     //FILE cFileBmp  PIXEL 
       PIXEL SIZE nWi, nHe ; //Min( nWi, ( nMaxHorz-( nMaxHorz/80*0.6) ) ), 
                          ; // Min( nHe, ( nMaxVert-( nMaxVert/30*5 ) ) ) 
                   SCROLL OF oWnGraf   ;
		ON LEFT  CLICK ( Eval( bAjust ) ) ;
		ON RIGHT CLICK ( Eval( bPrn ) )

      oBmpVer:Progress( .f. )

//      oWnGraf:SetControl( oBmpVer )

        // Corrige la llamada de optotipos .. para bloque bAjust
	oBmpW := iif( Empty( oBmpW ), oBmpVer, oBmpW )

   oBmpVer:cToolTip := 'Click Izq. = Ajustar Imagen - ' + CRLF +;
			'Click Dcho = Imprimir Imagen '

      oBmpVer:bMMoved = { | nRow, nCol | ;
                         oCoors:SetText( Transform( nRow, "99999" ) + " - " + ;
                                         Transform( nCol, "99999" ) ) }
   oWnGraf:bKeyChar = { | nKey, nFlags | ;
                   iif( nKey == K_ESC, oWnGraf:End(), MsgBeep() ) } 
                                                                   
   ACTIVATE WINDOW oWnGraf ON INIT ( oBmpVer:Progress( .f. ), ;
   iif( lAjustar, ;
 ( oWnGraf:Maximize(), AjustaZoom( oBmpVer, "s", oSay ) ), Nil ),;
   iif( !Empty( cFileBmp ) .and. File( cFileBmp ), ;
            ( oBmpVer:LoadBmp( cFileBmp ), oWnGraf:nWidth := oBmpVer:nWidth + 10 + 40*oWnGraf:nHorzRes()/1280,;
                                           oWnGraf:nHeight:= oBmpVer:nHeight + 35 + 65*oWnGraf:nVertRes()/800 ), Nil ),;
                SysRefresh(), oWnGraf:SetFocus() ) ;
                ON RESIZE Eval( bResize )

return iif( oMru3 == Nil, lAjustar, cFileBmp )
//--------------
//----------------------------------------------------------------------------//


function GetImag2( lVid, lRecall, cMask, cDir )

local lG32 := ( File( GetWinDir() + "\RunDlg32.exe" ) .OR.  File( GetSysDir() + "\RunDlg32.exe" ) )
local gcfile := "", cMsg := "" , nI := 1, cLista := "" , cCurDrive := HB_CurDrive()
local cPlt := "Bitmap (*.bmp)| *.bmp|" +          "DIB   (*.dib)| *.dib|" +           "PCX   (*.pcx)| *.pcx|"  + ;
         "JPEG  (*.jpg)| *.jpg|" +           "GIF   (*.gif)| *.gif|"  +          "TARGA (*.tga)| *.tga|" +      ;
              "RLE   (*.rle)| *.rle|" +           "Todos (*.*)| *.*"
local cVid := "W. Media (*.avi)| *.avi|" +          "W. Media (*.mpg)| *.mpg|" +           "W. Media (*.wmv)| *.wmv|"  +   ;
       "W. Media (*.mov)| *.mov|" +           "Flv Player (*.flv)| *.flv|"  +          "Divx Player (*.divx)| *.divx|" +           "Todos (*.*)| *.*"

If( lVid == nil, lVid := .F., ) ; If( lRecall == nil, lRecall := .F., ); If( cMask == nil, cMask := "", ); If( cDir == nil, cDir := cCurDrive, )

cMask := "Paciente sta expl. (" + cMask + ")|" + cMask + "|" +  "Todos sta expl. (*.*)| *.*"

nI := iif( lVid, 7, 8 )  ; nI := iif( lRecall, 1, nI )
cLista := iif( lVid, cVid, cPlt )   ; cLista := iif( lRecall, cMasK, cLista )
cMsg := "Elija un fichero de " + iif( lVid, "video", "imagen" ) + ", por favor"

cPlt := iif( lVid, cVid, cPlt )

      gcFile   := iif( lG32, cGetFile32( cLista, cMsg, nI, cDir ), cGetFile( cLista, cMsg, nI, cDir, , .T. ) )
      if !(lVid)
              cFileBmp := iif( !Empty( gcFile ) .AND. File( gcFile ), gcFile, cFileBmp )
      endif

return iif( !(lVid), cFileBmp, gcFile )
 
//----------------------------------------------------------------------------//

//***************************************************
static function DelArgon( oLbx, nRec, aFecha, cFile )
//***************************************************
//

if nRec < 2	// No borables, valores por omision y contador
	MsgStop( 'Registro: ' + AllTrim( str( nRec ) ) + CRLF + ;
		'Es reservado para uso ' + CRLF + 'interno del programa !..', 'Aviso !.' )
else
   if MsgYesNo( OemToAnsi( "Atencin:" ) + CRLF + ;
		OemToAnsi( " Est seguro de " + ;
		"querer borrar este registro?" ) + CRLF + CRLF + ;
		"REGISTRO:     " + aFecha, 'Elija una opcin.' )

      if File( cFile ) .and. MsgYesNo( OemToAnsi( "Atencin:" ) + CRLF + ;
			"Borrar tambien el Dibujo: " + cFile + "?", 'Elija una opcin.' )
	if File( cFile )
            Ferase( cFile )
//        else
//	    MsgInfo( "Fichero: " + cFile + CRLF + ;
//			"No se encuentra .." )
	endif

      endif

      ("Argon")->( DbCloseArea() )
      usa_base( "Argon", .t., "Argon", 5, .T. )

      DbGoto( nRec )
      DbDelete()
      HB_DBPACK()  // PACK

      ("Argon")->( DbCloseArea() )
      usa_base( "Argon", .F., "Argon", 5, .T. )

   endif

endif

return Nil	//aValores
//---------

//***************************************
static function EditGraf( lAppend, aLis, lReNom, cTarget, lSave )
//***************************************
local lValor := .t., cNumero := '00000000', cFileExe
local cFilePlt := ' ', letra := 'A'	//iif( nExpl == 1, 'P', 'F' )
local hDib, nRec := aLis[ 9 ]
local cDisco, cUnidad   //, cExt := '.WOC'   //'.BMP'
local cMaskIni := iif( aLis[9] > 0, ;
	"Completar ( " + AllTrim(aLis[10]) + " ) |" + aLis[10] + "|", '' )
local cExt := PADL( AllTrim( str( Lis_red->( RecNo() ), 3 ) ), 3, "0" )
local lUsImg := .t.     //iif( IsWinNT(), .f., .t. )
local cOldNum := '', cFile := ''
local lG32 := ( File( GetWinDir() + "\RunDlg32.exe" ) .or. ;
                        File( GetSysDir() + "\RunDlg32.exe" ) )
Local cPath := '.\', nIF := 1

DEFAULT lRenom := .f., lSave := .f.

cPath := iif( Empty( cFilePath( cFile ) ), cPath, cFilePath( cFile ) )
nIf := iif( nGetFileFilter() > 0, nGetFileFilter(), nIf )

        cFile := 'SELED.' + cExt

nRecNo := 1

// MUY IMPORTANTE !!!!!!!!!!
// queda poner el path de las plantillas q debe ser el actual
// y al buscar uno ya existente primero q mire el actual, antes q el path
// por si se ha importado, y avisar por si no es el mismo poder decidir 
// el del path de ese registro ..
// y lo mismo al archivarlos ..

do while lValor

if lAppend
	// Crear grafico a partir de plantillas *.Bma
  if lG32
     cFilePlt := cGetFile32(  cMaskIni + ;
	"Plantillas ( *.Bmr ) | *.Bmr |" + ;
	"Dibujos archivados ( " + letra + "*.Bmp ) | " + letra + "*.Bmp |" + ;
        "Archivos ( *.Bm? ) | *.Bm? |" + ;
                             "DIB   (*.dib)| *.dib|" +          ;
                             "PCX   (*.pcx)| *.pcx|"  +         ;
                             "JPEG  (*.jpg)| *.jpg|" +          ;
                             "GIF   (*.gif)| *.gif|"  +         ;
                             "TARGA (*.tga)| *.tga|" +          ;
                             "RLE   (*.rle)| *.rle|" +          ;
		"Todos ( *.* ) | *.* " , ;
        "Por favor, elija..", nIF, cPath, lSave, , cFilePlt )

  else
     cFilePlt := cGetFile(  cMaskIni + ;
	"Plantillas ( *.Bmr ) | *.Bmr |" + ;
	"Dibujos archivados ( " + letra + "*.Bmp ) | " + letra + "*.Bmp |" + ;
        "Archivos ( *.Bm? ) | *.Bm? |" + ;
                             "DIB   (*.dib)| *.dib|" +          ;
                             "PCX   (*.pcx)| *.pcx|"  +         ;
                             "JPEG  (*.jpg)| *.jpg|" +          ;
                             "GIF   (*.gif)| *.gif|"  +         ;
                             "TARGA (*.tga)| *.tga|" +          ;
                             "RLE   (*.rle)| *.rle|" +          ;
		"Todos ( *.* ) | *.* " , ;
        "Por favor, elija..", nIF, cPath, lSave, .t. )

  endif
 
else
	// Ver el grafico, si esta presente.. 
	//cFilePlt := aLis[ 5 ]
	( cBase )->( DbGoto( aLis[ 9 ] ) )
	cFilePlt := ( cBase )->NomImagen    //+ '.BMP'
endif

if ( Empty( cFilePlt ) .or. !File( cFilePlt ) ) 
	lValor := MsgYesNo( 'PLANTILLA: ' + cFilePlt + CRLF + ;
			'NO PUDO SER CREADO ..' + CRLF + ;
			'Buscar en otra UNIDAD / DIRECTORIO?..', 'Elija una opcin.' )
			// Si no se ha salido de la lista sin elegir 
			// o el campo de la base no estaba vacio ..
else
      //  if !Empty( hDib := DibRead( cFilePlt ) ) .and. ;
        //                                DibWrite( cFileBmp, hDib )
        LZCopyFile( cFilePlt, cFileBmp )
        if File( cFileBmp )
        	// Se ha copiado la plantilla en el disco para usarlo  ..

                lValor := CargarDibujo( cFileBmp )
/*                WAITRUN( cFileExe + " " + cFileBmp, 3 )
                SendMessage( FindWindow( 0, cFileExe ), WM_CLOSE )
		lValor := .t.
*/
		exit     // Final con exito
	else
		MsgBeep()
		lValor :=  MsgYesNo( 'DIBUJO: ' + cFileBmp + CRLF + ;
				'NO PUDO SER CARGADO ..' + CRLF + ;
				'REINTENTAR? ..', 'Elija una opcin.' )
	endif
	
endif

enddo

if lValor       // Si no hubo fallos de creacion lValor == .t.
	if lAppend
                // Aadir registro nuevo y dar nombre al nuevo .bmp

		// Manipulacion del contador de bmps de polo a o fondo..
		( cBase )->( DbGoto( 1 ) )      // Reg. del contador
		cNumero := ( cBase )->NomImagen
		cNumero := val( alltrim( cNumero ) )
		cDisco  := ( cBase )->Disco
		cUnidad := ( cBase )->Unidad
		Bloq_reg( 5 )   // Se actualiza el contador ..
         ( cBase )->NomImagen := Padl( alltrim( str( cNumero + 1 ) ), 7, '0' )
		Desbloq()

             /*   cNumero := letra + ;
                        Padl( alltrim( str( cNumero + 1 ) ), 7, '0' ) + ;
                                '.' + cFileExt( cFilePlt )      //cExt //'.BMP'
		// El fichero bmp definitivo a archivar ..
            */

                cNumero := letra + ;
                        Padl( alltrim( str( cNumero + 1 ) ), 7, '0' ) + ;
       '.' + iif( Upper( cFileExt( cFilePlt ) ) == 'BMR', 'BMP', ;
                         cFileExt( cFilePlt ) )    //cExt //'.BMP'



		If MsgYesNo( cNumero + CRLF + 'Archivar el dibujo?', 'Elija una opcin.' )
			appe_reg( 5 )   // Si lAppend == .t. es aadir nuevo reg.
		else
			lValor := .f.	// p q no se archiven datos ni dibujo
		endif

	else
		cNumero := cFilePlt
		Bloq_reg( 5 )   // Si lAppend es == .f. es editar existente ..

	endif

	nRecNo := Recno()       // Estatica // El actual registro..
            if lValor
                LZCopyFile( cFileBmp, cNumero )
//                if !Empty( hDib := DibRead( cFileBmp ) ) .and. ;
  //                      lValor .and. DibWrite( cNumero, hDib )
                if File( cNumero )
                // Se salva el dibujo en el disco para guardarlo  ..
		// y se le da el nuevo nombre = cNumero
		else
			lValor := .f.	// p q no se archiven los datos
			MsgInfo( cNumero + CRLF + ;
				'NO pudo ser CREADO..', 'Informacin.' )
		endif
            endif
           if recno() > 1 .and. lAppend .and. lValor
		// Si es nuevo .., se creo, se eligio salvar, y se salvo
		// se archivan los datos
                   // y se pasa a la carpeta de marras
                  if ! lUsImg .and. !Empty( cTarget )
                       LZCopyFile( cNumero, cTarget + '\' + cNumero )
                  endif
		FieldPut( 1, mHistoria )
		FieldPut( 2, Date )
		FieldPut( 10, cNumero   )    
		FieldPut( 11, cUnidad   )    
		FieldPut( 12, cDisco    )    
		FieldPut( 13, cViaArchivo )      //CURDIR( "C:" ) )

	   endif

	desbloq()               // Se libera el bloqueo

	if lValor	// Si todo fue verdadero = archivar datos
                EditSpec( Nil, lAppend, aLis, , nRecNo )
	endif

	( cBase )->( DbGoto( nRecNo ) )

endif

return lValor
//------------

//***************************************************************
       function EditSpec( oLbx, lAppend, aLis, oDlg, nRec )
//***************************************************************
   local lSave := .f., cTecn := '...', oGet10, oGet2, oBmp, ;
	oG1, oG2, oG3, oG4, oG5, oG6, oG7, oG8, oG9, oG10, oG11, oG12, oG13, cCurDrive := HB_CurDrive()
   local oDlgE, i, nCopRec := RecNo(), aEdit, aSav, aVal
   local cDirDef := cCurDrive + ':\' + CurDir()
   local cPath := '\' + CurDir() + '\'
//   local cFileOrigen := cPath, cFileDestino := cPath
   local cPathTip := cPath + cBase + '\', CtX, bValidGet, lValid := .f.
   local cDisc, lDisc, bDisc
   local cViaIni, cViaUso, Var01, Var02, Var03, Var04, Var05, Var06, ;
	Var07, Var08, Var09, Var10, Var11, Var12, Var13, Var14, Var15

   if nRec == 0
	return .f.
   endif

bDisc := { || ;
cDisc := AllTrim( Var11 ),;
cDisc := iif( Empty( cDisc ), cCurDrive, cDisc ),;
cDisc := iif( Len( cDisc ) > 1, Left( cDisc, 1 ), cDisc ),;
cDisc := iif( Upper( cDisc ) $ 'ABCDEFGHIJKLMNOPQRSTUVXYZ', ;
		Upper( cDisc ), cCurDrive ), ;
		Var11 := cDisc, oG11:Refresh(), .t. }

   ( cBase )->( DbGoto( iif( nRec == 1, nRec, ;
				iif( aLis[ 9 ] == 0, 1, aLis[9] ) ) ) )
					          // Valores por defecto ..

	cTecn := 'Esquema de Retina - ( PaintBrush )'

	aEdit := {}
	      Var01:=( Argon->Fecha ) 
	      Var02:=OemToAnsi( Argon->Laser ) 
	      Var03:=OemToAnsi( Argon->Ojo ) 
	      Var04:=val(OemToAnsi( str( (Argon->Disparos), 4 ) )) 
	      Var05:=val( OemToAnsi( str( (Argon->Diametro), 4 ) ))
	      Var06:=val( OemToAnsi( str( (Argon->Segundos), 4, 2 ) ))
	      Var07:=val( OemToAnsi( str( (Argon->Intensidad), 4 ) ) )
	      Var08:=OemToAnsi( Argon->Descripcio ) 

	if lAppend
		( cBase )->( DbGoto( nRec ) )	// Datos imagen
		Var01 := Argon->Fecha
	endif
		
	    Var09 := Recno()
	Var01 := iif( ( lAppend ), Date, Var01 )
	Var01 := CTOD(OemToAnsi( DTOC( Var01 ) ) )
	// Se corrige la fecha a hoy si es aadiendo nuevo ..

	       Var10:=OemToAnsi( Argon->NomImagen ) 
	       Var11:=OemToAnsi( Argon->Unidad ) 
	       Var12:=OemToAnsi( Argon->Disco ) 
	       Var13:=OemToAnsi( Argon->Directorio ) 

         cViaIni  := cCurDrive + ':' + cPathTip + ;
	iif( File( AllTrim( Var10 ) ), AllTrim( Var10 ), cFlogo )

         cViaUso  := Trim( Var11 ) + ':' + AllTrim( cViaArchivo ) + ;
	iif( File( AllTrim( Var10 ) ), AllTrim( Var10 ), cFlogo )

	//Envia: viaomision del programa, y via omision en uso actual
	//Recibe: Unidad, via archivo actualizada, y Validacion .t./.f.
	bValidGet := { || ( aVal := ;
			MenuViaFile( cViaIni, cViaUso, cBase, 'A' ), ;
				 Var11 := aVal[1], ;
				 Var13 := aVal[2], ;
				lValid := aVal[3],;
                Eval( bDisc ), oG11:Refresh(), oG13:Refresh() ) }

	if lAppend
	   ( cBase )->( DbGoto( nRec ) )      // Recupera puntero registro
	endif

   DEFINE DIALOG oDlgE FROM 0, 0 TO 19.5, 78.5 ;
      TITLE If( lAppend, "Nuevo Registro", "Modifique Registro" ) 
//        OF oWnd

Memory( -1 )

   @ 00, 01*nXPC SAY "Fecha" OF oDlgE
   @ 00, 07*nXpC SAY OemToAnsi( "Lser" ) OF oDlgE
   @ 00, 15.5*nXpC SAY OemToAnsi( "Ojo" ) OF oDlgE
   @ 00, 19*nXpC SAY OemToAnsi( "Nmero" ) OF oDlgE
   @ 00, 24*nXpC SAY OemToAnsi( "Dimetro" ) OF oDlgE
   @ 00, 29*nXpC SAY OemToAnsi( "Segundos" ) OF oDlgE
   @ 00, 34*nXpC SAY OemToAnsi( "Intensidad" ) OF oDlgE
   @ 2*nXpR , 01*nXpC SAY OemToAnsi( "Descripcin" ) OF oDlgE
   @ 4*nXpR , 01*nXpC SAY OemToAnsi( "Fichero Imagen" ) OF oDlgE
   @ 6*nXpR , 01*nXpC SAY OemToAnsi( "Unidad" ) OF oDlgE
   @ 6*nXpR , 19*nXpC SAY OemToAnsi( "Disco" ) OF oDlgE
   @ 8*nXpR , 01*nXpC SAY OemToAnsi( "Directorio" ) OF oDlgE

   @ 0.8,  01  GET oGet2 VAR Var01 OF oDlgE SIZE 40, 12 ;
	MESSAGE 'Ponga la fecha en formato:  DD/MM/AAAA'
	oGet2:cToolTip := 'Formato: DD/MM/AAAA '
	if Recno() < 2	//nRec == 2
		oGet2:Disable()
        endif
	
   @ 0.8,   7  GET oG2 var Var02 OF oDlgE  SIZE 60, 12 ;
	MESSAGE 'Ponga LASER a usar: P.ej., Argn,  Kripton, Diodo ..'
        oG2:cToolTip := 'Ponga LASER a usar: ' + CRLF + ;
                        'P.ej., Argn,  Kripton, Diodo ..'

   @ 0.8,  15.5  GET oG3 var Var03 OF oDlgE PICTURE '@!' SIZE 20, 12 ;
	MESSAGE 'Ponga Ojo a tratar:  D  /  I  /  AO'
	oG3:cToolTip := 'Ponga Ojo a tratar:  D  /  I  /  AO'
   @ 0.8,  19  GET oG4 var Var04 OF oDlgE PICTURE '9999' SIZE 30, 12       ;
	MESSAGE ;
	OemToAnsi('Ponga el nmero de disparos de la sesin en formato  9999')
	oG4:cToolTip := 'Disparos - Formato: 9999'

   @ 0.8,  24  GET oG5 var Var05 OF oDlgE PICTURE '9999' SIZE 30, 12       ;
	MESSAGE ;
   OemToAnsi('Ponga las micras de dimetro de los disparos en formato  9999')
	oG5:cToolTip := 'Micras - Formato: 9999'

   @ 0.8,  29  GET oG6 var Var06 OF oDlgE PICTURE '9.99' SIZE 30, 12       ;
	MESSAGE ;
	'Ponga el tiempo de cada disparo, en segundos en formato  9.99'
	oG6:cToolTip := 'Segundos - Formato: 9.99'

   @ 0.8,  34  GET oG7 var Var07 OF oDlgE PICTURE '9999' SIZE 30, 12       ;
	MESSAGE 'Ponga la intensidad en formato  9999'
	oG7:cToolTip := 'Intensidad - Formato: 9999'

   @ 2.8,   1  GET oG8 var Var08 OF oDlgE PICTURE '@!' SIZE 160, 12        ;
	MESSAGE OemToAnsi('Descripcion - En maysculas .. ')
	oG8:cToolTip := OemToAnsi('Descripcion - En maysculas .. ')

   @ 4.8,   1  GET oGet10 VAR Var10 ;
				OF oDlgE PICTURE '@!' SIZE 160, 12        ;
        MESSAGE OemToAnsi('Nombre del fichero de imagen .. ')
        oGet10:cToolTip := OemToAnsi('Nombre del fichero de imagen .. ')
//        if Recno() < 2
  	    oGet10:Disable()
//        endif

   @ 6.8,   1  GET oG11 var Var11 OF oDlgE PICTURE '@!' SIZE 125, 12        ;
	VALID Eval( bDisc )  ;
	MESSAGE OemToAnsi('Una letra, de la A a la Z .. ')
	oG11:cToolTip := OemToAnsi('A B C .. Z  ')

   @ 6.8,   19  GET oG12 var Var12 OF oDlgE PICTURE '@!' SIZE 130, 12        ;
	MESSAGE OemToAnsi('Ponga el numero del disco si es externo .. ')
	oG12:cToolTip := ;
		OemToAnsi('Ponga el numero del disco si es externo .. ')

   @ 8.8,   1  GET oG13 VAR Var13 OF oDlgE PICTURE '@!' SIZE 160, 12  ;
     VALID ( Eval( bValidGet ), lValid ) ;
     MESSAGE OemToAnsi('Ponga el Directorio y una [\] - Ej.: ' + cPathTip )
	oG13:cToolTip := 'Directorio y una [\] - Por ej.: ' + cPathTip
//        oG13:bGotFocus := {|| Eval( bValidGet ) }

   @ 11*nXtR, 13*nXtC BUTTON "&Aceptar"  OF oDlgE SIZE 50, 12 ;
				ACTION ( lSave := .t. , oDlgE:End() ) ;
	MESSAGE 'Archivar los valores actuales'

   @ 11*nXtR, 23*nXtC BUTTON "&Cancelar" OF oDlgE SIZE 50, 12 ;
				ACTION oDlgE:End()      ;
	MESSAGE 'Salir sin archivar'   

   @ 1.9, 22.5 BITMAP FILENAME '.\bitmaps\Fondo_AO.Bmp' ;
	OF oDlgE SIZE 100, 50 NOBORDER ADJUST

   ACTIVATE DIALOG oDlgE CENTERED

   oDlgE:Destroy()    

   if lSave 
	
	
	Var13 := cFilePath( Trim( Var13 ) ) 

	Bloq_reg( 5 )

   Var01   := CTOD(AnsiToOem( DTOC( Var01 ) ))
   Var02   := AnsiToOem( Var02 )
   Var03   := AnsiToOem( Var03  )
   Var04   := val( AnsiToOem( str( Var04   ) ) )
   Var05   := val( AnsiToOem( str( Var05   ) ) )
   Var06   := val( AnsiToOem( str( Var06   ) ) )
   Var07   := val( AnsiToOem( str( Var07   ) ) )
   Var08   := AnsiToOem( Var08   )
   Var10   := AnsiToOem( Var10   )
   Var11   := AnsiToOem( Var11   )
   Var12   := AnsiToOem( Var12   )
   Var13   := AnsiToOem( Var13 )

   if RecNo() > 1
	   FieldPut( 1, mHistoria )
	   FieldPut( 2, Var01   )
   else
	   FieldPut( 1, space(10) )
	   FieldPut( 2, CtoD( '' ) )
   endif

//   for i := 3 to 8
	fieldput( 3, Var03   )
	fieldput( 4, Var04   )
	fieldput( 5, Var05   )
	fieldput( 6, Var06   )
	fieldput( 7, Var07   )
	fieldput( 8, Var08   )
//   next

	fieldput( 9, Var02 )

	// El 10 es el contador ..
   if RecNo() > 1
           FieldPut( 10, Var10 )
   endif

// for i := 11 to 13
	fieldput( 11, Var11   )
	fieldput( 12, Var12   )
	fieldput( 13, Var13   )
// next

	DbCommitAll()
	DesBloq()

		aValores := {}

		DbSeek( mHistoria )
		aValores := CreaLista( {} )

/*      if empty( Var01 ) .and. lSave .and. Recno() > 1
	 nMsgBox( "Debe entrar una FECHA para que el registro se valide" )
      endif
*/

   endif

return aValores //Edit
//--------------

//****************************************
Function VerArgon( oAsc, oWn, cHis, cNom, lVal )
//****************************************
   local aEl, cLinea
   
lAnsi     := lVal
oWnd      := oWn
mHistoria := cHis
mNombre   := cNom

dbselectarea( "Argon" )

if DbSeek( mHistoria ) // Si hay archivados datos ..

     cLinea := ''

 cLinea := "Fecha      " + "Tcnica   " + "Ojo  " + "Nm. " + "Dim." + ;
		    "Seg. " + "Int. " + "Descripcin"

              oAsc := CreaLine( oAsc, cLinea )
	      cLinea := ''
              oAsc := CreaLine( oAsc, cLinea )

	Do While Argon->Historia == mHistoria .and. !Eof()
	 cLinea := DTOC( Argon->Fecha ) + ' ' + ;
		   Argon->Laser + ' ' + ;
		   Argon->Ojo  + ' ' + ;
		   str( (Argon->Disparos), 4 ) + ' ' + ;
		   str( (Argon->Diametro), 4 ) + ' ' + ;
		   str( (Argon->Segundos), 4, 2 ) + ' ' + ;
		   str( (Argon->Intensidad), 4 )  + ' ' + ;
		    Argon->Descripcio               
              oAsc := CreaLine( oAsc, cLinea )
	      DbSkip()
	enddo

endif

return oAsc
//----------

Static Function Crealine( oAsc, cLinea )

// sept 08 ansi
cLinea := iif( lAnsi, OemToAnsi( cLinea ), cLinea )
//2008, se crea el ascii en oem
oAsc:Add( cLInea )

return oAsc
//----------------------------------------------------------------------------//

