// zooming, librera FWH - WOCLUPA.PRG - Crea un ejecutable que es llamado desde WOCRICH.EXE
// Juan Planelles Lazaga - 15/02/2012
#include "fivewin.ch"

static oWnd
static nZoom := 2
static oColor

function main()
local oTimer



DEFINE WINDOW oWnd FROM 1, 1 TO 12, 30 TITLE "Lupa" MENU mimenu()

 DEFINE TIMER oTimer OF oWnd ;
      INTERVAL 70 ACTION GetColor()

 oTimer:Activate()




ACTIVATE WINDOW oWnd

 oTimer:DeActivate()


return nil

function mimenu()
local oMenu

MENU oMenu
MENUITEM "Zoom"
   MENU
       MENUITEM "1" ACTION ( nZoom := 1 )
       MENUITEM "2" ACTION ( nZoom := 2 )
       MENUITEM "3" ACTION ( nZoom := 3 )
       MENUITEM "4" ACTION ( nZoom := 4 )
       MENUITEM "5" ACTION ( nZoom := 5 )
   ENDMENU
ENDMENU

return oMenu


function GetColor()

local hDeskTop := GetDC(0)
local a        := GetCursorPos()
local nColor   := GetPixel( hDeskTop, a[2], a[1] )
local hDC      := oWnd:GetDC()
local hPen     := CreatePen( PS_SOLID,1,CLR_HRED )
local hOldPen
local nTop, nLeft
local nWidth, nHeight

nTop    := 10
nLeft   := 100
nWidth  := 100
nHeight := 100

SetBkColor( hDC, nColor )
TextOut( hDC, 10, 10, "           " )
TextOut( hDC, 25, 10, "           " )
TextOut( hDC, 40, 10, "           " )

Moveto( hDC,  nLeft-1, nTop-1)
Lineto( hDC,  nLeft + nWidth+1, nTop-1 )
Lineto( hDC,  nLeft + nWidth+1, nTop+nHeight+1 )
Lineto( hDC,  nLeft -1, nTop+nHeight+1 )
Lineto( hDC,  nLeft-1, nTop-1)

StretchBlt( hDC, nLeft, nTop, nWidth, nHeight, hDeskTop, a[2]-(nWidth/(nZoom*2)), a[1]-(nHeight/(2*nZoom)), nWidth/nZoom, nHeight/nZoom, 13369376 )

hOldPen := SelectObject( hDC, hPen )

Moveto( hDC,  nLeft+nWidth/2+1, nTop-1 )
Lineto( hDC,  nLeft+nWidth/2+1, nTop+nHeight+1 )

Moveto( hDC,  nLeft+1, nTop+nHeight/2+1 )
Lineto( hDC,  nLeft+nWidth+1, nTop+nHeight/2+1 )


SelectObject( hDC, hOldPen )
DeleteObject( hPen )





oWnd:ReleaseDC()
ReleaseDC( 0, hDeskTop )
return nil









#pragma BEGINDUMP
#include "windows.h"
#include "hbapi.h"

HB_FUNC( STRETCHBLT )
{
   hb_retl( StretchBlt( (HDC) hb_parnl( 1 )   ,
                        hb_parni( 2 )         ,
                        hb_parni( 3 )         ,
                        hb_parni( 4 )         ,
                        hb_parni( 5 )         ,
                        (HDC) hb_parnl( 6 )   ,
                        hb_parni( 7 )         ,
                        hb_parni( 8 )         ,
                        hb_parni( 9 )         ,
                        hb_parni( 10 )        ,
                        (DWORD) hb_parnl( 11 )
                        ) ) ;
}




#pragma ENDDUMP


