// Implementacin de un Browse genrico creado desde cdigo
// WOCAG.PRG - AGENDA, JUAN PLANELLES.

#include "FiveWin.ch"

#include "Report.ch"
//#include "InKey.ch"
#define DIA_W      15
#define DIA_H      15

#define K_ESC   27
#define K_ENTER   13
//#define K_ALT_E    274
#define CRCR chr( 13 )
#define TAB  chr( 9 )
#define BTN2WIDTH  15
#define BTN2HEIGHT 15

Static mFecha, dise, date, numdia, mcolor, nmes, lin, lin1, lin2, lin3, ;
   aActions, lin4, nombremes, finmes, oSmes, oSano, diauno, oBt4, cok
static nYear, udmes, aMeses, aDias, lPreg := .f., lAlt := .f.
static ColorDlg, ColorTxt

Static nRec, Ini1, Fin1, Ini2, Fin2, nMin, aMin, ;
        cDatos, aDatos, cFile, l24h, nValue, nMi2, nUser, cUser 
Static bLee, bSave, bCrea, oPrn
Static bPreg, bAyud, cAyud, lRChange := .f.
static nXpR := 0.862, nXpC := 1.34  // Correccion Says
static nXtR := 0.66  , nXtC := 1.16 // Correccion botones
//----------------------------------------------------------------------------//
Function Main()
local n, aStru, aDbf

   ColorTxT := nRGB( 0, 0, 0 )
   ColorDlg := nRGB( 210, 210, 210 )        //nRGB( 255, 255, 255 )

cAyud := ''
SET _3DLOOK ON
SET DATE BRITISH
SET CENTURY ON
SET MULTIPLE ON
SetHandleCount( 250 )
//SET EXACT OFF
SET SOFTSEEK ON
    SetBalloon( .t. )   // Los tooltips de globo de 2007
if year( date() ) >= 2000 .or. Year( date() ) == 00     // Siglo XXI ..
	SET EPOCH TO 2000
endif
if year( date() ) >= 2100 .or. Year( date() ) == 00     // Siglo XXII ..
        SET EPOCH TO 2100
endif
         aStru := {}
   AADD( aStru, { 'FECHA', 'D',  08 , 0 } )
   AADD( aStru, { 'TEXTO', 'C',  40 , 0 } )
   AADD( aStru, { 'HORA' , 'N',  05 , 2 } )
   AADD( aStru, { 'HECHA', 'D',  08 , 0 } )
   AADD( aStru, { 'NOTAS', 'C',  35 , 0 } )

   // Estaticas ..
   nMin := 30
   aMin := { 30, 15, 60, 0 }

   cFile  := 'AGENDA.DAT'
   cDatos := '10' + CRLF + '14' + CRLF +;
                  '16' + CRLF + '20' + CRLF + '30' + CRLF + ;
                'S' + CRLF + '1' + CRLF + '1' + CRLF 
   Ini1   := 0
   Fin1   := 0
   Ini2   := 16
   Fin2   := 21
   nMin   := 30
   aDatos := { '0', '0', '16', '21', '30', 'S', '1', '1' }
   l24h   := .t.
   nValue := 1

   cUser := MemoRead( "UserAg.DAT" )
   nUser := 1
   
   bSave := {|| cDatos := ;
        Str( Ini1, 5, 2 ) + CRLF + ;
        Str( Fin1, 5, 2 ) + CRLF + ;
        Str( Ini2, 5, 2 ) + CRLF + ;
        Str( Fin2, 5, 2 ) + CRLF + ;
        PadL( AllTrim( Str( nMin, 2 ) ), 2, '0' ) + CRLF + ;
        iif( l24h, 'S', 'N' ) + CRLF + ;
        AllTrim( Str( nValue, 3 ) ) + CRLF + ;
        AllTrim( Str( nUser, 3 ) ) + CRLF , ;         
        MemoWrit( cFile, cDatos ) }

   IF !File( cFile )
        Eval( bSave )   //MemoWrit( cFile, cDatos )
   endif

   bLee := {|| ;
        cDatos := iif( !Empty(MemoRead( cFile )), ;
        MemoRead( cFile ), cDatos ), ;
        Aeval( aDatos, {|c,x| ;
                aDatos[ x ] := MemoLine( cDatos,, x ) } ), ;
           Ini1 := Val( Trim( aDatos[1] ) ),;
           Fin1 := Val( Trim( aDatos[2] ) ),;
           Ini2 := Val( Trim( aDatos[3] ) ),;
           Fin2 := Val( Trim( aDatos[4] ) ),;
           nMin := Val( Trim( aDatos[5] ) ),;
           nMi2 := Val( '0.' + Trim( aDatos[5] ) ),;
           l24h := ( Trim( aDatos[6] ) == 'S' ),;
           nValue := Val( Trim( aDatos[7] ) ), ;
           nUser := Val( Trim( aDatos[8] ) ) }

   IF !File( cFile )
        Eval( bSave )   //MemoWrit( cFile, cDatos )
   endif

   Eval( bLee )

If !File( 'AG.DBF' ) .and. ;
        MsgYesNo( 'Archivo: AG.DBF' + CRLF + ;
                  'NO encontrado en directorio actual' + CRLF + ;
                  CRLF + 'CREARLO?' )
       DbCreate( 'AG', aStru )
       Usa_Base( 'Ag', .t., '', 5, .t. )

       index on ( dtos(Ag->fecha) + Str(Ag->Hora, 5, 2 ) ) to Ag1
       Ag->( DbCloseArea() )
endif

       usa_base( 'AG', .t., '', 5, .t. )
       aDbf := Ag->( DbStruct() )

if Len( aDbf ) < 5 .or. aDbf[ 2, 3 ] < 40
		COPY TO Temp1
                AG->( DbCloseArea() )
                dbcreate( 'AG', aStru )
                usa_base( 'AG', .t., "", 5, .t. )
		APPEND FROM Temp1
		FErase( 'TEMP1.DBF' )
endif
                Ag->( DbCloseArea() )

       Usa_base( 'Ag', .t., iif( File('AG1.NTX'), 'Ag1', '' ), 5, .t. )

if !File( 'AG1.NTX' )
   funindex( 'Ag.Dbf', "dtos(fecha)+Str(Hora,5,2)", "Ag1.Ntx", ;
                                                01, 01, , 0.5, 40 )

endif
       bCrea := {|d| Crear( d ) }
//   Eval( bCrea, Date() )
                 
                Ag->( DbCloseArea() )
       usa_base( 'AG', .f., 'Ag1', 5, .t. )     // Se abre en modo compartido

       BroWse()

       Ag->( DbCloseArea() )

Return Nil

Static Function Crear( Date )
local n, i, a, b, c, d, nCount := 0, nI
DEFAULT Date := Date() //, cUser := ""

     // Consulta Solo por la tarde
     if Ini1 == 0 .and. Fin1 == 0
          a := Min( Ini2, Fin2 )
          b := Max( Ini2, Fin2 )
          c := d := 0
     endif

     // Consulta Solo por la maana
     if Ini2 == 0 .and. Fin2 == 0
          a := Min( Ini1, Fin1 )
          b := Max( Ini1, Fin1 )
          c := d := 0
     endif

     // Consulta desde por la maana
     // continuada a la tarde sin interrupcion
     if Fin1 == 0 .and. Ini2 == 0
          a := Min( Ini1, Fin2 )
          b := Max( Ini1, Fin2 )
          c := d := 0
     endif

     // Consulta desde por la maana
     // a la tarde CON interrupcion
     if Fin1 > 0 .and. Ini2 > 0
          a := Min( Ini1, Fin2 )
          b := Max( Ini1, Fin2 )
          c := Min( Fin1, Ini2 )
          d := Max( Fin1, Ini2 )
     endif
// ? Ini1, Fin1, Ini2, Fin2, ValType( Fin2 )
// ? a, b, c, d
// ? a, c, d, b
      /*
          c := iif( c < a .or. c > b .or. d == 0, 0, c )
          d := iif( d > b .or. d < a .or. c == 0, 0, c )
          if c == 0 .or. d == 0
                c := 0
                d := 0
          endif
*/
        if a == 0 .and. b == 0
               ? 'SIN Inicio NI Final !..'
                Return nil
        endif
// ? a, c, d, b
        if nMi2 == 0
             nMi2 := 0.30
        endif

       if !( Ag->( DbSeek( Dtos( Date ) ) ) )
            n := a  // Ini1
            n := Ini1 
                   
//         Do While n < b + 0.01   //Fin2
         Do While n < Fin2 + 0.01   //Fin2
            nCount++
            if nCount > 50
                if MsgYesNO( 'VAN: ' + TRIM( Str( nCount ) ) + CRLF + ;
                  'SEGUIR MAS?..' )
                        nCount := 0
                else
                        Exit
                endif
            endif
            
            if Ini1 == 0 .and. Fin1 == 0
                 if Ini2 > 0 .and. n < Ini2
                    n := Ini2
                 else

                 endif
            endif
            if Fin1 > 0 .and. Ini2 > 0 .and. ;
            		n > Fin1 .and. Ini2 > 0 .and. n < Ini2
            		n := Ini2
            endif		
            
/*            if c > 0 .and. d > 0 .and. d > c .and. ;
                n > c .and. n < d
                // n >= c .and. n < d
                n := d 
            endif
   */         
 // ? n
   /*
            if  n > c .and. n < d
                // n >= c .and. n < d
         //       n := d 
            endif
 */
 // ? n, c, d
            for nI = 1 to nUser
                appe_reg( 5 )
                Ag->Fecha := Date
                Ag->Hora  := iif( n > 12 .and. !( l24h ), n-12, n )
                Ag->Notas :=AnsiToOem(  AllTrim( Memoline( cUser,, nI ) ) )
                DesBloq()
            next    
//? 'N: ' + Str(n)
                n := n + nMi2
//? 'nMi2: ' + Str(nMi2)
                i := n - int( n )
//? 'I: ' + Str(i)
                if i > 0.59
                     n := n -0.60
                     n := n+1
                endif
//? '2  N: ' + Str(n)
            EndDo
       endif
       Ag->( DbSeek( Dtos( Date ) ) )
       
return nil

function Browse( cTitle, cListName, bNew, bModify, bDelete,bSearch, bList )

   local oDlg, oLbx, oFont, nEl, cTxt, DNw, lSeguir, aData := {}
   local btnNew, btnModify, btnDelete, btnSearch, btnList, btnEnd, bRect := {}, aCoors := {}, bCoorSv, bCoorLee, bSize
   local n, aArray := {}, cAlias, xExp, oB1, oB2, cMemoCoors := "", cFCoors := "XCOORDS2", oSkinB, bInicio := {|| Nil }
   local cSel := "", nSel := 0, aSel := {}, btSel, btnIns
   
   DEFAULT cTitle  := "Browse: " + Upper( Alias() ) + ' - ' + ;
                FWVERSION + ' ( 32 Bits ) - ' + FWCOPYRIGHT, cListName := "Fields",;
           bNew    := { || RecNew( oLbx ) }, ;
	   bDelete := { || RecDelete( oLbx ) },;
	   bModify := { || RecModify( oLbx ) },;
	   bSearch := { || Search( oLbx ) }   ,;
	   bList   := { || Report( oLbx ) }

   oSkinB = TSkinButton():New()
   SkinButtons( oSkinB )   
   cAlias    :=  Upper( AllTrim( Alias() ) )
   cTitle    := 'AGENDA de  Consulta de Wocul3.Exe - '+ ; 
                FWVERSION + ' ( 32 Bits )' // - ' + FWCOPYRIGHT
   cListName := 'Datos de Agenda'

//---------------------------------------------------------------------------
   cFCoors := cFCoors + ".001"   //+ PADL( AllTrim( str( Lis_red->( RecNo() ), 3 ) ), 3, "0" )
   aCoors := Array( 4 )    
   bCoorSv := {||  ;
        MemoWrit(  cFCoors,  Str( ( oDlg:nTop ) ) + CRLF + ;
        Str( ( oDlg:nLeft ) ) + CRLF + ;
        Str( ( oDlg:nBottom ) ) + CRLF + ;
                 Str( ( oDlg:nRight  ) ) ) }
    
    bCoorLee := {|| ;
         cMemoCoors := Trim( MemoRead( cFCoors ) ),;
         cMemoCoors := iif( MLCount( cMemoCoors ) > 3,;   // Valor valido // En caso de error, valor original.. q s  establece en cada entrada
     cMemoCoors,  AllTrim( Str( 8*16 ) ) + CRLF + AllTrim( Str( 17*8 ) ) + CRLF + ;
  				                 AllTrim( Str( 35*16 ) ) + CRLF + AllTrim( Str( 100*8 ) ) ), ;  // msginfo( cMemocoors, str(MLCount( cMemoCoors )))
                    aCoors[ 1 ] := ( Val( TRIM( Memoline( cMemoCoors,, 1 ) ) )*1.011 ),;
  				  aCoors[ 2 ] := ( Val( TRIM( Memoline( cMemoCoors,, 2 ) ) ) ),;
  				  aCoors[ 3 ] := ( Val( TRIM( Memoline( cMemoCoors,, 3 ) ) )*0.949 ),;
    				  aCoors[ 4 ] := ( Val( TRIM( Memoline( cMemoCoors,, 4 ) ) )*0.9735 )  }  // 986

 bSize := {||  oDlg:CoorsUpdate(), Eval( bCoorSv ) } 
 Eval( bCoorLee )
     bRect := {|| ;
    		oDlg:nTop := aCoors[1], oDlg:nLeft := aCoors[2], oDlg:nBottom := aCoors[3], oDlg:nRight := aCoors[4]    }
  				                 
    // Eval( bCoorLee )
    // Fin Coordenadas
//----------------------------------------------------------------------------

   DEFINE FONT oFont NAME "Arial" SIZE 6, 15 BOLD

   DEFINE DIALOG oDlg ;  // FROM 3, 1 TO 26, 77 
   TITLE cTitle FONT oFont ;
   ;   //  STYLE nOr( WS_POPUP, WS_BORDER, WS_THICKFRAME ) ;
   ;  //   STYLE nOr( WS_POPUP, WS_THICKFRAME, WS_CAPTION ) 
   COLOR ColorTxt, ColorDlg
    oDlg:nStyle := nOr( WS_VISIBLE, WS_OVERLAPPEDWINDOW )

    Eval( bRect )
    
   bPreg := {|| iif( File( 'PACIENTE.DBF' ), ;
                     lPreg := MsgYesNo( 'PREPARAR LISTA' + CRLF +;
                                'Para llamar desde la CONSULTA:' + CRLF + ;
                                'Pueden BUSCAR los pacientes' + CRLF +;
                                    'desde un listado de la agenda'+ CRLF +;
                                'desde ventana inicial con CTRL + G' + CRLF + ;
                                'por Apellido1 Apellido2, Nombre' + ;
             CRLF + CRLF + 'CREAR LA LISTA?..' ), ( MsgBeep(), lPreg := .f. )),;
             iif( lPreg, FileCons( oLbx ), Nil ), oLbx:Refresh() }

    cAyud := ;
    'Clic en ste botn -> Uso compartido de la agenda' + CRLF + CRLF + ;
      'Al abrir la Agenda se crean las horas de la fecha actual si no lo estaban.' + CRLF + CRLF + ;
    'Si abre el almanaque con la fecha activa del listado, '+;
    'y si se modifica el almanaque, automticamente se va actualizando ' +;
    'una nueva fecha que, al cerrar con el botn de Aceptar, se ' +;
    'convierte en fecha actual del listado, crendola caso de no existir.' + CRLF + ;
    CRLF + 'Se pueden crear horas repetidas para distintos puestos de trabajo' + CRLF + ;
    'cuyos nombres se muestran en el campo <Observaciones>.' + CRLF + ; 
    CRLF + ;
    'Los cambios hechos son efectivos para las fechas creadas tras la modificacin' + ;
    ' y si se desea aplicar a una fecha ya creada se tiene que eliminar lo existente' + ;
     ' y volver a crearla con la nueva configuracin. Se hace con el botn <Eliminar>' + CRLF + CRLF + ;
    'Tecla [DEL] elimina paciente seleccionado, [INS] inserta una lnea delante de la seleccionada.' + ;
    'Clic Dcho. minimiza la ventana, lo mismo ocurre en el listado, '+;
    'y Clic Izq. o Intro, en la barra de tareas, la maximiza.' 
    
    /*WAITRUN( "NOTEPAD " + "REVISADO.TXT", 1 )
    +CRLF + ;
    CRLF + 'Esta utilidad funciona con unos Bitmaps que han de estar '+;
    'situados en un SUBdirectorio .\BITMAPS  al de su ubicacin. Estos '+;
    'son la mscara:?DIA*.BMP'
   */
   // bAyud := {|| MsgInfo( cAyud ), iif( File( "WOCRICH.EXE" ), WAITRUN( "WOCRICH " + "AGENDA.RTF", 1 ),  Nil ) }

  @ 0, 0 BUTTON ob1 PROMPT "A&yuda" OF oDlg  SIZE 38, 11 ;
         MESSAGE "Ayuda .." ACTION iif( File( "WOCRICH.EXE" ), ;
         		WAITRUN( "WOCRICH " + "AGENDA.RTF", 1 ), MsgInfo( cAyud, "Informacin" ) )
 //  @ 0.1, 0.3 BITMAP oB1 FILE ".\bitmaps\XDiax1.BMP"  OF oDlg SIZE 13,13 ;
 //  ADJUST NOBORDER ON LEFT CLICK ( Eval( bAyud ), MsgAbout() )
   oB1:cToolTip := {  cAyud,'Informacin:'}

/*
   @ 0,1 BUTTON oB1 FILE '.\bitmaps\XDiax1.Bmp' ;
   OF oDlg SIZE 13, 13  ACTION Eval( bAyud )
   oB1:cToolTip := 'Ayuda..'

   @ 0,14 BUTTON oB2 FILE '.\bitmaps\XDiax2.Bmp' ;
   OF oDlg SIZE 13, 13 ACTION ( Eval( bPreg ) )     
   oB2:cToolTip := 'Preparar lista para llamar desde la consulta'
*/
//   @ 0, 5 SAY cListName  OF oDlg  ;
//                           COLOR ColorTxt, ColorDlg

   @ 1.1, 1 LISTBOX oLbx FIELDS ;
    OF oDlg SIZE oDlg:nWidth() -30, oDlg:nHeight() -30  // MULTI
   oLbx:cToolTip := 'Esc = Salir,  Ins = Crear,  Del = Borrar, ' + ;
                      ' Intro = Editar Registro,  DblClick = Edita celdilla'
   oLbx:bLDblClick = { | nRow, nCol | EditCell( oLbx, nRow, nCol ) }
   oLbx:bKeyDown   = { | nKey, nFlags | KeyDown( oLbx, nKey, nFlags ) }
   oLbx:bKeyChar   = { | nKey, nFlags | KeyChar( oLbx, nKey, nFlags ) }
   oLbx:aActions   = Array( ( Alias() )->( FCount() ) )
   oLbx:bGoTop := {|| MsgBeep(), Ag->( DbGoTop(), oLbx:Refresh() ) }
   oLbx:bGoBottom := {|| MsgBeep(), Ag->( DbGoBottom(), oLbx:Refresh() ) }
   // Lets use different row colors
   oLbx:nClrText      := { || iif( Ag->Fecha == Date(), ;
   CLR_GREEN, iif( Year( Ag->Fecha ) == Year( Date() ), ;
                                                CLR_BLUE, CLR_BLACK ) ) }
   oLbx:nClrForeFocus := { || ;
   Iif( Ag->Fecha == Date(), ;
   CLR_GREEN, iif( Year( Ag->Fecha ) == Year( Date() ), ;
                                        CLR_BLUE, CLR_BLACK ) ) }
   oLbx:nClrBackFocus := { || ;
   Iif( Ag->Fecha == Date(), ;
   CLR_YELLOW, iif( Year( Ag->Fecha ) == Year( Date() ), ;
                                 CLR_YELLOW, CLR_YELLOW ) ) }

   for n = 1 to Len( oLbx:aActions )
      oLbx:aActions[ n ] = { || MsgInfo( "Column action" ) }
   next

        oLbx:aHeaders := { 'FECHA', 'ANOTACION', 'HORA', 'HECHA', ;
                                        'Observaciones' }  //, 'Hecha el:' }
        oLbx:bLine    := {|| { ;
                    cValToChar( ( cAlias )->( FieldGet( 1 ) ) ), ;
                    OemToAnsi( ( cAlias )->( FieldGet( 2 ) ) ), ;
                    cValToChar( ( cAlias )->( FieldGet( 3 ) ) ), ;  
                    cValToChar( ( cAlias )->( FieldGet( 4 ) ) ), ;  
                    OemToAnsi( ( cAlias )->( FieldGet( 5 ) ) ) } } 
 
   @ 0,  6.5 BUTTON btnNew    PROMPT "&Configurar"  OF oDlg SIZE 38, 11
   @ 0, 13 BUTTON btnModify PROMPT "&Almanaque" OF oDlg SIZE 38, 11
   @ 0, 19.5 BUTTON btnDelete PROMPT "&Elimina"  OF oDlg SIZE 38, 11
   @ 0, 26 BUTTON btnSearch PROMPT "&Buscar"   OF oDlg SIZE 38, 11
   @ 0, 32.5 BUTTON btnList   PROMPT "&Imprimir" OF oDlg SIZE 38, 11
   @ 0, 39 BUTTON btnEnd    PROMPT "&Reindexar"    OF oDlg SIZE 38, 11
   @ 0, 45.5 BUTTON btSel    PROMPT "&Seleccin"    OF oDlg SIZE 38, 11
   @ 0, 52 BUTTON btnIns    PROMPT "&Insertar"    OF oDlg SIZE 38, 11   ACTION oLbx:KeyDown( VK_INSERT ) 
   btnIns:CToolTip = { "Insertar nueva delante de la seleccionada", "Cita:" }
   btnNew:bAction    = { || Configu( oLbx ), iif( lRChange, (Eval(btnDelete:bAction) ), Nil ), oLbx:SetFocus() }
   btnNew:cToolTip  := { 'Configurar horas',  'Citas' }     
   btSel:bAction = {|| cSel := Seleccionar( oLbx ), iif( cSel != Nil .and. !Empty( cSel ), ( ;
   				Parcial( cSel, ( oLbx:cAlias )->( FieldGet( 1 )  ), cAlias ) ), Nil )  }  
   btSel:cToolTip := { "Seleccin parcial", "Listado:" }
//   btnModify:bAction = { || DNw := Calendar( oLbx, Ag->Fecha )
   btnModify:bAction = { || DNw := MsgDate( Date, 'Elija Fecha', Nil ), ;
   MsgInfo( dtoc(DNw) ), Eval( bCrea, DNw ), oLbx:Refresh(), oLbx:SetFocus() }
   btnModify:cToolTip := {'Ver Almanaque y aadir otra fecha a la lista.', 'Accin'}

   btnDelete:bAction =  ;
                           { || BorraDia( oLbx ),;
                           oLbx:Refresh(), oLbx:SetFocus(), ;
        iif( MsgYesNo( "Rehacer nuevo listado?", "Elija una opcin para seguir"  ),  ;
        ( Eval( bInicio ), oDlg:Refresh(), oLbx:SetFocus() ),  Nil ) ;                   
                            }
   
   btnDelete:cToolTip := {'Eliminar lista actual de horas de citas y rehacer si se desea ... (DEL elimina lnea)', 'DIA seleccionado'}

   btnSearch:bAction = If( bSearch != nil,;
			   { || Eval( bSearch ),;
			   oLbx:Refresh(), oLbx:SetFocus() },)
   btnSearch:cToolTip := {'Buscar / Crear una fecha determinada', 'Fecha' }

   btnList:bAction   = { || Eval( bList ), oLbx:Refresh() }
   btnList:cToolTip := {'Imprimir listado', 'entre fechas'}

   btnEnd:bAction    = { || ;   //oDlg:End() }
   funindex( cAlias +'.DBF', "dtos(fecha) + Str(Hora,5,2)", "Ag1.Ntx", ;
                                                01, 01, oDlg, 0.5, 40 ),;
         usa_base( cAlias, .f., "Ag1", 5, .t. ),  ;
        oLbx:Refresh(), oLbx:SetFocus() }
   btnEnd:cToolTip := 'Indexar la base de datos'

   oDlg:bRClicked := {|| oDlg:Minimize() } 
   oDlg:cToolTip  := {'Esc. -> Cerrar - CLICK DERECHO -> MINIMIZA ..' + CRLF + ;
   								'`[DEL] / [INS] = Suprime / Aade lnea ..', 'Teclas:'}
   oDlg:lResize16 := {|| .t. }
   oDlg:bReSized := {|| Eval( bSize ), oLbx:nWidth := oDlg:nWidth() -55,;
             oLbx:nHeight := oDlg:nHeight() -90, oDlg:Refresh(), oLbx:SetFocus()  }
   bInicio := {||  Eval( bCrea, Date() ), oLbx:SetFocus()  }
   ACTIVATE DIALOG oDlg ON INIT ;
         Eval( bInicio ) ON PAINT oLbx:SetFocus()  

   if lPreg
        // Crear lista en disco para consulta ..
   endif

return nil

Function Parcial( cSel, cDate, cBase )
   local nI := 0, a_temp := {},  bRect := {}, aCoors := {}, bCoorSv, bCoorLee, bSize, cTitle, cName := ""
   local oDlg, oBrw, n := 1, cMemoCoors := "", cFCoors := "XCOORDS3", oFont
   SET _3DLOOK ON
//---------------------------------------------------------------------------
   cFCoors := cFCoors + ".001"   //+ PADL( AllTrim( str( Lis_red->( RecNo() ), 3 ) ), 3, "0" )
   aCoors := Array( 4 )    
   bCoorSv := {||  ;
        MemoWrit(  cFCoors,  Str( ( oDlg:nTop ) ) + CRLF + ;
        Str( ( oDlg:nLeft ) ) + CRLF + ;
        Str( ( oDlg:nBottom ) ) + CRLF + ;
                 Str( ( oDlg:nRight  ) ) ) }
    
    bCoorLee := {|| ;
         cMemoCoors := Trim( MemoRead( cFCoors ) ),;
         cMemoCoors := iif( MLCount( cMemoCoors ) > 3,;   // Valor valido // En caso de error, valor original.. q s  establece en cada entrada
     cMemoCoors,  AllTrim( Str( 8*16 ) ) + CRLF + AllTrim( Str( 17*8 ) ) + CRLF + ;
  				                 AllTrim( Str( 35*16 ) ) + CRLF + AllTrim( Str( 100*8 ) ) ), ;  // msginfo( cMemocoors, str(MLCount( cMemoCoors )))
                    aCoors[ 1 ] := ( Val( TRIM( Memoline( cMemoCoors,, 1 ) ) )*1.011 ),;
  				  aCoors[ 2 ] := ( Val( TRIM( Memoline( cMemoCoors,, 2 ) ) ) ),;
  				  aCoors[ 3 ] := ( Val( TRIM( Memoline( cMemoCoors,, 3 ) ) )*0.949 ),;
    				  aCoors[ 4 ] := ( Val( TRIM( Memoline( cMemoCoors,, 4 ) ) )*0.9735 )  }  // 986

 bSize := {||  oDlg:CoorsUpdate(), Eval( bCoorSv ) } 
 Eval( bCoorLee )
     bRect := {|| ;
    		oDlg:nTop := aCoors[1], oDlg:nLeft := aCoors[2], oDlg:nBottom := aCoors[3], oDlg:nRight := aCoors[4]    }
  				                 
    // Eval( bCoorLee )
    // Fin Coordenadas
//----------------------------------------------------------------------------
 
Ag->( DbSeek( cDate ) )
// ( cBase )->( DbSeek( cDate ) )
// do while ( cBase )->( FieldGet( 1 ) ) == cDate
do while Ag->( FieldGet( 1 ) ) == cDate .and. Ag->( !Eof() )  
       if AllTrim( OemToAnsi( Ag->( FieldGet( 5 ) ) ) ) == AllTrim( cSel ) .and. ;
       				!Empty(  Ag->( FieldGet( 2 )  ) )
  
          aadd( a_Temp, { Ag->( FieldGet( 1 ) ), Ag->( FieldGet( 2 ) ), ;
       					Ag->( FieldGet( 3 ) ), Ag->( FieldGet( 4 ) ), Ag->( FieldGet( 5 ) ) } )
       endif					
      Ag->( DbSkip() )
enddo
 Ag->( DbGotop() )
 Ag->( DbSeek( cDate ) )

 
   if len( a_temp ) < 1
      Msginfo( "No hay pacientes anotados", "Aviso" )
      return NIL
   endif

//   asort( a_temp,,, { |x, y | x[1] < y[1] } )

  cTitle := "Pacientes citados para: " + Trim( cSel )
  DEFINE FONT oFont NAME "Arial" SIZE 6, 15 BOLD

   DEFINE DIALOG oDlg ;   
   TITLE cTitle FONT oFont ;
   COLOR ColorTxt, ColorDlg
    oDlg:nStyle := nOr( WS_VISIBLE, WS_OVERLAPPEDWINDOW )

    Eval( bRect )
 
   @ 1,2 listbox oBrw fields dtoc(a_temp[n][1] ),;
      OemToAnsi(a_temp[n][2]),;  
      str( a_temp[n][3], 5, 2 ),;
      dtoc(a_temp[n][4] ), ;
      OemToAnsi(a_temp[n][5]) ;  
      headers "Fecha", "Nombre", "Hora", "Hecha", "Observaciones" ;
      fieldsizes 80,150,60,80, 150 ;
      of odlg SIZE oDlg:nWidth() -70, oDlg:nHeight() -90 

   oBrw:bGotop    := { || n := 1 }
   oBrw:bGoBottom := { || n := eval( oBrw:bLogicLen ) }
   oBrw:bSkip     := { | nwant, nold | nold := n , n += nwant,;
      n := max( 1, min( n, eval( oBrw:bLogicLen ))),;
      n - nOld }
   oBrw:bLogicLen := { || len( a_temp ) }
   oBrw:cAlias    := "Array"

   @ 0, 0 Button "&Salir" of oDlg action oDlg:end() SIZE 38, 11
   @ 0, 6.5 Button "&Abrir" of oDlg action ( cName := a_temp[n][2], oDlg:end() ) SIZE 38, 11
   
   oDlg:lResize16 := {|| .t. }
   oDlg:bReSized := {|| Eval( bSize ), oBrw:nWidth := oDlg:nWidth() -70,;
             oBrw:nHeight := oDlg:nHeight() -90, oDlg:Refresh(), oBrw:SetFocus()  }

   activate dialog oDlg ON PAINT oBrw:SetFocus()  // centered
   

return( cName )


static Function Seleccionar( oLbx )
******************************       
local cUser := MemoRead( "UserAg.DAT" ), cSel :=  "", aSel := {}  
local nI := 0, oDlg, cTitle := "Elija, por favor", cValue := ""
cUser := MemoRead( "UserAg.DAT" )
if EmpTy( cUser )
		MsgInfo( "No hay datos de Usuarios...", "Informacin." )
		Return ""
endif
for nI = 1 to MLCount( cUser )
       aadd( aSel, AllTrim( MemoLine( cUser,, nI ) ) )
next

 cSel := MsgSelect( aSel, aSel[1] )   

 Return( cSel )

static function MsgSelect( aItems, cValue, cTitle )

   local oDlg, oBa, oBc
   DEFAULT cTitle := "Elija, por favor"
   
   DEFINE DIALOG oDlg FROM 5,10 TO 24, 55 TITLE cTitle

   @  1, 2 LISTBOX cValue ITEMS aItems SIZE 145, 95 OF oDlg

  @ 7, 7 BUTTON oBa 	PROMPT "&Aceptar" OF oDlg SIZE 40, 12 ;
     ACTION  oDlg:End() DEFAULT
     oBa:cToolTip :=  { "Listado parcial de pacientes", "Se muestra:" }

   @ 7, 17 BUTTON oBc PROMPT "&Cancelar" OF oDlg SIZE 40, 12 ;
     ACTION ( cValue := Nil, oDlg:End() )  
     oBc:cToolTip := {"Salir sin eleccin...", "Lista:" } // ( cValue := nil, oDlg:End() )

   ACTIVATE DIALOG oDlg CENTERED

return cValue

//----------------------------------------------------------------//

//procedure AppSys  // Xbase++ requirement

//return

//--------------------
static function Report( oLbx )
******************************
 local oRpt, aDates, dIni, dFin, lImpr := .t.
 local n, nField := 0, aLista := {}
 local cAlias := If( oLbx != nil, oLbx:cAlias, Alias() )
 local nVeces := FCount() 

   aDates := SelFechas()
   dIni   := aDates[1]
   dFin   := aDates[2]
   nRec   := Ag->( RecNo() )
   lImpr  := aDates[3]

   if ! lImpr
        Return Nil
   endif

   //GO TOP
   ag->( DbSeek( Dtos( dIni ) ) )
if !Ag->( Eof() )

/*      // Da error en W'98
   REPORT oRpt TITLE "Listado: " + cAlias ;
      HEADER "Fecha: " + DToC( Date() ) + ", Hora: " + Time() + ;
         "  -  Pag.: " + Str( oRpt:nPage, 3 ) ; 
      PREVIEW

      for n = 1 to 3    //nVeces       //FCount()
         oRpt:AddColumn( TrColumn():New( { FInfo1( cAlias, n ) },,;
            iif( n == 2, ( { FInfo2( cAlias, n ), FInfo2( cAlias, n+3 ) } ), ;
                    { FInfo2( cAlias, n ) } ),,,,,,,,,, oRpt ) )
      next

   ENDREPORT

   ACTIVATE REPORT oRpt WHILE ;
   ( Ag->Fecha <= dFin .and. Ag->( !Eof() ) )        //.and. nField <= 60
*/
   Do While Ag->Fecha <= dFin .and. Ag->( !Eof() ) 
        AAdd( aLista, AllTrim( DtoC( Ag->Fecha ) + ' - ' + ;
           Str( Ag->Hora ) ) + ' - ' + OemToAnsi( Ag->Texto ) )
        Ag->( DbSkip() )
   EndDo

        PrnLista( aLista, 'AGENDA' ,, .f. )

   Ag->( DbGoto( nRec ) )

else
        MsgAlert( 'Archivo sin datos' )
endif

return nil

//----------------------------------------------------------------------------//

static function FInfo1( cAlias, n )
local aLista := { "FECHA", "ANOTACION", "HORA", "Observaciones" } 
return iif( AllTrim( Upper( Alias() ) ) == 'AG', ;
		{|| ( aLista[ n ] ) }, {|| ( cAlias )->( FieldName( n ) ) } )
//return { || ( cAlias )->( FieldName( n ) ) }

static function FInfo2( cAlias, n )
return { || iif( ValType( ( cAlias )->( FieldGet( n ) ) ) == 'C', ;
OemToAnsi( ( cAlias )->( FieldGet( n ) ) ), ( cAlias )->( FieldGet( n ) ) ) }

//----------------------------------------------------------------------------//
Static function Configu( oLbx )
local nResp := MenuRadio( ;
              'Intervalo entre CITAS: ', ;
              { "&30' " , ;
                "1&5' ", ;
                '&1 Hora', ;
                '&Otro intervalo' }, 'Configuracin de la Agenda de Wocul3.Exe.', 01 )

return nil

static function RecModify( oLbx )

   local n := 1
   local nCols := ( oLbx:cAlias )->( FCount() )
   local u := ( oLbx:cAlias )->( FieldGet( 1 ) )
   local cBase := AllTrim( Upper( Alias() ) )

        nCols := 5

   lAlt := .t.

   if Valtype( u ) == 'C'
	u := OemToAnsi( u )
   endif
   while n <= nCols .and. oLbx:lEditCol( n, @u )
      if Valtype( u ) == 'C'
	u := AnsiToOem( u )
      endif
      oLbx:DrawSelect()
      SysRefresh()
      if ( oLbx:cAlias )->( RLock() )
	 ( oLbx:cAlias )->( FieldPut( n, u ) )
	 UNLOCK
      else
	 MsgAlert( "No es una Base de datos" )
	 n = nCols + 1
      endif
      n++
      if n <= nCols
	 u = ( oLbx:cAlias )->( FieldGet( n ) )
      endif
      if Valtype( u ) == 'C'
	 u := OemToAnsi( u )
      endif
      oLbx:GoRight() 
   end

For n := nCols To 1 STEP -1 
	oLbx:GoLeft()
Next

return nil

//----------------------------------------------------------------------------//

static function EditCell( oLbx, nRow, nCol, nCampo )

   local nColumn
   local u, cBase := AllTrim( Upper( Alias() ) )

   nColumn := iif( Empty( nCampo ), oLbx:nAtCol( nCol ), nCampo )
   // Llamada controlada desde raton  desde crear nuevo..

   lAlt := .t.

   u = ( oLbx:cAlias )->( FieldGet( nColumn ) )
   if Valtype( u ) == 'C'
        u := OemToAnsi( u )
   endif
   if oLbx:lEditCol( nColumn, @u )

      if Valtype( u ) == 'C'
	u := AnsiToOem( u )
      endif
      if ( oLbx:cAlias )->( RLock() )
	 ( oLbx:cAlias )->( FieldPut( nColumn, u ) )
	 UNLOCK
	 oLbx:DrawSelect()
      else
	 MsgAlert( "No es una Base de datos" )
      endif
   endif
   oLbx:Refresh()

return nil

//----------------------------------------------------------------------------//

static function KeyDown( oLbx, nKey, nFlags )
 local cAlias := If( oLbx != nil, oLbx:cAlias, Alias() )

   do case
      case nKey == VK_DELETE 
	   RecDelete( oLbx )

      case nKey == VK_INSERT
           RecNew( oLbx )

   endcase

return nil

static function RecNew( oLbx )
 local cAlias := If( oLbx != nil, oLbx:cAlias, Alias() )
 local dFecha := ( cAlias )->( FieldGet( 1 ) )
 local nHora  := ( cAlias )->( FieldGet( 3 ) ), n, i

 n := nHora

   lAlt := .t.

 i := n - int( n )
 //i := i - nMi2
 n := int( n )

 if i - nMi2 < 0
   n--
   i := i + 0.60 -nMi2
 else
   i := i - nMi2
 endif

   n := n + i
nHora := n
nHora := iif( nHora -int( nHora ) == 0.60, int( nHora ), nHora )

           nHora := Max( 0, nHora )
           oLbx:RecAdd()
           nRec := (cAlias)->( RecNo())
           //oLbx:Refresh() }
           ( cAlias )->(DbGoto( nRec ))
oLbx:RecAdd()
oLbx:Refresh()
/*
      if ( oLbx:cAlias )->( RLock() )
         ( oLbx:cAlias )->( FieldPut( 1, dFecha ) )
         ( oLbx:cAlias )->( FieldPut( 3, nHora  ) )
	 UNLOCK

	 oLbx:DrawSelect()
      else
	 MsgAlert( "No es una Base de datos" )
      endif
*/
           oLbx:Refresh()
           oLbx:SetFocus()
           EditCell( oLbx, 1, 1, 2 )
           oLbx:Refresh()

return nil
//----------------------------------------------------------------------------//

static function KeyChar( oLbx, nKey, nFlags )

   do case
      case nKey == K_ENTER
	   RecModify( oLbx )
   endcase

return nil

//----------------------------------------------------------------------------//

static function RecDelete( oLbx )
 local cAlias := If( oLbx != nil, oLbx:cAlias, Alias() )
 local Date := Ag->Fecha, nRegDel := Ag->( RecNo() )

   if MsgYesNo( OemToAnsi( cValToChar(( cAlias )->( FieldGet( 1 ) )) ) + ;
           + ' -> ' + OemToAnsi( AllTrim( Str( Ag->Hora ) ) ) + ;
           CRLF + "Borrar este registro?", "Confirme, por favor !." )
                Ag->( DbCloseArea() )
       usa_base( 'AG', .t., 'Ag1', 5, .t. )     // Se abre en modo compartido
        Ag->( DbGoto( nRegDel ) )
      DELETE
      PACK
                Ag->( DbCloseArea() )
       usa_base( 'AG', .f., 'Ag1', 5, .t. )     // Se abre en modo compartido
      Ag->( DbSeek( Dtos( Date ) ) )
      oLbx:Refresh()
   lAlt := .t.
   endif

return nil

static function BorraDia( oLbx )
 local cAlias := If( oLbx != nil, oLbx:cAlias, Alias() )
 local Date := Ag->Fecha

   if ( lRChange) .or. MsgYesNo( OemToAnsi( cValToChar(( cAlias )->( FieldGet( 1 ) )) ) + ;
           CRLF + "Borrar FECHA completa?", "Confirme, por favor !." )
                Ag->( DbCloseArea() )
       usa_base( 'AG', .t., 'Ag1', 5, .t. )     // Se abre en modo compartido
      Ag->( DbSeek( Dtos( Date ) ) )
      Do WHile Ag->Fecha == Date
        DELETE
        Ag->( DbSkip() )
      EndDo
      PACK
                Ag->( DbCloseArea() )
       usa_base( 'AG', .f., 'Ag1', 5, .t. )     // Se abre en modo compartido
      Ag->( DbSeek( Dtos( Date ) ) )
      oLbx:Refresh()
   lAlt := .t.
   lRChange := .f.
   endif

return nil

//----------------------------------------------------------------------------/
*
******************************
static function Search( oLbx, cDate )
******************************
local cBase := If( oLbx != nil, oLbx:cAlias, Alias() )
DEFAULT cDate := CtoD( '' )

if MsgGet( "Buscar " + FieldName( 1 ), 'Formato FECHA -> DD/MM/YYYY', ;
                                        @cDate, ".\bitmaps\lupa.bmp" )

        if Empty( cDate )
		MsgAlert( 'NO ha introducido' + CRLF + ;
				'VALOR para BUSCAR !.' )
		Return Nil
	endif
        if Ag->( DbSeek( DtoS( cDate ) ) )
        else
          if MsgYesNo( 'Fecha: ' + cValToChar( cDate ) + CRLF + ;
             'Va a ser CREADA ..!'+ CRLF + CRLF + 'CONFORME?..' )
             Eval( bCrea, cDate )
             Ag->( DbSeek( Dtos( cDate ) ) )
             oLbx:Refresh()
          endif
        endif

  /*      LOCATE FOR cDate $ ;
		cValToChar( upper( AllTrim( ( cBase )->( FieldGet( 1 ) ) ) ) )
	Do While !MsgYesNo( 'Encontrado: ' + ;
		OemToAnsi( ( cBase )->( FieldGet( 1 ) ) ) + CRLF + ;
							'Conforme?.' )
		CONTINUE
		if Eof()
			MsgStop( 'Fin del Fichero !.' )
			Exit
		endif
	EndDo
*/
endif

return nil
*---------
*
*********************************************************
function abrebase(cbasedatos, lmodoapert, nsegundos, area )
*********************************************************
// Abre una base en red
local iniseg := 0
local mientras, reiniciar, tiempo_espera, ca10 , cresp
nsegundos  := iif( empty( nsegundos ), 5, nsegundos )
lmodoapert := iif( empty( lmodoapert ), .f., lmodoapert )
area       := iif( empty(area), .f., area )  // .t. = area cero, para llamar
				       //  por el alias-nombre  
/*
MSGINFO('ABRIENDO: ' + cbasedatos  +CRLF+;
	'MODO: ' + ( IF( LMODOAPERT, '.F.', '.T.' ) ) )
*/
reiniciar  := .t.
mientras := (nsegundos == 0)
//cbasedatos := cbasedatos + '.dbf'

do while reiniciar == .t.
   tiempo_espera := nsegundos
   do while ( mientras .or. tiempo_espera > 0 )
      
      if ( lmodoapert )  // se valora si compartido es t o f
	 DbUseArea( area, , cbasedatos, , .F. ) // modo exclusivo
      else
	 DbUseArea( area, , cbasedatos, , .T. ) // modo compartido
      endif
      
      if !neterr()
	 return .t.
      endif
      
//      inkey(1)
	iniseg := val( substr( TIME(), 7, 2 ) )
	do while val( substr( TIME(), 7, 2 ) ) - iniseg < 1
	enddo
      tiempo_espera = tiempo_espera - 1
      
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Fichero: " + cbasedatos + " - NO se ha abierto.;" + ;
		 "Cierre cualquier otra version del programa;" + ;
		 "que se pueda estar ejecutando !"

   cresp := fallo_acc(cbasedatos, ca10)
   if cresp # "R"
      exit
   endif
   
enddo

return .f.
*---------
*
*       
*************************************************
       Function Alert2( cMsg, aOpciones, cTitle, nPosy, nPosx, oDlg )
*************************************************
//   local nPosy  := 11
//   local nPosx  := 38
   local nLongY := 5          // lo minimo
   local nLongX := 20         // lo minimo
   local nLong_cad := 0       // longitud de la cadena
   local nLong_opc := 0       // longitud de las opciones
   local n, nOpc := 1
   local cOpciones := ""
   local nPosOpc   := 0
   local nPosYOpc   := 3    // por defecto
   local lCogeOpcion := .F.
   local cCad_opcion := ""
   local nLineas := 0
   local oDlAl, oFont, lCentrar := ( Empty( nPosX ) .and. Empty( nPosY ) )
   local nRet := 0
   local aBut := {}
   
   DEFAULT cTitle    := "Atencin", oDlg := Nil
   DEFAULT aOpciones := { " &OK " }     //, "&NO", "&TAMPOCO" }
   DEFAULT cMsg      := ""      //"Sale o no sale; Segun salga; Ya saldra"
   DEFAULT nPosy     := 15, nPosx  := 38
//   cMsg := ';' + cMsg // Echo yo la linea uno mas abajo ..
   cMsg    = StrTran( cMsg, ";", CRLF )
   nLineas = MlCount( cMsg, 254 )
   // vamos a ver que linea es la mas larga

   for n = 1 To nLineas
      if Len( AllTrim( Memoline( cMsg,, n ) ) ) > nLong_cad
	 nLong_cad = Len( AllTrim( Memoline( cMsg,,n ) ) )
      Endif
   Next
   nLong_Cad += 4

   // vamos a calcular si es mas largo el texto o las opciones


   for n = 1 To Len( aOpciones )
      nLong_opc += ( Len ( aOpciones[ n ] ) + 2 )
      cOpciones += " " + If( Len( aOpciones[ n ] ) < 3,;
      " " + aOpciones[ n ] + " ", aOpciones[ n ] ) + " "
   Next
   nLong_opc := Len( cOpciones ) + 1

   if nLong_cad > nLongX .or. nLong_opc > nLongX
      if nLong_cad >= nLong_opc
	 nLongX := nLong_cad
      else
	 nLongX := nLong_opc
      endif
   Endif

   // calculamos las filas que tiene que tener el ALERT

   if nLineas > 1
      nLongY += (nLineas - 1)
      nPosYOpc += (nLineas - 1)
   end
if nPosy == 11
   nPosx -= int( nLongX / 2)
Endif
If nPosx == 38
   nPosy -= int( nLongY / 2)
Endif

   DEFINE FONT oFont NAME "Arial" SIZE 6, 15 BOLD
   DEFINE DIALOG oDlAl TITLE ( cTitle ) ;
        FONT oFont ;
	FROM nPosy, nPosx TO nPosy + ((nLongY*2)-(nLongY/2)), nPosx + nLongX OF oDlg

   @ 0.2, 0.2 BITMAP FILENAME '.\bitmaps\About.Bmp' ;
	OF oDlAl SIZE 15, 15 NOBORDER ADJUST ON LEFT CLICK MsgInfo( "Seleccione una opcin..", "Informacin" ) 

   oDlAl:Cargo := 0

   for n := 1 to nLineas
      @ n*nXpR, 4 SAY Alltrim( Memoline( OemtoAnsi( cMsg ),, n ) ) OF oDlAl
//      @ n*nXpR, 1 SAY Alltrim( Memoline( OemtoAnsi( cMsg ),, n ) ) OF oDlAl
   next

   cOpciones = Padc( cOpciones, nLongX + ( nLongX / 5 ), " " )

   for n = 1 To Len( cOpciones )
      if SubStr( cOpciones, n, 1 ) == ""  // acaba una opcin
	 AAdd( aBut, NIL )
         @ nPosYOpc*( nXtR - iif( nLineas > 10, 0.05, 0.10 ) ), (nPosOpc / 2)*nXtC BUTTON aBut[ nOpc ] ;
	    PROMPT cCad_opcion SIZE Len( cCad_opcion ) * 3.5, 12 ;
	    OF oDlAl // ACTION ( oDlAl:Cargo := GetParam( 2, 1 ),;
			//     oDlAl:End() )
   /*
         @ nPosYOpc*nXtR, (nPosOpc / 2)*nXtC BUTTON aBut[ nOpc ] ;
	    PROMPT cCad_opcion SIZE Len( cCad_opcion ) * 3.5, 12 ;
	    OF oDlAl ACTION ( oDlAl:Cargo := GetParam( 2, 0 ):Cargo,;
			     oDlAl:End() )
	 aBut[ nOpc ]:Cargo = nOpc++
	 lCogeOpcion = .F.
	 cCad_opcion = ""
      endif
     */

         aBut[ nOpc ]:bAction = GenAction( nOpc, oDlAl )

         aBut[ nOpc ]:Cargo = nOpc++
	 lCogeOpcion = .F.
	 cCad_opcion = ""

      endif

      if lCogeOpcion
	 cCad_opcion += SubStr( cOpciones, n, 1 )
      endif

      if SubStr( cOpciones, n, 1 ) == ""  // empieza una opcin
	 nPosOpc = n
	 lCogeOpcion = .T.
      end
   next
   if lCentrar
   		//oDlAl:lCentered 		//:= {|| lCentrar }
   		ACTIVATE DIALOG oDlAl CENTERED ON INIT oDlAl:SetFocus()   //endif
   else
   		ACTIVATE DIALOG oDlAl ON INIT oDlAl:SetFocus()
   endif
   oFont:End()

return oDlAl:Cargo

function GenAction( n, oDlAl )

return { || oDlAl:Cargo := n, oDlAl:End() }

 *
*************************************
function MenuRadio( cMsg, aOpc, cTit )
*************************************
   local oRad, oWnd2, oBot1, oBot2, aLista := Array( 4 ), nHorario, oRa2
   local lValor := .f., n := 0, oMin, oG1, oG2, oG3, oG4, oUser    //, nUser := 1
   local xValue := nValue, xUser := nUser, xHorario := nHorario
   local xIni1 := Ini1, xFin1 := Fin1, xIni2 := INi2, xFin2 := Fin2
   local lChg := .f.
   local bChg := { || lChg := !(xIni1 == Ini1 .and.  xFin1 == Fin1 .and. xIni2 == INi2 .and. xFin2 == Fin2 .and. ;
   	xValue == nValue .and. xUser == nUser .and. xHorario == nHorario) }
   
   DEFAULT cMsg := 'Valores: '
   DEFAULT aOpc := { 'Si', 'No', 'Ignorar', 'Cancelar' }
   DEFAULT cTit := 'Elija, por favor..'
//   DEFAULT nValue := 1
    nUser := Max( nUser, 1 )
//   nMin := aMin[ nValue ]
   aLista := AFill( aLista, '' )
   for n := 1 to len( aOpc )
          aLista[n] := OemToAnsi( aOpc[n] )
   next
   nHorario := iif( l24h, 1, 2 )

   DEFINE DIALOG oWnd2 FROM 01, 01 TO 14, 65 ;
      TITLE cTit //COLOR "N/W"
/*
   @ 0.3, 1 BUTTON oBot1 PROMPT "&Aceptar" SIZE 40, 12 OF oWnd2 ;
      ACTION ( nMin := iif( nValue < 4, aMin[ nValue ], nMin, Eval( bChg ), iif( lChg, , ) ), ;
      l24h := ( nHorario == 1 ), Eval( bSave ), Eval( bLee ), oWnd2:End() )
*/
//   @ 1.5,  1 TO 6, 35 LABEL cMsg OF oWnd2
   @ 1.5,  1 TO 6.4, 16 LABEL cMsg OF oWnd2
   @ 2.3, 2 RADIO oRad VAR nValue OF oWnd2 ;
            PROMPT aLista[1], aLista[2], aLista[3], aLista[4]
            
         //   oRad:bChange := {|| nValue := iif( nValue < 1, 1, nValue ), iif( nValue == 4,( oMin:SetFocus(), oMin:Refresh()), ) }
            	//	nMin := iif( nMin > 0, aMin[ nValue ], aDatos[ 7 ] ), oMin:Refresh() }
    
   @ 1.9, 8.9   SAY 'Listas mltiples:'  SIZE 50, 10 OF oWnd2 // COLOR CLR_HBLUE
   @ 2.3, 11.6   GET oUser VAR nUser SIZE 13, 10 OF oWnd2 VALID ;
        ( nUser > 0 .and. nUser < 20 ) PICTURE '99' 
     oUser:cToolTip := 'Para cuntos usuarios?  ( > 0 y < 21 )'
            
   //@ 4, 10   SAY OemToAnsi( 'Intervalo ( minutos )' ) SIZE 80, 12 OF oWnd2 
   @ 5.2, 11.6   GET oMin VAR nMin SIZE 13, 10 OF oWnd2 VALID ;
        ( nMin > 0 .and. nMin < 61 ) PICTURE '99' // WHEN nValue == 4
     oMin:cToolTip := 'Minutos de intervalo entre citas ( > 0 y < 61 )'
  //   oMin:bLClicked := { | nRow, nCol, nFlags |  iif( nValue == 4,( oMin:SetFocus(), oMin:Refresh()), )  }

   @ 0.2, 17 TO 6.4, 34 LABEL 'Sistema horario' OF oWnd2
   @ 1 , 22 SAY "Usar sistema de 24 horas."
   nHorario := 1
  /*
   @ 0.8, 17 RADIO oRa2 VAR nHorario OF oWnd2 ;
   ON CHANGE IIF( nHorario == 2, ;
                        MsgInfo( 'Los datos se ARCHIVARAN '+ CRLF + ;
                        'en el horario elegido' + CRLF + ;
                        'solo con CIFRAS, sin ' + CRLF + ;
                        'letra ( T ), '+ ;
                        'pero en este ' + CRLF + ;
                        'dialogo se introducen'+ CRLF + ;
                        'en formato 24 h.' ), ) ;
            PROMPT 'De &24 Horas.', OemToAnsi( '&Maana / tarde' )
*/

   @ 2.9*nXpR, 16*nXpC   SAY OemToAnsi( 'Maana->Inicio' ) SIZE 60, 12 OF oWnd2
   @ 3.8, 16   GET og1 VAR Ini1 SIZE 25, 10 OF oWnd2 VALID ;
        ( Ini1 >= 0 .and. Ini1 <= 24.00 ) PICTURE '99.99'
        oG1:cToolTip := OemToAnsi( 'Inicio maana: >= 0 y <= 24 h.' )

   @ 2.9*nXpR, 24.5*nXpC   SAY OemToAnsi( 'Final' ) SIZE 40, 12 OF oWnd2
   @ 3.8, 24.5   GET oG2 VAR Fin1 SIZE 25, 10 OF oWnd2 VALID ;
        ( Fin1 >= 0 .and. Fin1 <= 24.00  ) PICTURE '99.99'     
        oG2:cToolTip := OemToAnsi( 'Final maana: >= 0 y <= 24 h.' )

   @ 4.9*nXpR, 16*nXpC   SAY OemToAnsi( 'Tarde->Inicio' ) SIZE 60, 12 OF oWnd2
   @ 5.8, 16   GET og3 VAR Ini2 SIZE 25, 10 OF oWnd2 VALID ;
        ( Ini2 >= 0 .and. Ini2 <= 24.00 .and.  iif( Fin1 > 0, Ini2 > Fin1, Ini2 == 0 ) ) PICTURE '99.99'
        oG3:cToolTip := OemToAnsi( 'Inicio Tarde: >= 0 y <= 24 h.' )

   @ 4.9*nXpR, 24.5*nXpC   SAY OemToAnsi( 'Final' ) SIZE 40, 12 OF oWnd2
   @ 5.8, 24.5   GET og4 VAR Fin2 SIZE 25, 10 OF oWnd2 VALID ;
        ( Fin2 >= 0 .and. Fin2 <= 24.00 .and.  Fin2 > Ini2 ) PICTURE '99.99'
        oG4:cToolTip := OemToAnsi( 'Final Tarde:' + ;
                                                ' >= 0 y <= 24 h.' )
     
   @ 0.3, 1.2 BUTTON oBot1 PROMPT "&Aceptar" SIZE 50, 12 OF oWnd2 ;
      ACTION ( nMin := iif( nValue < 4, aMin[ nValue ], nMin ), ;
      l24h := ( nHorario == 1 ), Eval( bSave ), Eval( bLee ), Eval( bChg ), ;      				
      				iif( lChg .and. MsgYesNo( "Desea aplicar ya los cambios?" + CRLF + ;
      					" (se borran los datos de la fecha actual)", "Configuracin" ), ;
      							lRChange := .t., Nil ), oWnd2:End() )

   @ 0.3, 10 BUTTON oBot2 PROMPT "&Usuarios" SIZE 50, 12 OF oWnd2 ;
      ACTION iif( nUser > 0,  ;
      iif( MemoEdi2( @cUser, "Escriba en lneas sucesivas Nombres de cada uno de los " + ;
      				Alltrim( Str( nUser ) ) + " usuarios.",,,, ) , ;
      				MemoWrit( "UserAg.DAT", cUser ), ), Nil )
      oBot2:cToolTip := "Introducir nombre o ubicacin de las consultas asignadas."
      // ( nMin := iif( nValue < 4, aMin[ nValue ], nMin ), ;
//      l24h := ( nHorario == 1 ), Eval( bSave ), Eval( bLee ), oWnd2:End() )

   ACTIVATE DIALOG oWnd2 CENTER //ON PAINT nMin := aMin[ nValue ]

return nValue
*------------
*
//-----------------------------------------------------
static function SelFechas() // dIni, dFin, m_Filtro, cTit )
//-----------------------------------------------------
local oDlgEF, oGIni, oGFin, oFiltro, oBmp
local aSel, bsel, lAcept := .f.
local dIni := Ag->Fecha //Date()    //iif( Empty( SdIni ), dIni, SdIni )
local dFin := dIni      //Date()    //dFin := iif( Empty( SdFin ), dFin, SdFin )
local cTit := 'LISTADO de Agenda'
SET EXACT OFF
SET SOFTSEEK ON
//:= iif( Empty( sFiltro ), m_Filtro, sFiltro )

aSel := { dIni, dFin, lAcept }  //, m_Filtro, 'F' }

bSel := { || dIni  := MIN( dIni, dFin ), dFin  := MAX( dIni, dFin ), ;
        aSel := { dIni, dFin, lAcept } }

	   DEFINE DIALOG oDlgEF FROM 10, 10 TO 22, 57.5 ;
                TITLE   cTit + ': Elija fechas.'   

        @  1.3*nXpR, 01*nXpC SAY OemToAnsi( "Fecha inicio:" ) OF oDlgEF COLOR CLR_HRED
	@  1.3, 08 GET oGIni VAR dIni OF oDlgEF ;
		SIZE 60, 12 VALID ;
                ( Ag->( DbSeek( Dtos( dIni ) ) ), ;
		iif( Eof(), ;
                MsgStop( 'Fecha NO hallada !..' ), Nil ), ;
                !Empty( dIni ) .and. !( Ag->( Eof() ) ) ) ;
	MESSAGE OemToAnsi( "Escribir Fecha de Incio .." )

	oGIni:cToolTip := ;
		OemToAnsi( "Escribir Fecha de Incio (DD/MM/AAAA).." ) 

        @ 2.8*nXpR, 01*nXpC SAY OemToAnsi( 'Fecha Final:' ) OF oDlgEF COLOR CLR_HRED
	@ 2.8, 08 GET oGFin VAR dFin OF oDlgEF ;
		SIZE 60, 12 VALID ( !Empty( dFin ) .and. ;
                iif( dFin - dIni > 365, ;
                ( MsgAlert( 'NO DEBE pasar de 365 dias ..' ), .t. ), .t. ) ) ;
	MESSAGE OemToAnsi( "Escribir fecha final .." )
	oGFin:cToolTip := ;
		OemToAnsi( "Escribir fecha final (DD/MM/AAAA).." )

   @  4, 7 BUTTON "&Aceptar"  ;
      ACTION ( lAcept := .t., Eval( bSel ), oDlgEF:End() ) ;
			 OF oDlgEF SIZE 40, 12 ;
	MESSAGE 'Aceptar las fechas actualmente elegidas ..'

   @  4, 15 BUTTON  "&Cancelar"  OF oDlgEF         ;
      ACTION ( oDlgEF:End() ) SIZE 40, 12 ;
	MESSAGE 'Salir sin acceder al libro de ingresos ..'

   @ 0, 0  BITMAP oBmp ;
                FILE ".\bitmaps\BPRnRecet.bmp"  OF oDlgEF NOBORDER ;
                SIZE 14, 14 ADJUST ;
                ON LEFT CLICK MsgAlert( 'WOCAG.EXE ' + CRLF + ;
                'Dialogo de elegir fechas' + ;
                CRLF + 'para IMPRIMIR .. ' ) ;
                ON RIGHT CLICK oDlgEF:HardCopy( 4, .f. )
                oBmp:cToolTip := 'Clic Dcho. = Imprimir ventana'
                  //Logotipo imprimir TEXTOS'

	   ACTIVATE DIALOG oDlgEF CENTERED 

//oDlgEF:Destroy()
//SET EXACT ON
//SET SOFTSEEK OFF

Return aSel
*----------
*
*
***************************************************************************
static function funindex(bqbase, bqcampos, bqindice, nVeces, nEl, oDlgInd,;
				nFila, nColumna, oFont )
***************************************************************************
   local nActual := 0, oMeterNw
   local DateBase := directory( bqbase  ), DateIndex := directory( bqindice )
   MEMVAR cBase, cIndice, cCampos

DEFAULT nFila    := 15
DEFAULT nColumna := 1.5	//2	//6.5

cBase   := bqbase
cIndice := bqindice
cCampos := bqcampos

DbCloseAll()

if !File( cBase )

        if at( Upper( Left( "&cBase", 2 ) ), 'DABG' ) == 0
                MsgStop( 'Fichero: ' + "&cBase" + CRLF + 'No encontrado !.' )
                MsgBeep()
        endif
       
        Return Nil
endif

cBase := Left( cBase, at( '.', cBase ) -1 )   // Se suprime .DBF p la llamada

usa_base( "&cBase", .t., "", 5 )

   @ nFila, nColumna METER oMeterNw ;
		     VAR nActual  FONT oFont SIZE 230, 14 ;
		     TOTAL LastRec() OF oDlgInd UPDATE
   
   INDEX ON &cCampos TO "&cIndice"  ;
      EVAL ( oMeterNw:Set( RecNo() ), SysRefresh() )

DbCloseArea()

oMeterNw:End()

usa_base( "&cBase", .f., "Ag1", 5, .t. )

memory( -1 )

oDlgInd:Update()

return( nil )
*------------
*
***********************
function appe_reg(nseg) && rutina q controla todas las llamadas en red a
			  && append blank
***********************

if addrec( nseg )
   
else
   quit
endif

return .t.
*---------
*
**********************
function desbloq(nseg) && rutina q controla todas las llamadas en red a
		    && desbloqueo de ficheros previo vaciado
**********************

dbcommitall()           // Garantizando la actualizacion del registro
DbGoto( Recno() )
dbunlockall()

return .t.
*---------
       
Static Function Calendar( oLbx, xdate )
local oFont, oDlg, lAcept := .f., aDat := { Date(), .f. }
local aColor:= { 'GR+/BG', 'GR+/BG', 'GR+/BG', 'GR+/BG', 'GR+/BG', ;
                                              'GR+/BG', 'R+/BG'}
local n, bFecha, lSeguir := .t., lCrea := .t., Ob1, Ob2
local cColor, v := 1, aBmp := Array( 42 ), aHoja := Array( 42 ), x
local cFBmp, bBmpAct, nI, bGest
local oFon2, lCenter, lNoBorde, hDC, nClrTxt, nClrBack, cFileBmp
local lStrecht, bLoad, memayd := 'Ayuda', meminf := 'Info', bClick1, bClick2
//local bPreg, bAyud, lPreg := .f., cAyud := ''

DEFAULT xDate := Date()
lin4 := cok := n := 0
AFILL( aHoja,'' )
AFILL( aBmp, Nil )

aDias := { '  Lun  ', '  Mar  ', '  Mie  ', '  Jue  ', ;
                                        '  Vie  ', '  Sab  ', '  Dom  ' }
      bBmpAct := {|x| ni := x, MsgInfo( nI ) }
      aActions := Array( 42 )
      aFILL( aActions, {|| Nil } )

mFecha := xDate //Date() 
      lin1 = day(mfecha)
      lin2 = month(mfecha)
      lin3 = year(mfecha) 
 
bFecha := {|| x := mFecha, ;
      diauno := ctod("01/"+str(lin2,2)+"/"+str(lin3,4)),;
      finmes := val(substr(udmes,(month(mfecha)*2)-1,2)),;
      lin1   := Min( lin1, finmes ),;
      mFecha := ctod( str(lin1,2)+"/"+str(lin2,2)+"/"+str(lin3,4)),;
        iif( !Empty( mfecha ) .and. mFecha != x, ( ;
        Tone( 1200, 2 ), Eval( bGest, .f. ) ), ;
        ( Tone( 800, 2 ), mFecha := x ) ) }
                        // .f. = Reacargar

      aMeses := { 'Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', ;
         'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', ;
         'Noviembre', 'Diciembre' }
      nmes := "Enero     Febrero   Marzo     Abril     Mayo      Junio   "+;
	"  Julio     Agosto    SeptiembreOctubre   Noviembre Diciembre "
      udmes := "312831303130313130313031"
      nombremes = substr(nmes,(month(mfecha)*10)-9,10)
      nombremes := aMeses[ month( mFecha ) ]
      nYear := Year( mFecha )
 
   DEFINE FONT oFont NAME "Arial" SIZE 0, -12 BOLD  //6, 13 BOLD
   DEFINE FONT oFon2 NAME "Arial" SIZE 0, -14 BOLD  //6, 13 BOLD

   DEFINE DIALOG oDlg FROM 3, MaxCol() -40 TO 26, MaxCol()-2 TITLE ;
   'CALENDARIO de  Wocul3.Exe' //FONT oFont
   oDlg:SetFont( oFont )

   @ 0.2, 2 COMBOBOX oSmes VAR nombremes ITEMS aMeses ;
          OF oDlg SIZE 60, 55 COLOR 'W/GR+' ;
          ON CHANGE ( lin2 := Ascan( aMeses, nombremes ), Eval( bFecha ) ) ;
          MESSAGE 'Meses - Desplazarse en la lista y elegir ..' 
          oSmes:cToolTip := 'Teclas: Home, End, AvPg, RePg'

      nombremes = substr(nmes,(month(mfecha)*10)-9,10)
      nombremes := aMeses[ month( mFecha ) ]
      nYear := Year( mFecha )
      lin1 = day(mfecha)
      lin2 = month(mfecha)
      lin3 = year(mfecha) 


   @ 0.3, 9.8 GET oSano VAR nYear SIZE 55, 10 OF oDlg;  //COLOR 'W/GR+'
             VALID ( lin3 := nYear, Eval( bFecha ), .t. )

For n := 1 to 7
    @ 1.1*nXpR,  n*2*nXpC  SAY aDias[ n ] COLOR aColor[ n ] OF oDlg SIZE 22.5, 10
next   

bClick1 := { || ;
        aBmp[01]:bLClicked := {|| lin1 := aActions[01], Eval( bFecha ) }, ;
        aBmp[02]:bLClicked := {|| lin1 := aActions[02], Eval( bFecha ) }, ;
        aBmp[03]:bLClicked := {|| lin1 := aActions[03], Eval( bFecha ) }, ;
        aBmp[04]:bLClicked := {|| lin1 := aActions[04], Eval( bFecha ) }, ;
        aBmp[05]:bLClicked := {|| lin1 := aActions[05], Eval( bFecha ) }, ;
        aBmp[06]:bLClicked := {|| lin1 := aActions[06], Eval( bFecha ) }, ;
        aBmp[07]:bLClicked := {|| lin1 := aActions[07], Eval( bFecha ) }, ;
        aBmp[08]:bLClicked := {|| lin1 := aActions[08], Eval( bFecha ) }, ;
        aBmp[ 9]:bLClicked := {|| lin1 := aActions[09], Eval( bFecha ) }, ;
        aBmp[10]:bLClicked := {|| lin1 := aActions[10], Eval( bFecha ) }, ;
        aBmp[11]:bLClicked := {|| lin1 := aActions[11], Eval( bFecha ) }, ;
        aBmp[12]:bLClicked := {|| lin1 := aActions[12], Eval( bFecha ) }, ;
        aBmp[13]:bLClicked := {|| lin1 := aActions[13], Eval( bFecha ) }, ;
        aBmp[14]:bLClicked := {|| lin1 := aActions[14], Eval( bFecha ) }, ;
        aBmp[15]:bLClicked := {|| lin1 := aActions[15], Eval( bFecha ) }, ;
        aBmp[16]:bLClicked := {|| lin1 := aActions[16], Eval( bFecha ) }, ;
        aBmp[17]:bLClicked := {|| lin1 := aActions[17], Eval( bFecha ) }, ;
        aBmp[18]:bLClicked := {|| lin1 := aActions[18], Eval( bFecha ) }, ;
        aBmp[19]:bLClicked := {|| lin1 := aActions[19], Eval( bFecha ) }, ;
        aBmp[20]:bLClicked := {|| lin1 := aActions[20], Eval( bFecha ) } }

bClick2 := {|| ;
        aBmp[21]:bLClicked := {|| lin1 := aActions[21], Eval( bFecha ) }, ;
        aBmp[22]:bLClicked := {|| lin1 := aActions[22], Eval( bFecha ) }, ;
        aBmp[23]:bLClicked := {|| lin1 := aActions[23], Eval( bFecha ) }, ;
        aBmp[24]:bLClicked := {|| lin1 := aActions[24], Eval( bFecha ) }, ;
        aBmp[25]:bLClicked := {|| lin1 := aActions[25], Eval( bFecha ) }, ;
        aBmp[26]:bLClicked := {|| lin1 := aActions[26], Eval( bFecha ) }, ;
        aBmp[27]:bLClicked := {|| lin1 := aActions[27], Eval( bFecha ) }, ;
        aBmp[28]:bLClicked := {|| lin1 := aActions[28], Eval( bFecha ) }, ;
        aBmp[29]:bLClicked := {|| lin1 := aActions[29], Eval( bFecha ) }, ;
        aBmp[30]:bLClicked := {|| lin1 := aActions[30], Eval( bFecha ) }, ;
        aBmp[31]:bLClicked := {|| lin1 := aActions[31], Eval( bFecha ) }, ;
        aBmp[32]:bLClicked := {|| lin1 := aActions[32], Eval( bFecha ) }, ;
        aBmp[33]:bLClicked := {|| lin1 := aActions[33], Eval( bFecha ) }, ;
        aBmp[34]:bLClicked := {|| lin1 := aActions[34], Eval( bFecha ) }, ;
        aBmp[35]:bLClicked := {|| lin1 := aActions[35], Eval( bFecha ) }, ;
        aBmp[36]:bLClicked := {|| lin1 := aActions[36], Eval( bFecha ) }, ;
        aBmp[37]:bLClicked := {|| lin1 := aActions[37], Eval( bFecha ) }, ;
        aBmp[38]:bLClicked := {|| lin1 := aActions[38], Eval( bFecha ) }, ;
        aBmp[39]:bLClicked := {|| lin1 := aActions[39], Eval( bFecha ) }, ;
        aBmp[40]:bLClicked := {|| lin1 := aActions[40], Eval( bFecha ) }, ;
        aBmp[41]:bLClicked := {|| Nil }, ;
        aBmp[42]:bLClicked := {|| Eval( bAyud ) }       }

  bGest := {| lVal | lCrea := lVal, ;
      lin1 := day(mfecha),;
      lin2 := month(mfecha),;
      lin3 := year(mfecha)   ,;
      finmes := val(substr(udmes,(month(mfecha)*2)-1,2)),;
      nombremes := aMeses[ month( mFecha ) ],;
      nYear := Year( mFecha )               ,;
     oSmes:SetText( nombremes ),;
     oSano:SetText( cValToChar( Year( mFecha ) ) ),;
     oSano:Refresh(), oSmes:Refresh(), ;
     iif( lin2 == 2,;        // bisiesto finmes
         iif(  Day( CtoD( '29/02/' + AllTrim( Str( lin3, 4 ) ) ) ) > 0,;
            finmes := 29, Nil ), Nil ),;
      diauno := ctod("01/"+str(lin2,2)+"/"+str(lin3,4)),;
      dise := cdow(diauno),;      // Nombre del dia semana
      numdia := Dow( DiaUno ),;   // Numero del dia semana
      numdia := iif( numdia == 1, 7, numdia-1 ),;
      numdia := iif( finmes < 30 .and. numdia < 3, numdia + 7, numdia ),;
  hDC := GetDC(),;
  lCenter := .t.  ,;
  lNoBorde := .t. ,;    // NOBORDER
  lStrecht := .f. ,;    // ADJUST
  lin  := 1.7     ,;    // Linea de ventana
  lin4 := 0       ,;    // Contador dias semana
  nI   := 0       ,;    //FOR nI := 1 to 35 // Se crean los objetos por omision ''
  AFILL( aActions, {|| Nil } ),;
  aEval( aActions, {|c,nitem| ;
      lin4 ++, nI ++           ,;
      iif( lin4 > 7, (lin4  := 1, lin ++ ), Nil )        ,;
      aHoja[nI] := iif( nI > 41, '.\bitmaps\XDiax1.Bmp',;
        (".\bitmaps\" + ;
        iif( nI < numdia .or. nI > finmes+(numdia-1), 'Z', ( ;
        iif( lin4 == 7,  iif( nI-(numdia-1) == Day(mFecha), "D", "R" ), ;
        iif( nI -(numdia-1) == Day( mFecha ), "B", ;
        iif( nI-(numdia-1) == Day(Date()), "Q", "N" ) )) ) ) + "DIA" + ;
        iif( nI < numdia .or. nI > finmes+(numdia-1), '', ;
                                Alltrim(Str(nI-(numdia-1)) )) + ".BMP" )),;
        cFileBmp := aHoja[nI]   ,;
        aActions[nItem] := iif( nI < numdia .or. nI > finmes+(numdia-1), ;
         lin1, (nI-(numdia-1)) ), ;
   iif( lCrea, ( aBmp[nI] := TBitMap():New( 0.4+lin*1, 0.2+lin4*2.1, 15, 15, ;
      , cFileBmp, lNoBorde, oDlg, ,,, ;
        lStrecht  ) ), ;                      // Creacion
        aBmp[nI]:LoadBmp( cFileBmp )  ) } ), ;     // Recargar
         Eval( bClick1 ), Eval( bClick2 ), ;
         Ag->( DbSeek( Dtos(mFecha) ) ), oLbx:Refresh()   }

   Eval( bGest, .t. )   // Creacion
      
   @ 8, 04 BUTTON '&Mes +' ;
   ACTION ( iif( lin2 == 12, ( lin2 :=1, lin3++ ), lin2++ ), ;
        Eval( bFecha ) )

   @ 09.2,  04 BUTTON 'M&es -' ;
   ACTION ( iif( lin2 == 1, ( lin2 := 12, lin3-- ), lin2-- ), ;
           Eval( bFecha ))      //, lin1, lin2, lin3 ))

   @ 8, 16 BUTTON OemToAnsi( '&Ao +' )  ;
   ACTION ( lin3 ++, Eval( bFecha ))    //, lin1, lin2, lin3 ) )

   @ 09.2,  16 BUTTON OemToAnsi( 'A&o -' ) ;  //SIZE 60, 10
   ACTION ( lin3--, Eval( bFecha ))     //, lin1, lin2, lin3 ) )

   @ 10.5, 02 BUTTON oB1 PROMPT '&Salir'   ACTION ;
        ( mFecha := xDate, oDlg:End() ) SIZE 60, 10
   oB1:cToolTip := 'Salir, sin modificar fecha..'

   @ 10.5, 14.5 BUTTON oB2 PROMPT '&Aceptar' SIZE 60, 10 ACTION ;
        ( lAcept := .t., oDlg:End(), ;
        iif( Ag->( DbSeek( DtoS( mFecha ) ) ), Nil,;
          iif( MsgYesNo( 'Fecha: ' + cValToChar( mFecha ) + CRLF + ;
             'Va a ser CREADA ..!'+ CRLF + CRLF + 'CONFORME?..' ),;
             ( Eval( bCrea, mFecha ),;
             Ag->( DbSeek( Dtos( mFecha ) ) ),;
             oLbx:Refresh() ), Nil ) ))

   oB2:cToolTip := 'Sale y: Busca / Crea, la fecha que marca el almanaque'

//   oDlg:bRClicked := {|| oDlg:Minimize() }
   oDlg:cToolTip  := 'Esc. -> Cerrar ..'        //CLICK DERECHO -> MINIMIZA ..'

   ACTIVATE DIALOG oDlg ;                       // NOWAIT CENTERED
                            ON PAINT ;
                                Rectangle( hDC, 52, 30, 230, 270 )

   oFont:End()

   Ag->( DbSeek( Dtos( mFecha ) ) )

   oLbx:Refresh() 

return mFecha   //iif( lAcept, mFecha, xDate )
              
static function FileCons( oLbx )
   local cTxt := '', cFile := 'AGENDA.DIA'

   mFecha :=  Ag->Fecha
   Ag->( DbSeek( Dtos( mFecha ) ) )
   Do While Ag->Fecha == mFecha .and. !Eof()
        cTxt += AllTrim( Str( Ag->Hora ) ) + ' - ' + ;
                                   MemoTran( Ag->Texto, '', '' ) + ' - ' + Ag->Notas + CRLF
//        cTxt += Str( Ag->Hora ) + Ag->Texto + CRLF
//        cTxt += Ag->Texto + CRLF
        Ag->( DbSkip() )
   EndDo

   MemoWrit(  cFile, cTxt )
   IF File( cFile ) .and. !( lAlt )
         MsgInfo( 'Archivo: ' + cFile + CRLF + 'SI Creado' )
   endif

   Ag->( DbSeek( Dtos( mFecha ) ) )
   if !Empty( oLbx )
       oLbx:Refresh()
   endif

return nil
 
**************************
function addrec(numsegesp)      // Crea nuevo registro 
**************************
local mientras, tiempo_espera, reiniciar,ca10,cresp

dbappend()     
if .not. neterr()
   return .t.
endif

reiniciar = .t.
mientras  = (numsegesp = 0)

do while reiniciar = .t.
   
   tiempo_espera = numsegesp
   do while (mientras .or. tiempo_espera > 0)
      
      dbappend() 
      if .not. neterr()
	 return .t.
      endif
      
      inkey(.5)                     && Espera 1/2 segundo.
      tiempo_espera = tiempo_espera - .5
      
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Registro NO se ha creado."
   cresp := fallo_acc('',ca10)
   // reiniciar := resp5
   if cresp # "R"
      exit
   endif
   
   
enddo

return .f.
*---------
*
***************************
function fillock(numsegesp)  // bloquea un fichero - Red
***************************

local mientras, tiempo_espera, reiniciar,ca10,cresp

if flock()
	 return .t.                 && Bloqueo correcto.
endif

reiniciar = .t.
mientras  = (numsegesp = 0)

do while reiniciar = .t.
   
   tiempo_espera = numsegesp
   do while (mientras .or. tiempo_espera > 0)
      
      inkey(2)                     && Espera 1/2 segundo.
      tiempo_espera = tiempo_espera - 2
      
      if flock()
      endif
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Fichero NO bloqueado .." 
   cresp := fallo_acc('',ca10)
   //reiniciar := resp5
   if cresp # "R"
      exit
   endif
   
   
enddo

return (.f.)
*-----------
*
***************************
function reclock(numsegesp)
***************************

local mientras, tiempo_espera, reiniciar,ca10,cresp

if rlock()
   return .t.
endif

reiniciar = .t.
mientras  = (numsegesp = 0)

do while reiniciar = .t.
   
   tiempo_espera = numsegesp
   do while (mientras .or. tiempo_espera > 0)
      
      if rlock()
	 return .t.                 && Bloqueado.
      endif
      
      inkey(.5)                     && Espera 1/2 segundo.
      tiempo_espera = tiempo_espera - .5
      
   enddo
   
   * Fall el intento, pregunta al usuario si
   *  lo reintenta.
   *
   ca10 = "Registro NO bloqueado .. "
   cresp := fallo_acc('',ca10)
//   reiniciar := resp5
   if cresp # "R"
      exit
   endif
   
enddo

return .f.

//************************************         
function fallo_acc( basededato, ca10 )
//************************************          
local  aopciones := {  "&Reintentar ", "&Interrumpir" }
local  cresp := ""  // Alert( ca10, aopciones, 'Atencin !.' )  //, resp5
local nI := Alert2( ca10, aOpciones, 'DIALOGO de RED !..' )
 if nI == 1
    cResp := "R" 
 //   cresp := iif( cresp == 1, "R", "I" )
else
   MsgWait( "El programa se cerrar...", "Wocul3.Exe", 1.5 )
   QUIT
endif
//resp5 = .t.
return( cresp )
//------------

 *   
  // rutina q controla todas las llamadas a bases e indices
***********************************************************
function usa_base( baseusa, uso, indices, numseg, areacero)
***********************************************************
local desde := 0, i
local aBases := aGetWorkAreas(), cText := ''
local nArea := SELECT(), cAreaUso := ALIAS( nArea )
local cDrive := '.' + LEFT( DBSETDRIVER(), 3 )

MEMVAR  ind1, ind2, ind3, ind4, mindn, indn
ind1 := ind2 := ind3 := ind4:= Space( 0 )

baseusa := Upper( baseusa )
baseusa := cFileNoExt( baseusa )
if !File( baseusa + cDrive )
      // ? 222222222222222222222222
        MsgInfo( 'BASE: ' + baseusa + CRLF + 'NO ENCONTRADO ..' )
	QUIT
endif
//MsgInfo( 'Abrir: ' + baseusa )
if !( uso ) .and. ;
	Ascan( aBases, { | x | Upper(AllTrim(x)) == AllTrim(baseusa) } ) > 0 
				// Si la base ya esta abierta,
	DbSelectArea( BaseUsa ) // se selecciona y se sale sin tener q abrirla
else

if ( abrebase( baseusa, uso, numseg, areacero ) )
   if !empty( indices )

      for i = 1 to 4
	 
         indices := AllTrim( indices )
	 desde = at( ",", indices )

         indn = "ind" + alltrim( str( i ) )
         mindn := ''

	 if desde > 0
            mindn = left(indices,len(indices)-len(substr(indices, desde )))
            &indn := AllTrim( mindn )   //to &indn
            // store AllTrim( mindn ) to &indn
            indices = Alltrim( substr( indices, desde + 1 ) )
	    
	 else
	    
	    mindn = alltrim( indices )
	    store mindn to &indn
	    indices = ""
	    exit
	    
	 endif
	 
      next
      
      set index to &ind1, &ind2, &ind3, &ind4
   endif
else
   quit
endif

endif   // De si estaba o no en uso la base llamada ..

release all like ind*
release mindn

return(baseusa)
*---------------
*
***********************
function bloq_reg(nseg) && rutina q controla todas las llamadas en red a
			  && bloqueo de registros
***********************

if reclock( nseg )
   dbgoto( recno() )
else
   quit
endif

return .t.
*---------
*
* 
***********************
function bloq_fil(nseg) && rutina q controla todas las llamadas en red a
		    && bloqueo de ficheros
***********************

if fillock( nseg )
   
else
   quit
endif

return .t.
*---------
*******************************************
static Function PrnStart( cName, lPreview, lUser )
*******************************************
local xR, xC, xBV, xBH

DEFAULT cName    := "Impreso"
DEFAULT lPreview := .t.
DEFAULT lUser    := .t.

//lMeta := lPreview

memory( -1 )

if !Empty( oPrn )
         oPrn:End()      // cerrar, si esta abierto
endif

oPrn := TPrinter():New( cName, lUser, lPreview )

      if Empty( oPrn:hDC )
	 MsgStop( OemToAnsi( "Impresora no preparada !" ) )
	 oPrn := ''     //return nil
      else

	xR  := oPrn:nVertRes() / 1683   // La referencia es la resolucion
	xC  := oPrn:nHorzRes() / 1920   // epson fx-850 para unas coordenadas
					// modelo obtenidas para textos

	xBV := oPrn:nVertRes() / 3982   // La referencia es la resolucion
	xBH := oPrn:nHorzRes() / 2880   // epson STYLUS COLOR para coordenadas

      endif
Return oPrn
*----------
*
//------------------------
Static Function OutPrint( lPrev )
//------------------------

           if lPrev
		oPrn:Preview()
	   else
		oPrn:End()
	   endif

	oPrn := Nil

Return Nil
//--------
// function CurDrive( x )

// return HB_CurDrive( x )
//
**********************************************************
Function PrnLista( listado, cTitulo, nAltoFon, lVerLista )
**********************************************************
local nRow := 20, nCol := 20, oFont2, cBase
Local nI := 1, nItem, cFileAsc, oAsc, oWn := '', lVacio := .f., lHay := .f.
local aBases := aGetWorkAreas(), cText := '', cNom := '', cLine := '', n := 0
local nArea  := SELECT(), cAreaUso := ALIAS( nArea ), lPrev := .t.

DEFAULT listado  := {}
DEFAULT cTitulo  := 'Listado'
DEFAULT nAltoFon := 16
DEFAULT lVerLista := .t.        // Ver en FWRiteW todos excepto desde Verde2

if ValType( lVerLista ) != 'L'
	lVerLista := .f.
endif

if !Empty( aBases )
	aEval( aBases, { | cEl, nEl | ;
		cText += Upper( cEl ) + CRLF } )

	if AT( 'LIS_RED', cText ) > 0
		lHay := .t.
	endif
endif

cNom     := iif( lHay, cValToChar( Lis_red->( RecNo() ) ), '0' )
cBase    := 'ARRAY'

nItem := Len( Listado )

if nItem == 0
	MsgStop( 'No Hay Lineas para imprimirlas !.' )
	Return Nil
endif

//if Empty( oPrn := PrnStart( cTitulo, .f., .f. ) )
  //       return nil
//endif

if lVerLista

     cFileAsc  := cBase + PADL( alltrim( cNom ), 7, "0" )
     cFileAsc += ".MHL" // Mascara para autoborrado .. 
     if File( cFileAsc )
	Ferase( cFileAsc )
     endif
     oAsc     := TTxtFile():New( cFileAsc )
     if oAsc:Open()
	oAsc:Add( cTitulo )
	oAsc:Add( '________________________________________________________' )

	For nI := 1 to nItem
	  if ValType( listado[ nI ] ) == "A" .and. Len( listado[ nI ] ) > 1
		cLine := ''
		For n := 1 To Len( listado[ nI ] )
			cLine += cValToChar( Listado[ nI, n ] ) + ' '
		Next
		if Len( cLine ) < 71
			oAsc:Add( AnsiToOem( cLine ) )
		else
		   For n := 1 To Len( listado[ nI ] )
			oAsc:Add( AnsiToOem( cValToChar( listado[ nI ] ) ) )
		   Next
		endif
	  else
		oAsc:Add( AnsiToOem( cValToChar( listado[ nI ] ) ) )
	  endif
	Next

	oAsc:Close()
 //       CargarFich( cFileAsc, cTitulo,,,, oWn, cBase )
//      PrnReceta( cFileAsc, , 0, oWn, , , , cBase, , ,lVacio )
	Ferase( cFileAsc ) // por si aqui se borra receta?
     endif

else

if Empty( oPrn := PrnStart( cTitulo, .f., .f. ) )
	 return nil
endif

       DEFINE FONT oFont2 NAME "Normal"   SIZE 16, 10 OF oPrn BOLD      //0, 12 OF oPrn 

nAltoFon := oFont2:nHeight
//nAltoFon := oPrn:nVertRes() / 70   // La referencia es la resolucion
oPrn:StartPage()

	oPrn:Say( nRow, nCol, cTitulo )
	nRow += 4 + nAltoFon
        oPrn:Say( nRow, nCol, Replicate( "_", Len( cTitulo ) ) )
	nRow += 4 + nAltoFon
	nRow += 4 + nAltoFon    // 1 Linea vacia 

For nI := 1 to nItem
	  if ValType( listado[ nI ] ) == "A" .and. Len( listado[ nI ] ) > 1
		cLine := ''
		For n := 1 To Len( listado[ nI ] )
			cLine += cValToChar( Listado[ nI, n ] ) + ' '
		Next
	  else
		cLine := cValToChar( listado[ nI ] )
	  endif
		Listado[ nI ] := cLine

	oPrn:Say( nRow, nCol, AllTrim( Listado[ nI ] ) )
	nRow += 4 + nAltoFon
		if nRow > 70 * nAltoFon  // N de lneas x Alto caracter
		       nRow = 1                // Tendremos que calcular el
		       oPrn:EndPage()        // nmero de lneas que podemos
		       oPrn:StartPage()   // utilizar con un font determinado
		endif

Next

oPrn:EndPage()

//oPrn:End()
OutPrint( lPrev )

oFont2:End()

endif

return nil
*---------
*
#include "FiveWin.ch"
#include "richedit.ch"
#include "fget.ch"


//----------------------------------------------------------------------------//

function MemoEdi2( cText, cTitle, nTop, nLeft, nBottom, nRight )

   local oFont, oDlg, oMemo, oBtnOk, oBtnCancel, oBtnHelp
   local hDLL
   local uTemp := ''
   local lRich := .f., lGTF := .f., lOk   := .f.

   DEFAULT nTop := 9, nLeft := 9, nBottom := 23, nRight := 68.5,;
           cTitle := "MemoEdit"

   DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -10

   DEFINE DIALOG oDlg FROM nTop, nLeft TO nBottom, nRight ;
      TITLE cTitle FONT oFont

   if IsRTF( cText )
      lRich := .t.
      hDLL  := LoadLibrary( 'riched20.dll' )
      @ 4, 3 RICHEDIT oMemo VAR uTemp OF oDlg PIXEL SIZE 100,100
   elseif IsGTF( cText )
      lGTF  := .t.
      uTemp := cText
      @ 4, 3 FORMAT GET oMemo VAR uTemp OF oDlg PIXEL SIZE 100,100
   else
      uTemp := cText
      @ 4, 3 GET oMemo VAR uTemp MEMO OF oDlg PIXEL SIZE 100, 100 FONT oFont
      oMemo:bGotFocus = { || oMemo:SetSel( 0, 0 ) }
   endif


   @ 110,  90 BUTTON oBtnOk PROMPT "&Aceptar" SIZE 36, 13 PIXEL ;
      ACTION ( If( lRich, cText := oMemo:SaveAsRTF(), cText := uTemp ), ;
               lOk := .t., oDlg:End() )

   @ 78, 134 BUTTON oBtnCancel PROMPT "&Cancelar" SIZE 36, 13 PIXEL ;
      ACTION oDlg:End()

   // @ 78, 176 BUTTON oBtnHelp PROMPT "&Help" SIZE 36, 13 PIXEL ;
   //   ACTION HelpTopic()

   ACTIVATE DIALOG oDlg CENTERED ;
      ON INIT (  ;
                oMemo:SetSize( oDlg:nWidth() - 17, oDlg:nHeight() - 77 ),;
                If( lRich, ( oMemo:SetText( cText ) ), If( !lGTF, oMemo:SetSel( 0,0 ), nil ) ), ;
                oBtnOk:nTop      := oDlg:nHeight() - 64,;
                oBtnOk:nLeft     := oDlg:nWidth() - 250,;
                oBtnCancel:nTop  := oDlg:nHeight() - 64,;
                oBtnCancel:nLeft := oDlg:nWidth() - 167 )
//                oBtnHelp:nTop    := oDlg:nHeight() - 64,;
  //              oBtnHelp:nLeft   := oDlg:nWidth() -  84 )


   oFont:End()

   if hDLL != nil
      FreeLibrary( hDLL )
   endif

return lOk

//----------------------------------------------------------------------------//


procedure AppSys  // Xbase++ requirement

return
