// Special sample built for a customer
#include "report.ch"
#include "FiveWin.ch"
#include "richedit.ch"
#include 'ord.ch'
#include "InKey.ch"
#include 'xbrowse.ch' 

#define D_WIDTH           4 
#define D_HEIGHT          13 
#define GO_UP       1
#define GO_DOWN     2
#define GO_LEFT     1
#define GO_RIGHT    2

#command @ <row>, <col> SAY <sayxpr>                                    ;
                        [<sayClauses,...>]                              ;
                        GET <var>                                       ;
                        [<getClauses,...>]                              ;
                                                                        ;
      => @ <row>, <col> SAY <sayxpr> [<sayClauses>]                     ;
       ; @ ATail( oDlg:aControls ):nTop, ATail( oDlg:aControls ):nRight + 5 ;
         GET <var> [<getClauses>] PIXEL ; ATail( oDlg:aControls ):Set3DLook( .t. )

static aL := {}, aLista, aValues, aGExpl, aGPer, cFileUso := ".\GETDT\WocGetDt.Txt", ;
																				aGf := { -15, -10, -10, -10, -10, -10, -10, -10, -11  }, bFon, bSv
static bFechas, cMemo := "", lValid := .f., lFech := .f., lListado := .f., lExcluir := .f. , cVal := "                    ", nRad := 1
static nRGr := 1, aP2, lCerrar := .f., lSinMss := .f., oReport, aFont, oBot, oWnd, aFiltrados := {}, lVacio := .f., nInf := 0
static aSay, aSExpl, aUsados := {}, oProc, bProc, nCons := 0, lArray := .f., aInf := {}, nColor := 0, nSel := 0, cBasico := ""
static lSexos := .f., lCiudades := .f., lNombres := .f., aListado := {}, aDatCels := {}, aDatCels2 := {}, aDatCels3 := {}, ;
						aN3 := {}

function Main()

   local oDlg, nAncho, nAlto, cSize, bSvCoors, bSize, cTit := "Filtrado de datos y patologas de Pacientes. (Listados y grficas)"
   local bCoors, cFCoors := "FILTORDS.DAT", bCoorSv, bCoorLee, aCoors, cMemoCoors, bRect, aGr, c2
   
SET _3DLOOK ON
SET DATE BRITISH
SET CENTURY ON

SET MULTIPLE ON

SetBalloon( .t. )  // tooltips mas modelados, aunque salen para arriba y estorban un poco
aFont := Array( 9 )
cVal := Trim( MemoRead( "FILTCONF.DAT" ) ) + Space( 20 )
lExcluir   := ( SubsTr( cVal, 1, 1 ) == "S" )
nRad       := Val( SubsTr( cVal, 2, 1 )  )
nRad       := Max( nRad, 1 )
lSinMss  := ( SubsTr( cVal, 3, 1 ) == "S" )
nRGr       :=  Val( SubsTr( cVal, 4, 1 )  )
nRGr       := iif( nRGr == 0, 1, nRGr )
lSinMss  := ( nRGr == 2 )
if !File( "HISTORIC.DBF" ) .or. !File( "PACIENTE.DBF" )
      MsgWait( "WOCGET.EXE no est en " + CRLF + "la carpeta de la consulta", "`Aviso!", 2 )
      Return Nil
endif 
if File( "GETFONT.DAT" ) .and. !File( "FILTFONT.DAT" )
		LZCopyFile( "GETFONT.DAT", "FILTFONT.DAT" )
		FERASE( "GETFONT.DAT" )
endif
            // Coordenadas ..
    cSize := MemoRead( "FILTSIZE.DAT" )
    if MLCount( cSize ) >= 2
             nAncho := Int( Max( nAncho, Val( Trim( MemoLine( cSize, , 1 ) ) ) )*0.984 )
             nAlto     := Int(Max( nAlto,      Val( Trim( MemoLine( cSize, , 2 ) ) ) )*0.95 )
    endif
//    bSvCoors := {|| Memowrit( "FILTSIZE.DAT", AllTrim( Str( oDlg:nWidth() ) ) + CRLF + ;
  //  														AllTrim( Str( oDlg:nHeight() ) ) ) }        
//   Eval( bSvCoors )
   
   aCoors := Array( 4 )    
   bCoorSv := {||  ;
        MemoWrit(  cFCoors,  Str( ( oDlg:nTop ) ) + CRLF + ;
        Str( ( oDlg:nLeft ) ) + CRLF + ;
        Str( ( oDlg:nBottom ) ) + CRLF + ;
                 Str( ( oDlg:nRight  ) ) ) }
    
    bCoorLee := {|| ;
         cMemoCoors := Trim( MemoRead( cFCoors ) ),;
         cMemoCoors := iif( MLCount( cMemoCoors ) > 3,;   // Valor valido // En caso de error, valor original.. q s  establece en cada entrada
     cMemoCoors,  AllTrim( Str( 8*16 ) ) + CRLF + AllTrim( Str( 20*8 ) ) + CRLF + ;
  				                 AllTrim( Str( 35*16 ) ) + CRLF + AllTrim( Str( 100*8 ) ) ), ;  // msginfo( cMemocoors, str(MLCount( cMemoCoors )))
                    aCoors[ 1 ] := ( Val( TRIM( Memoline( cMemoCoors,, 1 ) ) )*1.011 ),;
  				  aCoors[ 2 ] := ( Val( TRIM( Memoline( cMemoCoors,, 2 ) ) ) ),;
  				  aCoors[ 3 ] := ( Val( TRIM( Memoline( cMemoCoors,, 3 ) ) )*0.949 ),;
    				  aCoors[ 4 ] := ( Val( TRIM( Memoline( cMemoCoors,, 4 ) ) )*0.986 )  }
  				                 
    // Eval( bCoorLee )
    // Fin Coordenadas
   
    bSize := {||  oDlg:CoorsUpdate(), Eval( bCoorSv ) }  //  , Eval( bCoorLee)
    
   DEFINE DIALOG oDlg ; 
               SIZE nAncho, nAlto  

    Eval( bCoorLee )
    bRect := {|| ;
    		oDlg:nTop := aCoors[1], oDlg:nLeft := aCoors[2], oDlg:nBottom := aCoors[3], oDlg:nRight := aCoors[4]    }
    Eval( bRect )
     
 oDlg:nStyle := nOr( WS_VISIBLE, WS_OVERLAPPEDWINDOW )		// nOr( WS_CAPTION, WS_BORDER, WS_THICKFRAME )
 oDlg:cCaption := cTit
 oDlg:bResized := {|| Eval( bSize ), oDlg:Refresh() }
 oDlg:lResize16 := {|| .t. }
    
   ACTIVATE DIALOG oDlg CENTER ;
      ON INIT ( oDlg:Normal(), oDlg:lCentered := iif( MLCount( MemoRead( cFCoors ) ) < 4, .t., .f. ), ;
      									PlaceControls( oDlg ), CreaBarra( oDlg ) )

return nil

Static Function CreaBarra( oDlg )
 local oBar, ob1, ob2, ob3, ob4, ob5, ob6, ob7, ob8, ob9, ob10
local oC1, oC2, oC3, cFileDest, aVal, aL, nI, a1, nSpace := 200  //, aInf
   
  DEFINE BUTTONBAR oBar SIZE 25, 25 _3DLOOK OF oDlg 2007
  
  DEFINE BUTTON OF oBar FILE ".\bitmaps\WHelp2.bmp"  ACTION  WINEXEC( ;
   iif( File( "WOCRICH.EXE" ), "WOCRICH.EXE", "WRITE.EXE" ) + " WOCGETDT.RTF", 1 ) ; 
  		 MESSAGE "Ayuda"  TOOLTIP "Ayuda"
  
  DEFINE BUTTON OF oBar FILE ".\bitmaps\WPrinter.bmp"      MESSAGE "Imprimir" ACTION oDlg:Print() ;
  		TOOLTIP "Imprimir la ventana"   
   
  DEFINE BUTTON OF oBar FILE ".\bitmaps\Save16.bmp"   GROUP   MESSAGE "Guardar" ;
          ACTION Salvar( oDlg ) ;
  	    TOOLTIP "Guardar los datos del proceso " 
  
  DEFINE BUTTON OF oBar FILE ".\bitmaps\Open16.bmp"    MESSAGE "Cargar datos archivados" ;
  	     ACTION ( Leer( oDlg ), lValid := .f. ) ;
  	    TOOLTIP "Cargar datos archivados"   
  
  DEFINE BUTTON OF oBar FILE ".\bitmaps\new2.bmp"    MESSAGE "Crear nuevo" ;
  	     ACTION ( Leer( oDlg, .t. )  ) ;
  	    TOOLTIP "Crear nuevo"   
   
  DEFINE BUTTON OF oBar FILE ".\bitmaps\WFontMin.bmp"   MESSAGE "Fuentes" ;
           ACTION  MenuFon( oDlg ) ; 
  		TOOLTIP "Ajustar tamao de las fuentes"   
     
  DEFINE BUTTON OF oBar FILE ".\bitmaps\Browse.bmp"   GROUP   MESSAGE "Ver la seleccin creada" ;
          ACTION ( Eval( bProc ), aInf := VerLosDatos( aFiltrados, lVacio, .t. ), ;
                                      IIF( File( "TEMPFILT.DBF" ), InfoBase(), ;
          																	MsgWait( "Debe crear la lista", "Informacin", 1.5 ) ) ) ;
  	    TOOLTIP "Ver la seleccin creada "

  DEFINE BUTTON OF oBar FILE ".\bitmaps\WordDoc.bmp"    MESSAGE "Informe" ;
          ACTION( Eval( bProc ), aInf := VerLosDatos( aFiltrados, lVacio, .t. ), InfoBase( aInf ) ) ; // 
  	    TOOLTIP "Informe " 

  DEFINE BUTTON oBot OF oBar FILE ".\bitmaps\Chart.bmp"    MESSAGE "Grficas" ;
          ACTION ( Eval( bProc ), ;
          iif( File( "WOCGRAPH.EXE" ), iif( File( ".\WOCGET.TXT" ), ;
                 WaitRun( "WOCGRAPH.EXE " + ".\WOCGET.TXT" ), MsgWait( "Sin archivo de grficas", "Atencin", 1 ) ),;
                        MsgStop( "WOCGRAPH.EXE" + " NO encontrado.", "Atencin" ) ) ) ; 
  	    TOOLTIP "Grficas "

  DEFINE BUTTON OF oBar FILE ".\bitmaps\Excel.bmp"     MESSAGE "Abrir grfica en Excel"  ;
  	    ACTION ( Eval( bProc ), AExcel( oDlg )  ) ;
  	    TOOLTIP "Abrir en Excel"   NOBORDER

  DEFINE BUTTON OF oBar FILE ".\bitmaps\WExit3.bmp"   GROUP   MESSAGE "Cerrar" ;
          ACTION oDlg:End() ;
  		TOOLTIP "Cerrar sesin" 
  
Return .t.

static Function MenuFon( oDlg )
local nIt := 1, oMenu5a, c2 := ""
 
       MENU oMenu5a POPUP 2007

      MENUITEM "Aumentar fuente" ACTION ( aGf := aEval( aGf, {|c,n| aGf[n] := ( aGf[n] ) -1 } ), Eval( bFon )  )
                    
      MENUITEM "Disminuir fuente"  ACTION ( aGf := aEval( aGf, {|c,n|  aGf[n] := ( aGf[n] ) +1 } ), Eval( bFon )  )
      
      ENDMENU
      
      ACTIVATE POPUP oMenu5a DIALOG oDlg AT 25, 160
         
            // AEval( oDlg:aControls, { | o | o:Refresh() } )
 
Return( oDlg )

static Function Leer( oDlg, lNuevo )
local cTarg := Upper( HB_CurDrive() ) + ':', nI 
local aTodas := oDlg:aControls, nSpaces := 200
// static aValues, aGExpl, aGPer
DEFAULT lNuevo := .f.
  cMemo := ""
// ? 	  cFileUso, cMemo := Trim( MemoRead( cFileUso ) )
cTarg := AllTrim( cTarg ) + iif( !Empty( CurDir( cTarg ) ), ;
                                 '\' + AllTrim( CurDir( cTarg ) ), '' )
                if !( lIsDir( cTarg + "\" + "GETDT" ) )
                        lMkDir( cTarg + '\' + "GETDT" )
                endif
                cTarg := cTarg +  '\' + "GETDT\"
do case

case  !lNuevo
   IF !Empty( ( cFileUso :=cGetFile32("De texto|*.Txt","",, cTarg  ) ) ) .and. File( cFileUso )
	  cMemo := Trim( MemoRead( cFileUso ) )
       if !File( cFileUso ) .or. Empty( cMemo )
             MsgAlert( "Fichero no existe o no tiene texto" )
             Return Nil
       endif
        cFileUso := cFileNoPath( cFileUso )  // se adopta el nombre de fichero abierto aqu
   else
      MsgAlert( "No pudo leerse el texto" )
      Return Nil
   endif
 
cMemo := MemoRead( cTarg + cFileUso )

// se le reparte a cada lista lo suyo
case  lNuevo // Se pone todo a cero
  cMemo := ""
  For nI = 1 to 25
      cMemo += Space( 200 ) + CRLF
  next
  Ferase( ".\GETDT\WocGetDt.Txt" )
  Ferase( "WOCGET.TXT" )
  IF Ascan( aGetWorkAreas(), "TEMPFILT" ) > 0
  		TempFilt->( DbCloseArea() )
  Endif
  Ferase( "TEMPFILT.DBF" )
  Ferase( "TEMPFILT.NTX" )

endcase

For nI = 1 to Len( aValues )
                 aValues[ nI ] := Trim( Memoline( cMemo,, nI ) ) + Space( nSpaces )
next
For nI = 1 To Len(  aGExpl )
                aGExpl[ nI ] := Trim( MemoLine( cMemo,, nI + Len( aValues ) ) ) + Space( nSpaces )
next
For nI = 1 to Len( aGPer )  
                aGPer[ nI ] :=  Trim( MemoLine( cMemo,, nI  + Len( aValues )  + Len( aGExpl ) ) ) + Space( nSpaces )
next
 
AEval( oDlg:aControls, { | o | o:Refresh() } )
oDlg:Refresh()

Salvar( oDlg, .t. ) 

Return Nil


static Function Salvar( oDlg, lTxt )
local cMemo := "", cTarg := Upper( HB_CurDrive() ) + ':'
DEFAULT  lTxt := .f.

aLista := {} // Statica
aEval( aValues, {| c, n | aadd( aLista, aValues[ n ]  )  } ) 
aEval( aGExpl, {| c, n |  aadd( aLista, aGExpl[ n ]  )  } )
aGPer[ 1 ] := iif( !Empty( AllTrim(aGPer[ 2 ]) ) .and. EmpTy( AllTrim(aGPer[ 1 ]) ), "1;2;3;4;5;6;7;8;9;10;11;12;", aGPer[ 1 ] )
aEval( aGPer, {| c, n |    aadd( aLista, aGPer[ n ]  )  } )

aEval( aLista, {| c, n | cMemo += Trim( cValToChar(c) ) + CRLF } )

// Obtener solo la lista desde Procesar
// if lTxt
	// Return ( cMemo )
// endif

cTarg := AllTrim( cTarg ) + iif( !Empty( CurDir( cTarg ) ), ;
                                 '\' + AllTrim( CurDir( cTarg ) ), '' )
                if !( lIsDir( cTarg + "\" + "GETDT" ) )
                        lMkDir( cTarg + '\' + "GETDT" )
                endif
                cTarg := cTarg +  '\' + "GETDT\"
 cFileUso := iif( !Empty( cFileUso ), cFileNoPath( cFileUso ), "WocGetDt.Txt" )
 if  Memowrit( cTarg + iif( !Empty( cFileUso ), cFileUso, "WocGetDt.Txt" ), Trim( cMemo ) )
      //MsgWait( cTarg + iif( !Empty( cFileUso ), cFileUso, "Grafico.Txt" ), "Guardado", 1.5 )
      // Obtener solo la lista desde Procesar
      if lTxt
	    Return ( cMemo )
      else
         WaitRun( "Notepad " + cTarg + iif( !Empty( cFileUso ), cFileUso, "WocGetDt.Txt" ) )
      endif
 endif

Return Nil
 

static function PlaceControls( oDlg, lNuevo )
   local n, nSpaces := 300, o2, oBotX, bClk, nBase := 1, aItems, bSelect, cBase
   local cName    := Space( 30 ) //, aSay := Array( 11 ) //, aL := Array( 11 )
   local cSurname := Space( 40 ), oBProc, oRad, oRGr, oGr1, oGr2, oSinMss
   local cAddress := Space( 70 ), cFPeriodos := "PERIODOS.DAT", cFSeries := "SERIES.DAT", cPeriodo := "", cSerie := ""
   local nRow := 1, nCol, aTip1 := Array( 9 ), nC := 2, n1, aP1 := {}  //, aP2 := {}
   local aGr := { -15, -12, -10, -10, -10, -10, -10, -10, -11  }, aGet := {}
   local aL2, aTip2, oGet, oExcluir, oPorcent, aFallidos := {}
   local aSPer, aL3, oSkinB, c2 , aBase := {}
   local g1, g2, g3, g4, g5, g6, g7, g8, g9, g10, g11, g12, g13, g14, gp1, gp2, nI := 0
   // static aL, aLista, aValues, aGExpl, aGPer, cFileUso, aGf := { -15, -10, -10, -10, -10, -10, -10, -10, -11  }, bFon, bSv
   DEFAULT lNuevo := .f.
   aSay := Array( 9 )
   cPeriodo := "Ene" + CRLF + "Feb" + CRLF + "Mar" + CRLF + "Abr" + CRLF + "May" + CRLF + "Jun" + ;
      CRLF + "Jul" + CRLF + "Ago" + CRLF + "Sep" + CRLF + "Oct" + CRLF + "Nov" + CRLF + "Dic"
   cSerie := ""
   for n1 = 1 to 25
      cSerie += AllTrim( Str( Year( Date() )-n1 ) ) + CRLF
   next
   if !File( cFPeriodos )
      MemoWrit( cFPeriodos, cPeriodo )    
   else
     cPeriodo := MemoRead( cFPeriodos )
   endif       
   if !File( cFSeries )
      MemoWrit( cFSeries, cSerie )    
   else
     cSerie := MemoRead( cFSeries )
   endif       
   for n1 = 1 to MLCount( cPeriodo )
        aadd( aP1, MemoLine( cPeriodo,, n1 ) )
   next
   aP2 := {}
   for n1 = 1 to MLCount( cSerie )
        aadd( aP2, MemoLine( cSerie,, n1 ) )
   next
   aLista := {}   
   AFILL( aTip1, "Es una cadena alfanumrica, escriba cada dato y le aade ';' " )
   aTip1[ 5 ] := "Escriba Nm. del ao de nacimiento sin punto de miles + ';' " + CRLF + ;
                           "y si quiere puede aadir ao de nacim. final de bsqueda + ';' "
   aTip1[ 7 ] := "Filtrar solo H o solo M ( + ';' ), o vaco para admitir los dos sexos sin filtrar"  
   aValues := Array( 9 )

      oSkinB = TSkinButton():New()

   // meses y aos
   aSPer := { "Meses", "Aos" } ;   aL3      := { 1, 2 } ; aGPer := Array( 2 ) ; AFILL( aGPer, Space( nSpaces ) )
 //  aSPer[ 1 ] := iif( nRGr == 2, "", aSPer[ 1 ] ) 
   // Exploraciones
   aSExpl := Titulos( {} )   // 14
   aEval( aSExpl, {| c, n | aSExpl[ n ] := AllTrim( aSExpl[ n ] ) } )
   aL2 := Array( Len( aSExpl ) )  ;  aGExpl := Array( Len( aSExpl ) )  ;  aTip2 := Array( Len( aSExpl ) )
   aBase := Array( Len( aSExpl ) )
   for n = 1 to Len( aL2 )
        aL2[ n ]        := n
        aGExpl[ n ] := Space( nSpaces )
        aTip2[ n ]    := { "Escriba punto y coma ';' detrs de cada elemento de texto", ;
        							"Click Izq en el botn: Abrir listas",, } 
        // aBase[ n ]   :=  "AUX" + AllTrim( Str( n ) ) + ".DBF"
   next
   
       aTip2[ 3 ]    := aTip2[ 4 ] := { ;
       "En todos escriba ';' detrs de cada elemento de texto - En nmeros incie con dlar '$' ",;
        																											"Click Izq en el botn: Abrir listas",, } 
       aBase := { "AUX1","AUX2","AUX3","AUX4","AUX5","AUX6","AUX7",;
       			"AUX8","AUX9","AUX10","AUX11","AUX12","AUX13", "AUX14" }
       
       bSelect := { | cText | iif( Ascan( aGetWorkAreas(), cBase ) == 0, ;
       	 DbUseArea( .t., , cBase, , .T. ), Nil ), ;  // modo compartido
       	 iif( ( cBase )->( LastRec() ) > 0, ( ;
       	 aItems := Array( ( cBase )->( LastRec() ) ), AFill( aItems, "  " ), ;
       	 aEval( aItems, { | c, n | ( cBase )->( DbGoto( n ) ), aItems[ n ] := ( cBase )->( FieldGet( 1 ) ) } ),;
       	 cText := MsgSelect( aItems, aItems[ 1 ], Ascan( aBase, cBase ), cText ) ),;
       	 MsgStop( ( cBase ) + " sin datos archivados", "Atencin" )  )       }

//       c2 := MemoRead( "GETFONT.DAT" )
       c2 := MemoRead( "FILTFONT.DAT" )
       if MLCount( c2 ) < 4
             aGf := aClone( aGr )
       else
             aGf := Aeval( aGf, {| c, n | aGf[n] := Val( AllTrim( MemoLine( c2,, n  ) ) )  } )
       endif
 
     bSv := {|| c2 := "", aEval( aGf, {|c,n| c2 += AllTrim( Str( aGf[n] ) ) + CRLF  }, 1, 8 ), MemoWrit( "FILTFONT.DAT", c2 )   }
             
              bFon := {| n | ;
   aFont[1] := TFont():New( "Arial", 0, aGf[2], .F., .T.,   0, 0, ,.F., .F.),;  // Title
   aFont[2] := TFont():New( "Arial", 0, aGf[3], .F., .T.,   0, 0, ,.F., .F.),;  // xFont
   aFont[3] := TFont():New( "Arial", 0, aGf[4], .F., .F.,   0, 0, ,.F., .F.),;  // yFont
   aFont[4] := TFont():New( "Arial", 0, aGf[4], .F., .F.,   0, 0, ,.F., .F.),;  // Legends
   aFont[5] := TFont():New( "Arial", 0, aGf[5], .F., .T.,   0, 0, ,.F., .F.),;  // Subtitle
   aFont[6] := TFont():New( "Arial", 0, aGf[6], .F., .T., 898, 0, ,.F., .F.),;  // xTitle
   aFont[7] := TFont():New( "Arial", 0, aGf[7], .F., .T.,   0, 0, ,.F., .F.),;  // yTitle
   aFont[8] := TFont():New( "Arial", 0, aGf[8], .F., .F.,   0, 0, ,.F., .F.), ;  // Values
   aFont[9] := TFont():New( "Arial", 0, aGf[8], .F., .T.,   0, 0, ,.F., .F.), ;  // Values Bold
    oDlg:SetFont( aFont[ 1 ] ), oDlg:Refresh() , Eval( bSv ) }     
  
    // Fin Fuentes
   Eval( bFon )

   aFont[1] := TFont():New( "Arial", 0, aGf[2], .F., .T.,   0, 0, ,.F., .F.)
   aFont[2] := TFont():New( "Arial", 0, aGf[3], .F., .T.,   0, 0, ,.F., .F.) 
   aFont[3] := TFont():New( "Arial", 0, aGf[4], .F., .F.,   0, 0, ,.F., .F.) 
   
   @ 2.7, 18 + nC SAY "FILTROS en Datos de FILIACIN" COLOR CLR_GREEN FONT aFont[1]  OF oDlg SIZE 250, 15
   @ 17.5, 18 + nC  SAY "Periodos a mostrar" COLOR CLR_GREEN FONT aFont[1]   OF oDlg SIZE 250, 15
   @ 2.7, 93 + nC  SAY "FILTROS en Datos de EXPLORACIONES" COLOR CLR_GREEN FONT aFont[1]  OF oDlg SIZE 350, 15
   
   // Filiacion  
 // As es como queda la lista de datos de filiacin     
   aSay := { "NOMBRE", "DIRECCIN", "POBLACIN", "TELFONO", "FECHANACI", "Otros DATOS", ;
   										"SEXO (H/M)", "ALERGIAS", "D-POSTAL" }   
    aL     := { 1, 2, 3, 4, 5, 8, 9, 10, 16 }  
   
    aValues  := Array( 9 )  ; AFILL( aValues, Space( nSpaces ) )
    aGExpl   := Array( 14 ) ; AFILL( aGExpl,  Space( nSpaces ) )
    aGPer     := Array( 2 )  ; AFILL( aGPer,  Space( nSpaces ) )
    Ferase( "WOCGET.TXT" )  // Para q se re-cree y no se use uno q no sea el suyo    
if File( ".\GETDT\WOCGETDT.TXT" )
     // Mostrar los ultimos datos usados
     cMemo := MemoRead( ".\GETDT\WOCGETDT.TXT" )
     For nI = 1 to Len( aValues )  // 9
                 aValues[ nI ] := Trim( Memoline( cMemo,, nI ) ) + Space( nSpaces )
     next
     For nI = 1 To Len(  aGExpl )  // 14
                aGExpl[ nI ] := Trim( MemoLine( cMemo,, nI + Len( aValues ) ) ) + Space( nSpaces )
     next
     For nI = 1 to Len( aGPer )  // 2
                aGPer[ nI ] :=  Trim( MemoLine( cMemo,, nI  + Len( aValues )  + Len( aGExpl ) ) ) + Space( nSpaces )
     next
    // Ferase( "WOCGET.TXT" )  // Para q se re-cree y no se use uno q no sea el suyo
else
    Salvar( oDlg, .t. )
endif
//     aEval( oDlg:aControls, {| c, n | oDlg:aControls[ n ]:Refresh()  } )
   n = 1 ; nCol := 7
 
   for nRow = 1 to Len( aValues )
          TSay():New( 4 + nRow*0.2 + nRow -0.5, nCol*2 - 13 + nC , GenBlock( aSay, nRow ), oDlg, , aFont[1], ;
          					, .t., , , CLR_RED , , 90, 15, , , , , , , .t. )
          oGet := TGet():New( ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, nCol * 2 - 0.7 + nC , GenBlock( aValues, n++ ), oDlg, 280, ;
          				    16, , , CLR_BLUE, , aFont[1] )
          oGet:cToolTip := aTip1[  nRow ]
   next 
   
   n = 1 ; nCol := 41
   for nRow = 1 to Len( aGExpl )
          oBotX := TSay():New( 4 + nRow*0.2 + nRow -0.5, (nCol)*2 - 12.5 + nC , GenBlock( aSExpl, nRow ),oDlg , , aFont[1], ;
          					, .t., , , CLR_RED , , 120, 15, , , , , , , .t. )
 
 //         oGet := TGet():New( ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC , GenBlock( aGExpl, n++ ), oDlg, 300, ;
   //       				    16, , , CLR_BLUE, , aFont[1], , , .f., aTip2[ nRow ],,,,,,,,,,,,,,, {||  ( "click", nRow ) }  , "..\bitmaps\16x16\find4.bmp" )
   //       oGet:cToolTip := aTip2[  nRow ] 
 
   next  

     nRow := 1
    @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g1 VAR aGExpl[ 1 ] SIZE  300, 18  FONT aFont[ 1 ] ;
       COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 1 ], aGExpl[ 1 ] := Eval( bSelect,  aGExpl[ 1 ] ), g1:SetFocus(), g1:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g1:cToolTip := aTip2[ 1 ]
           
     nRow := 2
    @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g2 VAR aGExpl[ 2 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 2 ], aGExpl[ 2 ] := Eval( bSelect,  aGExpl[ 2 ] ), g2:SetFocus(), g2:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g2:cToolTip := aTip2[ 2 ]  
     
     nRow := 3
    @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g3 VAR aGExpl[ 3 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 3 ], aGExpl[ 3 ] := Eval( bSelect,  aGExpl[ 3 ] ), g3:SetFocus(), g3:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g3:cToolTip := aTip2[ 3 ]  

     nRow := 4
    @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g4 VAR aGExpl[ 4 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 4 ], aGExpl[ 4 ] := Eval( bSelect,  aGExpl[ 4 ] ), g4:SetFocus(), g4:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g4:cToolTip := aTip2[ 4 ]  

     nRow := 5
    @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g5 VAR aGExpl[ 5 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 5 ], aGExpl[ 5 ] := Eval( bSelect,  aGExpl[ 5 ] ), g5:SetFocus(), g5:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g5:cToolTip := aTip2[ 5 ]  
 
      nRow := 6
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g6 VAR aGExpl[ 6 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 6 ], aGExpl[ 6 ] := Eval( bSelect,  aGExpl[ 6 ] ), g6:SetFocus(), g6:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g6:cToolTip := aTip2[ 6 ]  
 
     nRow := 7
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g7 VAR aGExpl[ 7 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 7 ], aGExpl[ 7 ] := Eval( bSelect,  aGExpl[ 7 ] ), g7:SetFocus(), g7:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g7:cToolTip := aTip2[ 7 ]  
 
     nRow := 8
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g8 VAR aGExpl[ 8 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 8 ], aGExpl[ 8 ] := Eval( bSelect,  aGExpl[ 8 ] ), g8:SetFocus(), g8:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g8:cToolTip := aTip2[ 8 ]  
 
     nRow := 9
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g9 VAR aGExpl[ 9 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 9 ], aGExpl[ 9 ] := Eval( bSelect,  aGExpl[ 9 ] ), g9:SetFocus(), g9:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g9:cToolTip := aTip2[ 9 ]  
 
     nRow := 10
         @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g10 VAR aGExpl[ 10 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 10 ], aGExpl[ 10 ] := Eval( bSelect,  aGExpl[ 10 ] ), g10:SetFocus(), g10:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g10:cToolTip := aTip2[ 10 ]  
 
     nRow := 11
    @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g11 VAR aGExpl[ 11 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 11 ], aGExpl[ 11 ] := Eval( bSelect,  aGExpl[ 11 ] ), g11:SetFocus(), g11:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g11:cToolTip := aTip2[ 11 ]  
 
     nRow := 12
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g12 VAR aGExpl[ 12 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 12 ], aGExpl[ 12 ] := Eval( bSelect,  aGExpl[ 12 ] ), g12:SetFocus(), g12:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g12:cToolTip := aTip2[ 12 ]  
 
     nRow := 13
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g13 VAR aGExpl[ 13 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 13 ], aGExpl[ 13 ] := Eval( bSelect,  aGExpl[ 13 ] ), g13:SetFocus(), g13:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g13:cToolTip := aTip2[ 13 ]  
 
     nRow := 14
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 13 + nC  GET g14 VAR aGExpl[ 14 ]  SIZE  300, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( cBase := aBase[ 14 ], aGExpl[ 14 ] := Eval( bSelect,  aGExpl[ 14 ] ), g14:SetFocus(), g14:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        g14:cToolTip := aTip2[ 14 ]  
 
   n = 1 ; nCol := 7
   for nRow = 13 to 14  // 13 + Len( aGPer )
          TSay():New( 4 + nRow*0.2 + nRow -0.5, (nCol)*2 - 13 + nC , GenBlock( aSPer, n ), oDlg, , aFont[1], ;
          					, .t., , , CLR_RED , , 90, 15, , , , , , , .t. )
       n++
   next   
     nRow := 13               //  nCol * 2 - 0.7 + nC 
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 0.7 + nC  GET gp1 VAR aGPer[ 1 ]  SIZE  280, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
      ACTION ( aGPer[ 1 ] := IIF(  nRGr == 2, "", MsgSelect( aP1, aP1[ 1 ], -1, aGPer[ 1 ] ) ), ;      					
      						gp1:SetFocus(), gp1:Refresh()   ) ;
      BITMAP ".\bitmaps\find4.bmp" 
        gp1:cToolTip :=   "Cada mes ponga: Nm. de Mes + ';' "

     nRow := 14
     @ ( nRow  ) + 4 + nRow*0.2 + nRow*0.22, (nCol) * 2 - 0.7 + nC  GET gp2 VAR aGPer[ 2 ]  SIZE  280, 16  FONT aFont[ 1 ] ;  //  22
      COLOR CLR_BLUE, CLR_WHITE ;
     ACTION ( aGPer[ 2 ] := MsgSelect( aP2, aP2[ 1 ], -2, aGPer[ 2 ] ), ; 
      						gp2:SetFocus(), gp2:Refresh(), iif( lCerrar == .t., ;
      						( lCerrar := .f., aGPer[ 2 ] := MsgSelect( aP2, aP2[ 1 ], -2, aGPer[ 2 ] ) ), ),;
      						gp2:SetFocus(), gp2:Refresh(), oDlg:Refresh()   )        ;
      BITMAP ".\bitmaps\find4.bmp" 
        gp2:cToolTip :=   "Cada ao ponga Nm. del ao sin punto de miles + ';' " + CRLF + ;
                                          "Si todos los hallados de un ao son = cero, no se muestra el ao."
        gp2:bGotFocus := {|| iif( nRGr == 2, Nil, ( ;
                                aGPer[ 1 ] := iif( EmpTy( aGPer[ 1 ] ), "1;2;3;4;5;6;7;8;9;10;11;12;", aGPer[ 1 ] ),;
      gp1:Refresh() ) ) }
   
// Es engorroso. La sintaxis de acentos que se sustituya poniendo las distintas llamadas que use cada usurio
// p.ej., miopa;MIOPA;MIOPIA;MIOP sera la mas eficaz, o procurar evitar la zona del acento si la palabra lo hace posible
// como en la muestra   .. y lo que se buscar ser exactamente lo que se hay puesto en sta ventana
// Lo aconsejable es usar maysculas y sin acentos a la hora de escribir en exploraciones y preferible sera desde la base
// auxiliar de cada exploracin...
         // nRow *= 2 ; nCol := 41 

         @ 27.2, 82   CHECKBOX oExcluir VAR lExcluir PROMPT "Exploraciones, Filtrados excluyentes?" SIZE 300, 16 OF oDlg ;
      ON CHANGE ( !( lExcluir ), cVal := Stuff( cVal, 1, 1, iif( lExcluir, "S", "N" ) ), MemoWrit( "FILTCONF.DAT", cVal )  ) ;
      FONT aFont[ 1 ] COLOR CLR_RED
      oExcluir:cToolTip := {'Hacer que los filtros excluyan pacientes, o los sumen.' + CRLF + ;
      'Click Dcho -> Ms informacin.', 'En exploraciones diferentes:',, }            
       oExcluir:bRClicked := {| nrow, ncol, flags| MsgInfo( "Filtro excluyente: crea una lista de " + ;
       "los pacientes filtrados y el filtro de la siguiente exploracin se har sobre sta lista ya filtrada" + ;
       " por ej., pacientes que tengan CATARATA y MIOPIA" + CRLF + ;
       "Filtros que se suman = pacientes que tengan CATARATA o MIOPIA"  + ;
       " y la bsqueda se hace cada vez sobre la misma lista.", "Filtros de Exploraciones" ) }
  
     nRGr := Min( nRGr, 2 )       // 30.5
    @ 24, 16 GROUP oGr2 TO 29, 59 PROMPT "Grficas, ver por: " OF oDlg COLOR CLR_RED
 
   @ 1, 1 RADIO oRGr VAR nRGr OF oGr2 UPDATE ;
      PROMPT "Aos y &meses"  SIZE 125, 25 COLOR CLR_GREEN, CLR_YELLOW
    @ 1, 21 RADIOITEM "Aos Totales" RADIOMENU oRGr OF oGR2 SIZE 137, 25 ;
    COLOR CLR_GREEN, CLR_YELLOW
 
    oRGr:Refresh()   
    oRGr:bChange := {|| cVal := Stuff( cVal, 4, 1, AllTrim( Str( nRGr ) ) ), MemoWrit( "FILTCONF.DAT", cVal ),;
     oRGr:Refresh(), oDlg:Refresh() }    

    @ 26.5, 80.8 GROUP oGr1 TO 30, 125 PROMPT "En las grficas " OF oDlg COLOR CLR_RED
                  //81
   @ 15.5, 83 RADIO oRad VAR nRad OF oDlg UPDATE ;
      PROMPT "Recuento"  SIZE 112, 25 COLOR CLR_GREEN, CLR_YELLOW
   @ 15.5, 103.5 RADIOITEM "% de hallados" RADIOMENU oRad OF oDlg SIZE 112, 25 ;
    COLOR CLR_GREEN, CLR_YELLOW
    oRad:Refresh()   
    oRad:bChange := {|| cVal := Stuff( cVal, 2, 1, AllTrim( Str( nRad ) ) ), MemoWrit( "FILTCONF.DAT", cVal ),;
         oRad:Refresh(), oDlg:Refresh()  }    
 
   @ 26.1, (41) * 2 - 13 + nC + 3.5 SAY "Ver los datos en: " COLOR CLR_RED
 
//   oSkinB = TSkinButton():New()
 /*
   oSkinB:nClrBorder0_N = RGB( 249, 194, 179 )
   oSkinB:nClrBorder1_N = RGB( 181, 61, 29 )
   oSkinB:aClrNormal    = { { 0.2, RGB( 254, 154, 128 ), RGB( 254, 154, 128 ) }, ;
              	            { 0.8, RGB( 252, 85, 40 ), RGB( 181, 61, 29 ) } }
   */
   
   SkinButtons( oSkinB )              	          	
 
     bFechas := {|| aGPer[ 1 ] := iif( !Empty( aGPer[ 2 ] ) .and. EmpTy( aGPer[ 1 ] ), "1;2;3;4;5;6;7;8;9;10;11;12;", ;
     aGPer[ 1 ] ), SysRefresh(), lFech := !( EmpTy( AllTrim( aGPer[ 1 ] ) ) .or. EmpTy( AllTrim( aGPer[ 2 ] )  ) ) }
          // nRow + 5

     bProc := {|| ;
               Salvar( oDlg, .t. ), Eval( bFechas ), oDlg:Refresh(), ;
      	aFiltrados := {}, Ferase( "TEMPFILT.DBF" ), Ferase( "TEMPFILT.NTX" ), ;
      	Procesar( Salvar( oDlg, .t. ), oDlg ), lValid := .t., oDlg:Refresh() ;
     }
/*
      @ nRow + 7.5 + 3, nCol + 11 + nC   BUTTON oProc PROMPT "Procesar" SIZE 280, 30 OF oDlg ACTION ( ;
          Salvar( oDlg, .t. ), Eval( bFechas ), oDlg:Refresh(), ;
      	aFiltrados := {}, Ferase( "TEMPFILT.DBF" ), Ferase( "TEMPFILT.NTX" ), ;
      	Procesar( Salvar( oDlg, .t. ), oDlg ), lValid := .t., oDlg:Refresh() )  // , o2:Refresh(), o2:SetFocus() )  
*/
return Nil  
 
static  function GenBlock( aValues, n )
 
return bSETGET( aValues[ n ] )

static function MsgSelect( aItems, cValue, nExpl, cText )			//aItems, cValue, cTitle )
   local n1 := 0, c1 := "", c2
   local oDlg, oLbx, aSelect := {}, a1 := {}, aL := Titulos(), bReSize, bRect, oBmp, cInfo := "Ayuda en la ventana actual."
   local oB1, oB2, oB3, bCoorLee, bCoorSv, aCoors := Array( 4 ), cMemoCoors := "", cFCoors := "SELCOORS.DAT"
   DEFAULT nExpl :=  1, cValue := Nil, cText := ""
   cText := Trim( cText )
   cInfo := "En la ventana actual no aparece ningn elemento seleccionado." + CRLF + CRLF + ;
                  "Puedes desplazarte por ella con el teclado (letra mays o mins," + CRLF + ;
                   "segn est escrito el archivo va a inicial de esa letra en la lista, y " + CRLF + ;
                   "PGUP / PGDN, etc.),  y con el ratn  usando la  barra de desplaza-" + CRLF + ;
                   "miento vertical o la rueda." + CRLF + CRLF + ;
                   "Con el ratn puedes marcar cuantos elementos quieras para que se" + CRLF + ;
                   "carguen en la lnea correspondiente a la exploracin que est activa" + CRLF + ;
                   "pero aqu solo se hace dicha descarga, la creacin y modificacin de" + CRLF + ;
                   "estos datos  se hacen en  el men inicial de Wocul3.Exe en apartado" + CRLF + ;
                   "de Mantenimiento -> Bases Auxiliares, y los datos corresponden a la" + CRLF + ;
                   "primera lnea de cada registro siendo las restantes informativas para" + CRLF + ;
                   "el usuario."
   
       bCoorSv := {||  ;
        MemoWrit(  cFCoors,  Str( ( oDlg:nTop ) ) + CRLF + ;
        Str( ( oDlg:nLeft ) ) + CRLF + ;
        Str( ( oDlg:nBottom ) ) + CRLF + ;
                 Str( ( oDlg:nRight  ) ) ) }
   
   bReSize := {|| ;
   oDlg:CoorsUpdate(), Eval( bCoorSv ), ;
       oLbx:nWidth   := oDlg:nWidth   - 50, ; 
       oLbx:nHeight := oDlg:nHeight  - 100, ;  
   oB1:nTop := oDlg:nHeight -70, ;     // oB1:nLeft := 15 
   oB2:nTop := oDlg:nHeight -70,  ;     //, oB2:nLeft := 16 
   iif( nExpl == -2, ( oB3:nTop := oDlg:nHeight -70 ), )  }

    bCoorLee := {|| ;
         cMemoCoors := Trim( MemoRead( cFCoors ) ),;
         cMemoCoors := iif( MLCount( cMemoCoors ) > 3,;   // Valor valido // En caso de error, valor original.. q s  establece en cada entrada
     cMemoCoors,  AllTrim( Str( 8*16 ) ) + CRLF + AllTrim( Str( 20*8 ) ) + CRLF + ;
  				                 AllTrim( Str( 35*16 ) ) + CRLF + AllTrim( Str( 100*8 ) ) ), ; // msginfo( cMemocoors, str(MLCount( cMemoCoors )))
                    aCoors[ 1 ] := ( Val( TRIM( Memoline( cMemoCoors,, 1 ) ) )*1.011 ),;
  				  aCoors[ 2 ] := ( Val( TRIM( Memoline( cMemoCoors,, 2 ) ) ) ),;
  				  aCoors[ 3 ] := ( Val( TRIM( Memoline( cMemoCoors,, 3 ) ) )*0.949 ),;
    				  aCoors[ 4 ] := ( Val( TRIM( Memoline( cMemoCoors,, 4 ) ) )*0.986 )  }
   
//   Eval( bCoorLee )
   
   DEFINE DIALOG oDlg FROM aCoors[ 1 ], aCoors[ 2 ] TO aCoors[ 3 ], aCoors[ 4 ] TITLE ;
   iif ( nExpl > 0, "Base auxiliar de:  " + AllTrim( aL[ nExpl ] ), iif( nExpl == -1, "Meses", "Aos" )   ) + ;
   							" - Seleccin mltiple"  //cTitle

     Eval( bCoorLee )
    bRect := {|| ;
    		oDlg:nTop := aCoors[1], oDlg:nLeft := aCoors[2], oDlg:nBottom := aCoors[3], oDlg:nRight := aCoors[4]    }
    Eval( bRect )

    oDlg:nStyle := nOr( WS_CAPTION, WS_BORDER, WS_THICKFRAME )
   @  1, 1 LISTBOX oLbx VAR cValue ITEMS aItems MULTI SIZE 150, 95 OF oDlg

   @  7, 4 BUTTON oB1 PROMPT  "&Aceptar" OF oDlg SIZE 40, 12 ;
        ACTION ( aSelect := oLbx:aSelections(), oDlg:End() ) DEFAULT

   @  7, 12 BUTTON oB2 PROMPT  "&Cancelar" OF oDlg SIZE 40, 12 ;   
	ACTION ( cValue := nil, oDlg:End() )
	 
   if nExpl == -2
	   @  7, 20 BUTTON oB3 PROMPT  "&Invertir" OF oDlg SIZE 40, 12 ;
        ACTION (  a1 := Array( Len( aItems ) ), aEval( aItems, {| c, n | a1[ Len( a1 )+1 -n ] := aItems[ n ] } ), ;
            aItems := aClone( a1 ), c2 := "", aEval( aItems, {|c,n| c2 += aItems[ n ] + CRLF } ), MemoWrit( "SERIES.DAT", c2  ),;
            aP2 := aClone( aItems ), lCerrar := .t., oDlg:End() )
	  oB3:cToolTip := { "Invertir el orden de la lista, guardar y cerrar", "Lista de Aos",, }
   endif
      
   @ 0, 0 BITMAP oBmp FILE ".\Bitmaps\Whelp2.Bmp" NOBORDER CURSOR CursorHand() ;
   SIZE 16, 16 ON CLICK MsgInfo( cInfo, "Informacin" )
    oDlg:bResized := {|| Eval( bResize ) }
    oDlg:lResize16 := {|| .t. }
  
   ACTIVATE DIALOG oDlg CENTERED ;
      ON INIT  Eval( bResize )  ;    // oLbx:SetSelItems( { 2, 3 } )   // Lets start with some
      ON MOVE Eval( bResize )                                      // already selected
 
   if cValue != nil .and. Len( aSelect ) > 0
      do case
      case nExpl == -1
      AEval( aSelect, { | c, n | c1 := c, cText := iif( at( AllTrim( Str( Ascan( aItems, c1 ) ) ), cText ) == 0, cText + "" + ;
      				AllTrim(   Str( Ascan( aItems, c1 ) )    ) + ";", cText ) } )

      // case nExpl == -2
      otherwise
      cText := AllTrim( cText )
      AEval( aSelect, { | cSelect | cText := iif( at( AllTrim( cSelect ), cText ) == 0, cText + "" + AllTrim(cSelect) + ";", cText ) } )
 
      endcase
   endif

return Trim( cText ) + Space( 300 )

//----------------------------------------------------------------//
 
static function Titulos( aTitulo )

DEFAULT aTitulo := {}

aadd( aTitulo,  ( "   Polo anterior    " ) )
aadd( aTitulo,  ( "    Fondo ocular    " ) )
aadd( aTitulo,  ( "     Refraccin     " ) )
aadd( aTitulo,  ( "    Tonometras     " ) )
aadd( aTitulo,  ( "     Motilidad      " ) )
aadd( aTitulo,  ( "     Biometra      " ) )
aadd( aTitulo,  ( " Reflejos pupilares " ) )
aadd( aTitulo,  ( "    Campo visual    " ) )
aadd( aTitulo,  ( "  Vas lagrimales   " ) )
aadd( aTitulo,  ( "   Biomicroscopa   " ) )
aadd( aTitulo,  ( "  Visin cromtica  " ) ) 
aadd( aTitulo,  ( "   Otras tcnicas   " ) ) 
aadd( aTitulo,  ( "    Diagnstico     " ) ) 
aadd( aTitulo,  ( "    Tratamiento     " ) )

return( aTitulo )
//---------------

sTatic Function Procesar( cSalva, oDlg )
local nI, n, n1, n2, n3, nX, c1, c2, c3, c4, a1, a2, a3, aX, aNombres := {}, nI2 := 0
local cBase := "PACIENTE", aDBf, aPru := {}, lHay2 := .f., lSalir := .f., cBaseTmp
local bBorrar,  aNuales := {}, nSpaces := 200, aDatMes, aDatAn, bVacio, bListado // , lListado := .f.
local aMeses, aLMeses := { "Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic" }
local lSinFil := .f., aFallidos := {}, nPac, nTotal, nVac := 0, DateTop := Year( Date() )
Field Texto
// static aL, aLista, aValues, aGExpl, aGPer, cFileUso, aGf := { -15, -10, -10, -10, -10, -10, -10, -10, -11  }, bFon, bSv
cMemo := cSalva
     aL     := { 1, 2, 3, 4, 5, 8, 9, 10, 16 }   // recuerda .., son los campos a usar de paciente.dbf
bVacio := {|| lVacio := EmpTy( Trim( StrTran( cMemo, ";", "" ) ) ) }
Eval( bVacio )
aListado := {}  // statica
bListado := {|| lListado := Empty( Trim( aGPer[ 1 ] )  ) .and. ;  // .or.
										Empty( Trim( aGPer[ 2 ] ) ) }
Eval( bListado )
// lListado es estatica aunque se evalua aqu
// primero comprobar los excluyentes: sexo, fechanaci .. NOOOOoooo, lo voy a hacer secuencial aunque tarde mas
// pero con tantas variantes es lo menos embrollado
if Len( aGetWorkAreas() ) > 0
	DbCloseAll()
endif
AbreBases()  // Se abren todas las bases, compartidas
cBasico := ""
Paciente->( DbSelectArea() )
Paciente->( DbGoto( 1 ) )
//aDbf := Paciente->( DbStruct() )

// PRIMER PASO DE DATOS DE FILIACION
// Primero localizar los pacientes que cumplen los requisitos
// establecidos como filtros en datos de filiacin.  Si no hay filtros de filiacin
// entonces las patologias de exploraciones se aplicaran a todos los que fueran
// de aos y meses establecidos
n1 := Len( aValues )  // 9
 // lSinFil
c1 := ""
For nI = 1 To n1 // aValues = Filiacin
 		c1 += MemoLine( cMemo,, nI )
Next
c1 := StrTran( c1, ":", ";" )
lSinFil := ( Empty( AllTrim( StrTran( c1, ";", "" ) ) ) )
lSinFil := iif( Empty( AllTrim( StrTran( ( aGPer[ 1 ] + aGPer[ 2 ] ), ";", "" ) ) ), .f., lSinFil ) 

// Si hay que filtrar filiacion, se hace 
if !( Empty( AllTrim( StrTran( c1, ";", "" ) ) ) ) // si no estn vacios toda la filiacin

For nI = 1 To n1  // La lista de los campos de filiacin que se exploran
if !Empty( AllTrim( memoLine( cMemo, , nI ) ) )   // si est vacia la filiacion actual acelerar el proceso saltandola
   
   Paciente->( DbGoto( 1 ) )
   a1 := {} 
   c1 := Trim( memoLine( cMemo, , nI )  )
   c1 := StrTran( c1, ":", ";" )
  
  if nI == 5 .and. ( lListado .or. lSinFil ) .and. Empty( c1 )    // fecha nacim
	c1 := "0;" // AllTrim( Str( Year( Date() ) -150 ) ) + ";"  // 120 aos
  endif
  do While at( ";", c1 ) > 0
       c2 := AllTrim( SubsTr( c1, 1, at( ";", c1 )-1 ) )
       c1 := SubsTr( c1,  at( ";", c1 ) + 1 )
       aadd( a1, AllTrim( c2 ) )  // Se crea array con las cadenas a procesar
  enddo
  
if Len( a1 ) > 0  // Si hay filtros en este dato ( nI ) de filiacin del paciente
// ? "Hola!", len( a1 ), c2
// msglist( a1 )
Paciente->( DbGoto( 1 ) )
n := 1
DO WHILE Paciente->( RecNo() ) <= Paciente->( LastRec() ) 

  	If !( Empty( Paciente->( FieldGet( aL[ nI ] ) ) ) ) // El Campo NO est vacio

  	for n2 = 1 to Len( a1 )
  	
             	a1[ n2 ] := StrTran( a1[ n2 ], "$", ""  )  // Se eliminan los dolares improcedentes
  	          a1[ n2 ] := StrTran( a1[ n2 ], ";", ""  )

       if !Empty( a1[ n2 ] )
  	    do case
  	    
  	    case aL[ nI ] == 5  // Fechanaci es para tomar el ao
  	          // procesar el ao nacimiento
  	          DateTop := iif( Len( a1 ) > 1, Val( AllTrim( a1[ n2 + 1 ] ) ), DateTop )
             	    if Year( Paciente->FechaNaci ) >= Val( AllTrim( a1[ n2 ] ) ) .and. ;   // ao igual o mayor a nacimiento
             	         Year( Paciente->FechaNaci ) < DateTop 
             	         aadd( aFiltrados, Str(Paciente->( RecNo() ) ) )  // Se aade a la lista de admitidos al filtro
             	    endif
             	    n2 ++  // Para que salga tras el primero en fechanaci             	   
  	    case aL[ nI ] == 9
 
  	           DO CASE
  	          // case  a1[ n2 ] == "HN" .or. a1[ n2 ] == "NH" .or. EmpTy( AllTrim( a1[ n2 ] ) )  	           
  	          case  EmpTy( AllTrim( a1[ n2 ] ) )
  	                     c4 := Upper( Paciente->( FieldGet( aL[ nI ] ) ) )
               case  a1[ n2 ] == "H"
                          c4 := "V"
               case  a1[ n2 ] == "M"           
  	                      c4 := "H"
  	          endcase                           
  	           if at(  AnsiToOem( c4 ), Upper( Paciente->( FieldGet( aL[ nI ] ) ) ) ) > 0 .or. Empty( Paciente->( FieldGet( aL[ nI ] ) ) )
  	                aadd( aFiltrados, str(Paciente->( RecNo() ) ) )  // Se aade a la lista de admitidos al filtro
   	           endif
 
           otherwise        
  	           if at( Upper( AnsiToOem( a1[ n2 ] ) ), Upper( Paciente->( FieldGet( aL[ nI ] ) ) ) ) > 0 .or. ;
  	           				at( AnsiToOem( a1[ n2 ] ), Paciente->( FieldGet( aL[ nI ] ) ) ) > 0
  	                aadd( aFiltrados, str(Paciente->( RecNo() ) ) )  // Se aade a la lista de admitidos al filtro
   	           endif
   	           
  	   endcase
      endif  // de si no est vacio lo que se busca    
    next 
    endif  // de si el campo del paciente est vacio
    
    Paciente->( DbSkip() )  // Pasa al registro siguiente
     
     if Paciente->( Eof() )
         exit
     endif  
  
ENDDO
 
 endif  // Fin de si hay datos de filiacin del paciente, si la lista total esta o no vacia
 endif  // de si el actual campo de filiacin no tiene filtros      
  if Len( aFiltrados ) > 0
       exit  // Una vez que hay lista de hallados se sale del bucle
                // para continuar el proceso con la lista que ya contiene la primera seleccion obtenida.
  endif    // En el caso contrario seguira en el for to next hasta agotar todos los elementos
                // de filtrado por filiacin
    
NEXT  

// SEGUNDO PASO DE DATOS DE FILIACION
// Ahora se completan los posibles filtrados que an queden (si es as) de filiacin
// ? "IDA", len( aFiltrados )   // MsgList( aFiltrados )

 if nI < n1 .and. Len( aFiltrados ) > 0 // n1 es la longitud de aValores, lista de campos de filiacion para filtro 
     aFiltrados := FiltrarUno( aFiltrados, nI+1, aValues, cMemo, 5 )  // 5 = nClave que orienta a valorar como numrico 
 endif

else  // si no hay que filtrar filiacion se toma la base entera de pacientes
    Paciente->( DbEval(  {|| ;
        iif( !EmpTy( AllTrim( Paciente->Nombre + Paciente->Historia ) ), ;
               aadd( aFiltrados, str(Paciente->( RecNo() ) ) ), Nil )  } ) )
endif

bBorrar := {|| aX := {},;
      aEval( aFiltrados, {| c, n | iif(  Val( AllTrim( aFiltrados[ n ] ) ) > 0,  aadd( aX, aFiltrados[ n ] ),   )  } ), ;
     											aFiltrados := aClone( aX ), aX := {} }

     // Ahora eliminar de la lista los registros borrados
        Eval( bBorrar )

// VerLosDatos( aFiltrados, lVacio )
// RETURN nIL

// PROCESO EN BASES DE EXPLORACIONES
// Si hay ya pacientes seleccionados se revisan las bases de expl para dichos pacientes
// pero si no los hay se har sobre la base de datos completa.
// Antes se revisa si hay filtros establecidos para bases de expl

lSalir := .f.
lHay2 := .f.
aEval( aGExpl, { | c, n | lHay2 := iif( at( ";", aGExpl[ n ] ) > 0, .t., lHay2 ) } ) 

if lHay2 // Hay filtros de patologia de exploraciones

n1 := Len( aGExpl ) + Len( aValues ) // Para seguir con los memolines de cmemo
// nI := Len( aValues ) + 1
// For nI = nI To n1  // La lista de los campos bases de exploracion que se evaluan
// desde 10 a 23
For nI = ( Len( aValues ) + 1 ) To n1  // La lista de los campos bases de exploracion que se evaluan
   a1 := {} 
   c1 := Trim( memoLine( cMemo, , nI )  )
if !Empty( AllTrim( memoLine( cMemo, , nI ) ) )  // Sin filtro = acelerar saltando todo
  do While at( ";", c1 ) > 0
       c2 := SubsTr( c1, 1, at( ";", c1 )-1 )
  //     c1 := SubsTr( c1,  at( ";", c1 ) + 1 )
    //   aadd( a1, AnsiToOem( c2 ) )  // Se crea array con las cadenas a procesar
       if ( nI -Len( aValues ) == 3 .or. nI -Len( aValues ) == 4 ) .and. at( "$", c2 ) > 0     // at( "$", a1[ Len( a1 ) ] ) > 0
             // c2 := SubsTr( c1, 1, at( ";", c1 )-1 )
             aadd( a1, AnsiToOem( c2 ) ) 
             c1 := SubsTr( c1,  at( ";", c1 ) + 1 )
             c2 := SubsTr( c1, 1, at( ";", c1 )-1 )
             if  at( "$", c2 ) > 0
             		 a1[ Len( a1 ) ] += c2 
             else
                     aadd( a1, AnsiToOem( c2 ) )
             endif
       	   
       	   c1 := SubsTr( c1,  at( ";", c1 ) + 1 )                          
       else
       c2 := SubsTr( c1, 1, at( ";", c1 )-1 )
       c1 := SubsTr( c1,  at( ";", c1 ) + 1 )
       aadd( a1, AnsiToOem( c2 ) )  // Se crea array con las cadenas a procesar
       endif
  enddo
 
  if Len( a1 ) > 0

  	for n2 = 1 to Len( a1 )  // cada elemento de filtro para cada cada base
                                               // se hace para clasificarlos pero se envia a1 a la funcion bases(
                                               // para q ah se haga rapidamente la evaluacin ..	
   Do Case  // se usa case en vez de if para mejor entendimiento
   
   case Len( aFiltrados ) > 0  // Lista con seleccionados. Usar lista de seleccionados
  
   if ( nI -Len( aValues ) == 3 .or. nI -Len( aValues ) == 4 ) .and. at( "$", a1[ n2 ] ) > 0  // Valor para nmero en refr y pio
      
     do case
     
     case  nI -Len( aValues ) == 3  // refraccion
	For n = 1 to Len( aFiltrados )
	   if Val( AllTrim( aFiltrados[ n ] ) ) > 0  // Por si se escapa alguno, evitar error
              if Refra( a1[ n2 ], aFiltrados[ n ] )
	           // Si es .f. = no cumple el filtro y se borrar de la lista
	           If !( lExcluir ) .and. Ascan( aFallidos, aFiltrados[ n ] ) > 0
	              ADel( aFallidos, Ascan( aFallidos, aFiltrados[ n ] ) )
	              ASize( aFallidos, Len( aFallidos ) -1 )
	           Endif
	        else
	            if lExcluir   
	               aFiltrados[  n ] := " "   // Si no hay se borra de filtrados
	            else
	               if Ascan( aFallidos, aFiltrados[  n ] ) == 0
	               	aadd( aFallidos, aFiltrados[ n ] )
	               endif
	            endif              
              endif
        endif
     Next           
     
     case  nI -Len( aValues ) == 4  // Pio
     For n = 1 to Len( aFiltrados )
	   if Val( AllTrim( aFiltrados[ n ] ) ) > 0  // Por si se escapa alguno, evitar error
              if BPIO( a1[ n2 ], aFiltrados[ n ] )
	           // Si es .f. = no cumple el filtro y se borrar de la lista
	           If !( lExcluir ) .and. Ascan( aFallidos, aFiltrados[ n ] ) > 0
	              ADel( aFallidos, Ascan( aFallidos, aFiltrados[ n ] ) )
	              ASize( aFallidos, Len( aFallidos ) -1 )
	           Endif
	        else
	            if lExcluir   
	               aFiltrados[  n ] := " "   // Si no hay se borra de filtrados
	            else
	               if Ascan( aFallidos, aFiltrados[  n ] ) == 0
	               	aadd( aFallidos, aFiltrados[ n ] )
	               endif
	            endif
              
              endif
        endif
     Next           
     
     endcase
   
   else // las normales de texto de cualquier expl
	   a1[ n2 ] := StrTran( a1[ n2 ], "$", ""  )  // Se eliminan los dolares improcedentes
	   For n = 1 to Len( aFiltrados )
	   if Val( AllTrim( aFiltrados[ n ] ) ) > 0  // Por si se escapa alguno, evitar error
     	   if Bases( nI -Len( aValues ), a1, aFiltrados[ n ], ,1 )  // Base num, texto patologia, registro pac otra IDE
	           // Si es .f. = no cumple el filtro y se borrar de la lista
	           If !( lExcluir ) .and. Ascan( aFallidos, aFiltrados[ n ] ) > 0
	              ADel( aFallidos, Ascan( aFallidos, aFiltrados[ n ] ) )
	              ASize( aFallidos, Len( aFallidos ) -1 )
	           Endif
	        else
	            if lExcluir   
	               aFiltrados[  n ] := " "   // Si no hay se borra de filtrados
	            else
	               if Ascan( aFallidos, aFiltrados[  n ] ) == 0
	               	aadd( aFallidos, aFiltrados[ n ] )
	               endif
	            endif
	        endif
	  endif
	  Next
	   lSalir := .t.  // ya revisado a1 en la funcion BASES( , entero, salir del for de a1
	   exit
   endif
 
   otherwise                              // Lista vaca. Usar la base de paciente entera para crear seleccion
 
   For n = 1 to Paciente->( LastRec() )
        If Bases( nI -Len( aValues ), a1, AllTrim( Str( n ) ), .t. )  // Base num, texto patologia, registro pac, lBasePac         
                aadd( aFiltrados, AllTrim( Str( n ) ) )
	           If !( lExcluir ) .and. Ascan( aFallidos, aFiltrados[ n ] ) > 0
	              ADel( aFallidos, Ascan( aFallidos, aFiltrados[ n ] ) )
	              ASize( aFallidos, Len( aFallidos ) -1 )
	           Endif
        else    
           if !( lExcluir )   
               aadd( aFiltrados, AllTrim( Str( n ) ) )         
        	     if Ascan( aFallidos, aFiltrados[  n ] ) == 0                
               	aadd( aFallidos, aFiltrados[ n ] )
               endif
           endif
        endif
   Next    
 
   	   lSalir := .t.  // ya revisado a1 entero en BASES(, salir del for de a1
	   exit
   EndCase
   
     next  // de n2 // cada elemento de cada base
      
  endif  // de si len( a1 ) > 0
           Eval( bBorrar ) 
  endif // de acelerar saltando si el campo de expl no tiene puesto filtro en cMemo           
Next // de aGExpl

// Ahora eliminar si han sido no excluyentes
if !( lExcluir )
For nI = 1 To Len( aFallidos )
   n := Ascan( aFiltrados, aFallidos[ nI ] )
   if n > 0
        aFiltrados[ n ] := " "
   endif
Next
  Eval( bBorrar ) 
endif

endif  // de si lHay2

     // Ahora eliminar de la lista los registros borrados
        Eval( bBorrar ) 
        
 CursorWait()
 
//if !( VerLosDatos( aFiltrados, lVacio ) ) .or. lListado

// VerLosDatos( aFiltrados, lVacio ) // Se crea el archivo de pacientes filtrados
// lListado := ( Empty( aGPer[ 1 ] ) .and. Empty( aGPer[ 2 ] ) )
if  lListado
      msgwait( iif( lListado, "Grficas no disponibles: Faltan periodos", "" ), "Puede ver Listados", 1 )
     Ferase( "WOCGET.TXT" )
     RETURN NIL
else
	If Len( aFiltrados ) < 1
   		MsgStop(  "Ningn paciente tras el filtrado.", "Atencin" )
	     RETURN NIL
	endif
      MsgWait( "Grficas y Listados", "Disponibles", 0.8 )
       // y a continuacion de crean las listas para leer las graficas
endif
//-------------------------------------------

// PROCESO EN  MESES y AOS
// Si hay ya pacientes seleccionados se revisan loa meses y aos para esos pacientes
// pero si no los hay se har sobre la base de datos completa.
// Antes se revisa si hay establecidos aos y meses; si no hay aos se ponen
// los 3 ultimos y si no hay meses se ponen los 6 primeros de cada ao. = se suprime
 // para q se puedan hacer listado adems o en vez de grficas.

     // Ahora eliminar de la lista los registros borrados
        Eval( bBorrar )
 
If lFech

lSalir := .f.
lHay2 := .f.
aEval( aGPer, { | c, n | lHay2 := iif( at( ";", aGPer[ n ] ) > 0, .t., lHay2 ) } ) 

// Empieza proceso de fechas
// PRIMERO CREACION DEL ARRAY DE MESES CON LAS CELDAS DE AOS VACIAS
n1 := Len( aGPer ) + Len( aGExpl ) + Len( aValues ) // Para seguir con los memolines de cmemo
nI := Len( aGExpl ) + Len( aValues ) + 1

// Primero lista de meses
   aDatMes := {} 
   if !( nRGr == 2 )
   c1 := Trim( memoLine( cMemo, , nI )  )
   do While at( ";", c1 ) > 0
       c2 := SubsTr( c1, 1, at( ";", c1 )-1 )
       c1 := SubsTr( c1,  at( ";", c1 ) + 1 )
       aadd( aDatMes, AllTrim(c2)  )  // Se crea array con las cadenas a procesar, en caracteres
  enddo
  else
     aadd( aDatMes, "Ao" )
  endif
  aMeses := {}
   
// Ahora la lista de aos 
 nI := n1  // Linea de aos  
 aDatAn := {}
   c1 := Trim( memoLine( cMemo, , nI )  )
   do While at( ";", c1 ) > 0
       c2 := SubsTr( c1, 1, at( ";", c1 )-1 )
       c1 := SubsTr( c1,  at( ";", c1 ) + 1 )
       aadd( aDatAn, AllTrim(c2)  )  // Se crea array con las cadenas a procesar, en caracteres
   enddo
 
// Ahora se crea la lista vacia y sin cabeceros de meses ni aos
	aListado := Array( Len( aDatAn ), Len( aDatMes ) )
     // y la llenamos de valores iniciales de caracteres, vacios
	For nI = 1 To Len( aDatAn )
    		AFILL( aListado[ nI ], "0" + Space( nSpaces )  )
	Next
	
// Fin lineas de fechas, con las casillas de meses vacias y sin las cabeceras de meses ni aos  aDatMes y aDatAn
// y el array preparado se llama aListado
endif // de si lfech de datos de fechas no vacios s/n

 a1 := {}

// Empieza el proceso de datos
// CARGAR LOS VALORES EN LAS CELDAS DE LOS MESES DE LOS AOS
aUsados := {}
nCons := 0
If Len( aFiltrados ) > 0 // Admitidos en la lista
For nI = 1 To Len( aFiltrados ) // Se tratan uno a uno los pacientes filtrados

Paciente->( DbGoto( Val( AllTrim( aFiltrados[ nI ] ) ) ) )
Historic->( DbSeek( Paciente->Historia ) )
Do While AllTrim( Historic->Historia ) == AllTrim( Paciente->Historia )
 
n1 := n2 :=  0
 if Empty( Historic->Fecha )
	// nada ..
 else
   if AllTrim( Historic->Historia ) == AllTrim( Paciente->Historia )
	 if Len( aDatAn ) > 0
	 	// Se busca mes y ao 
	 	n1 :=  Ascan( aDatAn, cValToChar( Year( Historic->Fecha ) ) ) 
          if at( "Ao", aDatMes[ 1 ]  ) == 0          
 	 	      n2 := Ascan( aDatMes, AllTrim( Str( Month( Historic->Fecha ) ) ) )          
          else
                n2 := 1
          endif
 		If   n1 > 0 .and. n2  > 0 
   			aListado[ n1, n2 ] := Str( Val( aListado[ n1, n2 ] ) +1 )
               nCons ++
               if Ascan( aUsados, aFiltrados[ nI ] ) == 0
               	aadd( aUsados, aFiltrados[ nI ] )
               endif	
		endif      
	 endif
   endif

endif

		Historic->( DbSkip() )

EndDo
Next // de 1 a len( filtrados )
 // Fin de afiltrados > 0

else  // Entonces la base Paciente.dbf entera
 
For nI = 1 To Paciente->( LastRec() )  // Se tratan uno a uno los pacientes

Paciente->( DbGoto( nI ) )
Historic->( DbSeek( Paciente->Historia ) )
Do While AllTrim( Historic->Historia ) == AllTrim( Paciente->Historia )
 
 n1 := n2 := 0
 
 // if Empty( Historic->Fecha )
	// nada ..
// else
   if Historic->Historia == Paciente->Historia 
	 	// Se busca mes y ao 
	 	n1 :=  Ascan( aDatAn, cValToChar( Year( Historic->Fecha ) ) ) 
          if at( "Ao", aDatMes[ 1 ]  ) == 0          
 	 	      n2 := Ascan( aDatMes, AllTrim( Str( Month( Historic->Fecha ) ) ) )          
          else
                n2 := 1
          endif
 		If   n1 > 0 .and. n2  > 0 
   			aListado[ n1, n2 ] := Str( Val( aListado[ n1, n2 ] ) +1 )
               nCons ++
               if Ascan( aUsados, aFiltrados[ nI ] ) == 0                 
               	aadd( aUsados, aFiltrados[ nI ] )
               endif	
		endif
   // endif
endif
 
		Historic->( DbSkip() )
		
// aUsados proporciona el numero de consultas, no de pacientes, que puede haber
// mas de una por cada uno

EndDo

Next // de 1 a Paciente Lastrec

endif  // fin de filtrados o Paciente.dbf
 
// Termina el proceso de datos
// Fin proceso de fechas
// CREACION DE LA LISTA DE graficas

// aFiltrados := iif( Len( aUsados ) > 0, Aclone( aUsados ), aFiltrados )  // no, porque aUsados = totales incluso repetds
// VerLosDatos( aFiltrados, lVacio ) // Se crea el archivo de pacientes filtrados 
 c1 := ""
 
 // Primero la linea con los nombres de meses
if aDatMes[ 1 ] ==  "Ao" 
     aDatMes[ 1 ] :=  "Ao;"  
     c1 := "Aos completos;"
     c1 += CRLF 
else
// aEval( aDatMes, {| c, n | c1 += aLMeses[ Val( aDatMes[ n ] ) ] + ";"  } )   // pasarlo a for to next
// aEval( aDatMes, {| c, n | nI2 := n, iif( Val( aDatMes[ nI2 ] ) > 0 .and. Val( aDatMes[ nI2 ] ) < Len( aLMeses ) +1, ;
// 																	c1 += aLMeses[ Val( aDatMes[ nI2 ] ) ] + ";" + CRLF, Nil ) } )
  For nI2 = 1 to Len( aDatMes )
   if     Val( aDatMes[ nI2 ] ) > 0 .and. Val( aDatMes[ nI2 ] ) < Len( aLMeses ) +1
      c1 += aLMeses[ Val( aDatMes[ nI2 ] ) ] + ";"
   endif
  next    
      c1 += CRLF 
   
     
endif
// Ahora las dems lineas      
nInf := 0
nPac   := Paciente->( LastRec() )
for nI = 1 to len( aDatAn )
     
     a1 := aListado[ nI ]
     
     do case
     case nRad ==  1
          	aEval( a1, {| c, n | n1 := n, c1 += AllTrim( Str( INT( Val( a1[ n1 ] ) ) ) ) + ";" } )
     case nRad ==  2   //3
    //    if Len( aFiltrados ) > 0
         	aEval( a1, {| c, n | n1 := n, c1 += AllTrim( Str( Val( a1[ n1 ] )*100/Len( aFiltrados ) ), 5, 0 ) + ";" } )          
    //    endif
     endcase
           
     aEval( a1, {| c, n | n1 := n, nInf += INT( Val( a1[ n1 ] ) )  } )
      
      c1 += CRLF
       
next  
 
  c2 := c1
   
  // Ahora, a todas las lneas anteponer la srie
if aDatMes[ 1 ] == "Ao;"
  c1 := iif( nRad > 1, " Por%;", " ----- ;" ) + "Ao completo;" + CRLF 
else
  c1 := iif( nRad > 1, " Por%;", " ----- ;" ) + AllTrim( MemoLine( c2,, 1 ) ) + CRLF 
endif
  For nI = 1 To Len( aDatAn )
   		c1 += aDatAn[ nI  ] + ";" + AllTrim( MemoLine( c2,, nI+1 ) ) + CRLF 
  Next
  cBasico := c1 
  
  MemoWrit( "WOCGET.TXT", c1 )
 VerLosDatos( aFiltrados, lVacio ) // Se crea el archivo de pacientes filtrados 
 
Return Nil
// Fin proceso aos y meses

static function VerLosDatos( aFiltrados, lVacio, lInforme )
local c1, c2, c3, c4, c11, a1, a2, a3, a4, aDbf, n, n1, n2, n3, n4, nI, lGraf := .f., oScr, cTool, nVac,  lOpen := .f., aCiudad := {}
local AnMes, aDatMes := {}, aDatAn := {}, aPac := {},  a12, a13, cFechas
local  a44,  a45,  c21 := "", aSexos := {}
local aLMeses2 := { "Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic" }
local aLMeses := { "En", "Fe", "Mr", "Ab", "My", "Jn", "Jl", "Ag", "Se", "Oc", "Nv", "Dc" }
local cTx3, nTx3, cTx4, nTx4, aNombre := {}
DEFAULT lInforme := .f.

aN3 := { 1, 1, 1 }
 // aFiltrados := ASort( aFiltrados,,,{ | x, y| Upper( x ) < Upper( y ) } )
nVac := 0
a1 := aClone( aFiltrados ) 
a1 := ASORT( a1,,,{ | x, y| Upper( x ) < Upper( y ) } ) 
c1 := ""
aInf := {}
// MSGLIST( a1 ) 
// ESTE BLOQUE ES LA UNICA FORMA DE Obtener
// EL TEXTO ORDENADO, DE LOS ARRAYS NO SE ORDENA EL TEXTO
// NADA MAS QUE AL MOSTRAR LA LISTA
// cBaseTmp := "TMP" + Alltrim( Str( Len( a1 )  ) ) + ".DBF"
if Ascan( aGetWorkAreas(), "TEMPFILT" ) > 0
     TempFilt->( DbCloseArea() )
endif
       
 aDbf := {} ; aDatCels := {}; aDatCels2 := {}; aDatCels3 := {}
 aadd( aDbf,  { "NOMBRE", "C", 40, 0 }  )
 aadd( aDbf,  { "POBLACION", "C", 30, 0 }  )
 aadd( aDbf,  { "TELEFONO", "C", 30, 0 }  )
 aadd( aDbf,  { "FECHANACI", "C", 10, 0 }  )
 aadd( aDbf,  { "SEXO", "C", 1, 0 }  )
 aadd( aDbf,  { "ALERGIAS", "C", 30, 0 }  )
 aadd( aDbf,  { "DPOSTAL", "C", 30, 0 }  )
 DbCreate( "TEMPFILT", aDbf  )
 USE TEMPFILT  NEW
 INDEX ON TEMPFILT->NOMBRE TO TEMPFILT
 
 TEMPFILT->( DBCLOSEAREA() )
 USE TEMPFILT INDEX TEMPFILT
 TEMPFILT->( DBREINDEX() )

if Ascan( aGetWorkAreas(), "PACIENTE" ) == 0
	DbUseArea( .t., , "PACIENTE", , .T. ) // modo compartido
	lOpen := .t.      
endif
  CursorWait()
  
     Paciente->( DBEVAL( {|| nVac := ;
        iif( EmpTy( AllTrim( Paciente->Nombre ) ) .or. Empty( AllTrim( Paciente->Historia ) ), nVac++, nVac )  } ) )
 
FOR n = 1 To Len( a1 )     
     Paciente->( DbGoto( Val( AllTrim( a1[ n ] ) ) ) )
 
 /*       c1 :=  AllTrim( OemToAnsi( Paciente->Nombre ) ) + " - " + iif( !EmpTy(  Paciente->Poblacion ), ;
             AllTrim( OemToAnsi( Paciente->Poblacion ) )  + ;
" - ", "" ) + cValToChar( Paciente->FechaNaci )	+ " - " + iif( AllTrim( Paciente->Sexo ) == "V", "H", "M" ) + ;
  	+ 	iif( !EmpTy(  Paciente->Telefono ),  " - " +  AllTrim( OemToAnsi( Paciente->Telefono ) ), "" ) 
  */
  
    TEMPFILT->( DBAPPEND() )
    TEMPFILT->NOMBRE := OemToAnsi( Paciente->NOMBRE )
    TEMPFILT->Poblacion := OemToAnsi( Paciente->Poblacion )
    TEMPFILT->Telefono := OemToAnsi( Paciente->Telefono )
    TEMPFILT->Fechanaci := cValToChar( Paciente->Fechanaci )
    TEMPFILT->Sexo := iif( AllTrim( Paciente->Sexo ) == "V", "H", "M" )
    TEMPFILT->Alergias := OemToAnsi( Paciente->Alergias )
    TEMPFILT->DPostal := OemToAnsi( Paciente->DPostal )
  //  a1[n] := c1

Next

   // Aos
   c3 := AllTrim( aGPer[ 2 ] )
   if at( ";", c3 ) > 0
     do While at( ";", c3 ) > 0
        c4 := SubsTr( c3, 1, at( ";", c3 )-1 )     
         c3 := SubsTr( c3, at( ";", c3 ) +1 )
        aadd( aDatAn, c4 )
     enddo
   endif
 
   // Meses
   c3 := AllTrim( aGPer[ 1 ] )
   if at( ";", c3 ) > 0
     do While at( ";", c3 ) > 0
        c4 := SubsTr( c3, 1, at( ";", c3 )-1 )     
        c3 := SubsTr( c3, at( ";", c3 ) +1 )
        aadd( aDatMes, c4 )
     enddo
   else    
      if !Empty( AllTrim( aGPer[ 2 ] ) )
         aDatMes := { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12" }
      endif
   endif
  
        // para aUsados
        a2 := {}
        c11 := AllTrim( aValues[ 1 ]  )
 
 if  at( ";", c11 ) > 0 .and. Len( aFiltrados ) > 0 .and. !Empty( aGPer[ 2 ] )
  lNombres := .t.   
    c2 := c3 := c4 := ""  // c1 es filtros de ciudades
 
   // Nombres
    aNombre := {}
   do While at( ";", c11 ) > 0
       c2 := SubsTr( c11, 1, at( ";", c11 )-1 )
       c11 := SubsTr( c11,  at( ";", c11 ) + 1 )   
       aadd( aNombre, AllTrim(c2)  )  // Se crea array con las cadenas a procesar, en caracteres
   enddo
   
For n = 1 to Len( aNombre )
     for n1 = 1 to Len( aDatAn )
              a2 := {}
              aadd( a2,  AllTrim( aNombre[ n ] ) + " - " + AllTrim( aDatAn[ n1 ] ) )
 
              for n2 = 1 to Len( aDatMes )
              		aadd( a2, "0" )  // aDatMes[ n2 ] )               
              next
              aadd( aDatCels2, a2 )
              //  msglist( a2, "a2" )
     next
next
 
endif

// Ya en aDatCels2 tenemos p.ej:
// { "JOS - 2006", "4", "5", "6", "7" } 
// { "JOS - 2007", "4", "5", "6", "7" }   
// { "JUAN - 2006", "4", "5", "6", "7" }
// { "JUAN - 2007", "4", "5", "6", "7" }
// y ahora pasar Nombre pac + ao al campo de DATOS, y la cadena de nombres meses + nums pacs + % de aUsados al
// campo de filtros, procesando aPac relacionado con aDatCels
   // Fin Nombres de pacientes
   
// Iniciando ciudades   
        // para aUsados
        a2 := {}
        c1 := AllTrim( aValues[ 3 ]  )
 
 if  at( ";", c1 ) > 0 .and. Len( aFiltrados ) > 0 .and. !Empty( aGPer[ 2 ] )
  lCiudades := .t.   
  
   c2 := c3 := c4 := ""  // c1 es filtros de ciudades
 
   // Ciudades
    aCiudad := {}
   do While at( ";", c1 ) > 0
       c2 := SubsTr( c1, 1, at( ";", c1 )-1 )
       c1 := SubsTr( c1,  at( ";", c1 ) + 1 )   
       aadd( aCiudad, AllTrim(c2)  )  // Se crea array con las cadenas a procesar, en caracteres
   enddo
   
For n = 1 to Len( aCiudad )
     for n1 = 1 to Len( aDatAn )
              a2 := {}
              aadd( a2,  AllTrim( aCiudad[ n ] ) + " - " + AllTrim( aDatAn[ n1 ] ) )
 
              for n2 = 1 to Len( aDatMes )
              		aadd( a2, "0" )  // aDatMes[ n2 ] )               
              next
              aadd( aDatCels, a2 )
              //  msglist( a2, "a2" )
     next
next
 
endif

// Ya en aDatCels tenemos p.ej:
// { "JEREZ - 2006", "4", "5", "6", "7" } 
// { "JEREZ - 2007", "4", "5", "6", "7" }   
// { "JEREZ - 2008", "4", "5", "6", "7" }
// { "CHICL - 2006", "4", "5", "6", "7" }
// { "CHICL - 2007", "4", "5", "6", "7" }
// { "CHICL - 2008", "4", "5", "6", "7" }
// y ahora pasar ciudad + ao al campo de DATOS, y la cadena de nombres meses + nums pacs + % de aUsados al
// campo de filtros, procesando aPac relacionado con aDatCels

//----- Empieza SEXO
        // para aUsados
        a2 := {}
        c21 := AllTrim( aValues[ 7 ]  )
        // eliminar los dos sexos, HV, a la vez
        c21 := iif( at( "H", Upper( c21 ) ) > 0 .and. at( "V", Upper( c21 ) ) > 0, "", c21 )
 // msglist( aFiltrados, str( Len( aFiltrados ) ) )
 if  at( ";", c21 ) > 0 .and. Len( aFiltrados ) > 0 .and. !Empty( aGPer[ 2 ] )
  lSexos := .t.   
    c2 := c3 := c4 := ""  // c1 es filtros de ciudades
 
   // Sexos
    aSexos := {}
   do While at( ";", c21 ) > 0
       c2 := SubsTr( c21, 1, at( ";", c21 )-1 )
       c21 := SubsTr( c21,  at( ";", c21 ) + 1 )   
       if Len( c2 ) > 0 
       		aadd( aSexos, AllTrim(c2)  )  // Se crea array con las cadenas a procesar, en caracteres
       endif
   enddo
  
For n = 1 to Len( aSexos )
     for n1 = 1 to Len( aDatAn )
              a2 := {}
              aadd( a2,  AllTrim( aSexos[ n ] ) + " - " + AllTrim( aDatAn[ n1 ] ) )
    
              for n2 = 1 to Len( aDatMes )
              		aadd( a2, "0" )  // aDatMes[ n2 ] )               
              next
              aadd( aDatCels3, a2 )
   
     next
next
  
endif

// Ya en aDatCels3 tenemos p.ej:
// { "H - 2006", "4", "5", "6", "7" } 
// { "H - 2007", "4", "5", "6", "7" }   
// { "M - 2006", "4", "5", "6", "7" }
// { "M - 2007", "4", "5", "6", "7" }
// y ahora pasar Sexo pac + ao al campo de DATOS, y la cadena de nombres meses + nums pacs + % de aUsados al
// campo de filtros, procesando aPac relacionado con aDatCels
   // Fin sexos de pacientes

//------Termina SEXO

                  aadd( aInf, { "PACIENTES FILTRADOS: ", "  - I N F O R M E -" } )
                  aadd( aInf, { "", "" } )
       c1 := "" ; c2 := ""
       for n = 1 to Len( aValues )  // MLCount( cMemo )
                 c2 += AllTrim( Memoline( cMemo,, n ) ) + "   "
       next
       if !Empty( c2 )
                  aadd( aInf, { "DATOS DE FILIACIN: ", "  F I L T R O S usados." } )
       else
                  aadd( aInf, { "DATOS DE FILIACIN: ", "  S I N   F I L T R O S." } )       
       endif           
       
	c1 := "" ; c2 := ""
 	if ! lVacio       
 	  cFechas := ""
 	  if !Empty( aValues[ 5 ] )
 	      aValues[ 5 ] := AllTrim( aValues[ 5 ] ) 
 	      cFechas := "Incio: 01/01/" + SubsTr( aValues[ 5 ], 1, at( ";", aValues[ 5 ] )-1  )
 	      c4 := SubsTr( aValues[ 5 ], at( ";", aValues[ 5 ] ) +1  )
 	      c4 := iif( len( c4 ) > 0, "01/01/" + AllTrim( StrTran( c4, ";", "" ) ), "Hoy" )
 	      cFechas += " - Fin: " + c4
 	      c4 := ""
 	  endif
       for n = 1 to Len( aValues )  // MLCount( cMemo )
            if !Empty( Memoline( cMemo,, n ) )
                 // aadd( aInf, { aSay[ n ] + ": ", "  " + iif( n == 5, "Incio: 01/01/", "" ) + aValues[ n ] } )
                 aadd( aInf, { aSay[ n ] + ": ", "  " + iif( n == 5, cFechas, aValues[ n ] )  } )
                c1 += AllTrim( Memoline( cMemo,, n ) ) + "   "
            endif
       next
       c1 := iif( Empty( c1 ), "  Filiacin: Sin Filtros - ", c1 )
       
                  aadd( aInf, { "", "" } )

       for n = n to Len( aValues ) + Len( aGExpl )  // MLCount( cMemo )
                 c2 += AllTrim( Memoline( cMemo,, n ) ) + "   "
       next 	        
       if Empty( c2 )
                  aadd( aInf, { "EXPLORACIONES: ", "  S I N   F I L T R O S." } )       
       else
                  aadd( aInf, { "EXPLORACIONES: ", "  F I L T R O S usados." } )              
       	for n = 10 to 23    //Len( aValues ) + Len( aGExpl )  // MLCount( cMemo )
            	if !Empty( aGExpl[ n -9 ] )  //  Memoline( cMemo,, n ) )
                 aadd( aInf, { aSExpl[ n - 9 ] + ": ", "  " + aGExpl[ n - 9 ] } )
               endif
                c1 += AllTrim( Memoline( cMemo,, n ) ) + "   "
                c2 += AllTrim( Memoline( cMemo,, n ) ) + "   "
       	next 	        
       endif
       
       c1 := iif( Empty( c2 ), c1 + "  Exploraciones: Sin Filtros - ", c1 )
        for n = n to MLCount( cMemo )
            if !Empty( Memoline( cMemo,, n ) )
                c1 += AllTrim( Memoline( cMemo,, n ) ) + "   "
            endif
        next
     endif
                  aadd( aInf, { "", "" } )     
                  aadd( aInf, { "Recuento de PACIENTES FILTRADOS: ", "  " + AllTrim( Str( TempFilt->( LastRec() ) ) ) + " del total " + ;
                  					   AllTrim( Str( Paciente->( LastRec() ) -nVac ) ) + ;
                  					   " = " + AllTrim( str( Len( a1 )*100 / Paciente->( LastRec() ), 8, 2 ) ) + " %"  } )
                        
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "PERIODOS: ", "  M O S T R A R" } )
                  aadd( aInf, { "MESES: ", " " + aGPer[ 1 ] } )
                  aadd( aInf, { "AOS: ",    " " + aGPer[ 2 ]  } )
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "RECUENTO DE CONSULTAS PARA GRFICAS: ", "  " + AllTrim( Str( nInf ) ) + ;
                             "  de  " + AllTrim( Str( Len( aUsados ) ) ) + "   PACIENTES  " + ;
                        "(" + AllTrim( Str( Len( aUsados )*100 / Len( aFiltrados ), 8, 2 ) ) ;
                         + " % de los " + AllTrim( Str( Len( aFiltrados ) ) )  +  " filtrados, y " + ;
                                AllTrim( Str( Len( aUsados )*100 / Paciente->( LastRec() ), 8, 2 )  ) + " %  del total de pacientes." ;
                                    + ")"      } )
 
 // Mostrar aos y meses, consultas, informacin basica del chequeo
 // cBasico es esttica  EMPIEZA
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "CONSULTAS: Por Aos", "   y Meses"  } )
                  aadd( aInf, { "", "" } )                  
                 aadd( aInf, { "AO + (Total)[% de " + AllTrim( Str( nInf ) ) + "]: ", ;
                 					"  MES: NMERO + [% de " + AllTrim( Str( nInf ) ) + " Consultas halladas]" } )                  
            
            c1 := c2 := c3 := c4 := cTx4 := "" 
             n3 := n4 := 0 ; a45 := 0
     c1 := MemoLine( cBasico,, 1 )
     aadd( aInf, { substr( c1, 1, at( ";", c1 ) -1  ) + "  ", "  " + substr( c1, at( ";", c1 ) +1  ) } ) 
     
  For n = 1 To len( aListado )
     c11 := "" ; n4 := 0
     a13 := aListado[ n ]
     c1     := AllTrim( MemoLine( cBasico,, n+1 ) )
     c2     := substr( c1, 1, at( ";", c1 ) -1  )

     For n1 = 1 To Len( a13 )
        n4 += Val( a13[ n1 ] )
  //    if  Val( aDatMes[ n1 ] ) > 0 .and. Val( aDatMes[ n1 ] ) < Len( aLMeses ) +1
        c11 += aLMeses[ Val( aDatMes[ n1 ] ) ] + ": " + AllTrim( a13[ n1 ] ) + ;
        									"[" +  iif( Val( a13[ n1 ] ) > 0, AllTrim( Str( Val( a13[ n1 ] )*100/nInf ), 8, 2 ), "0.00" ) + ;
                     "]" + ";  "
    //   endif
     next

     n4 := AllTrim( Str( n4 ) )

     aadd( aInf, { c2 + "(" + n4 +  ")[" +  AllTrim( Str( Val( n4 )*100/nInf ), 8, 2 ) + "]: ", "  " + c11 } )

  next
 
           c1 := c2 := c3 := c4 := cTx4 := "" ; n3 := n4 := 0
      
// FINAL de mostrar Basico      
      
// SEXOS Empieza
// Ahora pasar SEXO + ao al campo de DATOS, y la cadena de meses + etc etc al campo de filtros
If lSexos
cTx3 := ""
n3 := 0  ; n4 := 0  ;  a45 := Array( Len( aDatCels3 ) )  ;  AFill( a45, "0" )  
For n = 1 to Len( aFiltrados )  
	Paciente->( DbGoto( Val( AllTrim( aFiltrados[ n ] ))))  
Historic->( DbSeek( Paciente->Historia ) )
Do While AllTrim( Historic->Historia ) == AllTrim( Paciente->Historia )
  
          For n1 = 1 To Len( aDatCels3 )
              n4 := 0               
              c2 := AllTrim( Str( Month( Historic->Fecha ) ) )              
              n2 := Ascan( aDatMes, c2 )
              cTx4 := AllTrim( Str( Year( Historic->Fecha ) ) )
              nTx4 := AT( cTx4, aDatCels3[ n1, 1 ] )
 
              cTx3 := aDatCels3[ n1, 1 ]  ; nTx3 := at( "-", cTx3 ) -1 ; cTx3 := SubsTr( cTx3, 1, nTx3 ) ; cTx3 := AllTrim( cTx3 )
               cTx3 := iif( cTx3 == "H", "V", "H" )
			if ( AT( cTx3, OemToAnsi( Paciente->Nombre )  ) > 0 .or. ;  // comprobar la ciudad
												AT( cTx3, OemToAnsi( Upper( Paciente->Sexo )  ) ) > 0 ) .and. ;
												             nTx4 > 0 .and. n2 > 0  // comprobar ao y mes
 
                                   aDatCels3[ n1, 1 + n2 ] := AllTrim( Str( Val( AllTrim( aDatCels3[ n1, 1 + n2 ] ) ) +1 ) )
         					     n3++         
                                   n4++
                                   a45[ n1 ] := AllTrim( Str( Val( a45[ n1 ] ) +1 ) )  
              endif
              
          Next
 		
		Historic->( DbSkip() )
		
     EndDo

Next
aN3[ 3 ] := n3

if Len( aDatCels3 ) > 0 .and. Len( aSexos ) > 0
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "S E X O S: ", "  " + aValues[ 7 ]  } )
                  aadd( aInf, { "", "" } )                  
                 aadd( aInf, { "SEXO + AO + (Total)[% de " + AllTrim( Str( n3 ) ) + "]: ", ;
                 					"  MES: NMERO + [% de " + AllTrim( Str( n3 ) ) + " Consultas halladas]" } )                  
  For n = 1 To len( aDatCels3 )
     c11 := ""
     a13 := aDatCels3[ n ]

     For n1 = 2 To Len( a13 )
  
        c11 += aLMeses[ Val( aDatMes[ n1-1 ] ) ] + ": " + a13[ n1 ] + "[" +  iif( Val( a13[ n1 ] ) > 0, AllTrim( Str( Val( a13[ n1 ] )*100/n3 ), 8, 2 ), "0.00" ) + ;
                     "]" + ";  "
     next
     
     aadd( aInf, { aDatCels3[ n, 1 ] + "(" + a45[ n ] +  ")[" +  AllTrim( Str( Val( a45[ n ] )*100/n3 ), 8, 2 ) + "]: ", "  " + c11 } )

 next

endif 
                  aadd( aInf, { "", "" } )                  
Endif // FIN  de SEXOS

// FIN SEXOS


// NOMBRES
// Ahora pasar nombre + ao al campo de DATOS, y la cadena de meses + etc etc al campo de filtros
If lNombres
cTx3 := ""
n3 := 0  ; n4 := 0  ;  a44 := Array( Len( aDatCels2 ) )  ;  AFill( a44, "0" )
For n = 1 to Len( aFiltrados )  
	Paciente->( DbGoto( Val( AllTrim( aFiltrados[ n ] ))))  
Historic->( DbSeek( Paciente->Historia ) )
Do While AllTrim( Historic->Historia ) == AllTrim( Paciente->Historia )
  
          For n1 = 1 To Len( aDatCels2 )
              n4 := 0               
              c2 := AllTrim( Str( Month( Historic->Fecha ) ) )              
              n2 := Ascan( aDatMes, c2 )
              cTx4 := AllTrim( Str( Year( Historic->Fecha ) ) )
              nTx4 := AT( cTx4, aDatCels2[ n1, 1 ] )
 
              cTx3 := aDatCels2[ n1, 1 ]  ; nTx3 := at( "-", cTx3 ) -1 ; cTx3 := SubsTr( cTx3, 1, nTx3 ) ; cTx3 := AllTrim( cTx3 )

			if ( AT( cTx3, OemToAnsi( Paciente->Nombre )  ) > 0 .or. ;  // comprobar la ciudad
												AT( cTx3, OemToAnsi( Upper( Paciente->Nombre )  ) ) > 0 ) .and. ;
												             nTx4 > 0 .and. n2 > 0  // comprobar ao y mes
 
                                   aDatCels2[ n1, 1 + n2 ] := AllTrim( Str( Val( AllTrim( aDatCels2[ n1, 1 + n2 ] ) ) +1 ) )
         					     n3++         
                                   n4++
                                   a44[ n1 ] := AllTrim( Str( Val( a44[ n1 ] ) +1 ) )  
              endif
              
          Next
 		
		Historic->( DbSkip() )
		
     EndDo

Next
aN3[ 2 ] := n3

if Len( aDatCels2 ) > 0 .and. Len( aNombre ) > 0
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "N O M B R E S: ", "  " + aValues[ 1 ]  } )
                  aadd( aInf, { "", "" } )                  
                 aadd( aInf, { "NOMBRE + AO + (Total)[% de " + AllTrim( Str( n3 ) ) + "]: ", ;
                 					"  MES: NMERO + [% de " + AllTrim( Str( n3 ) ) + " Consultas halladas]" } )                  
  For n = 1 To len( aDatCels2 )
     c11 := ""
     a13 := aDatCels2[ n ]

     For n1 = 2 To Len( a13 )
  
        c11 += aLMeses[ Val( aDatMes[ n1-1 ] ) ] + ": " + a13[ n1 ] + "[" +  iif( Val( a13[ n1 ] ) > 0, AllTrim( Str( Val( a13[ n1 ] )*100/n3 ), 8, 2 ), "0.00" ) + ;
                     "]" + ";  "
     next
     
     aadd( aInf, { aDatCels2[ n, 1 ] + "(" + a44[ n ] +  ")[" +  AllTrim( Str( Val( a44[ n ] )*100/n3 ), 8, 2 ) + "]: ", "  " + c11 } )

 next

endif 
                  aadd( aInf, { "", "" } )                  
Endif // FIN  de NOMBRES

// CIUDADES
// y ahora pasar ciudad + ao al campo de DATOS, y la cadena de nombres meses + nums pacs + % de aUsados al
// campo de filtros, procesando aPac relacionado con aDatCels
If lCiudades
cTx3 := ""
n3 := 0  ; n4 := 0  ;  a4 := Array( Len( aDatCels ) )  ;  AFill( a4, "0" )
For n = 1 to Len( aFiltrados )  // aUsados ) // aPac )
	Paciente->( DbGoto( Val( AllTrim( aFiltrados[ n ] ))))  
Historic->( DbSeek( Paciente->Historia ) )
Do While AllTrim( Historic->Historia ) == AllTrim( Paciente->Historia )
  
          For n1 = 1 To Len( aDatCels )
              n4 := 0               
              c2 := AllTrim( Str( Month( Historic->Fecha ) ) )              
              n2 := Ascan( aDatMes, c2 )
              cTx4 := AllTrim( Str( Year( Historic->Fecha ) ) )
              nTx4 := AT( cTx4, aDatCels[ n1, 1 ] )
 
              cTx3 := aDatCels[ n1, 1 ]  ; nTx3 := at( "-", cTx3 ) -1 ; cTx3 := SubsTr( cTx3, 1, nTx3 ) ; cTx3 := AllTrim( cTx3 )

			if ( AT( cTx3, OemToAnsi( Paciente->Poblacion )  ) > 0 .or. ;  // comprobar la ciudad
												AT( cTx3, OemToAnsi( Upper( Paciente->Poblacion )  ) ) > 0 ) .and. ;
												             nTx4 > 0 .and. n2 > 0  // comprobar ao y mes
 
                                   aDatCels[ n1, 1 + n2 ] := AllTrim( Str( Val( AllTrim( aDatCels[ n1, 1 + n2 ] ) ) +1 ) )
         					     n3++         
                                   n4++
                                   a4[ n1 ] := AllTrim( Str( Val( a4[ n1 ] ) +1 ) )  
              endif
              
          Next
 		
		Historic->( DbSkip() )
		
     EndDo

Next
aN3[ 1 ] := n3

if Len( aDatCels ) > 0 .and. Len( aCiudad ) > 0
                  aadd( aInf, { "", "" } )
                  aadd( aInf, { "C I U D A D E S: ", "  " + aValues[ 3 ]  } )
                  aadd( aInf, { "", "" } )                  
                 aadd( aInf, { "CIUDAD + AO + (Total)[% de " + AllTrim( Str( n3 ) ) + "]: ", ;
                 					"  MES: NMERO + [% de " + AllTrim( Str( n3 ) ) + " Consultas halladas]" } )                  
  For n = 1 To len( aDatCels )
     c1 := ""
     a12 := aDatCels[ n ] 
     
     For n1 = 2 To Len( a12 )
        c1 += aLMeses[ Val( aDatMes[ n1-1 ] ) ] + ": " + a12[ n1 ] + "[" +  iif( Val( a12[ n1 ] ) > 0, AllTrim( Str( Val( a12[ n1 ] )*100/n3 ), 8, 2 ), "0.00" ) + ;
                     "]" + ";  "
     next
     
     aadd( aInf, { aDatCels[ n, 1 ] + "(" + a4[ n ] +  ")[" +  AllTrim( Str( Val( a4[ n ] )*100/n3 ), 8, 2 ) + "]: ", "  " + c1 } )

 next

endif 
                  aadd( aInf, { "", "" } )                  

                  aadd( aInf, { "FIN DEL", "LISTADO." } )                                    
endif  // de si lCiudades

     	 c1 := "LISTADO " + iif(  !Empty( c1 ), "por FILTROS: " + "[ " + c1 +" ]", "General.-" ) + CRLF + ;
     	 "HALLADOS: " + AllTrim( Str( Len( a1 ) ) ) + ;
     	   '  De:   ' + ;
		AllTrim( str( Paciente->( LastRec() ) - nVac ) ) + ' = ' + ;
		iif( Len( a1 ) <= 0, '0', ;
		str( Len( a1 )*100 / Paciente->( LastRec() ), 8, 2 ) ) + " %"  + CRLF + CRLF 

/*
     TEMPFILT->( DbGotop() )
     DO WHILE !TEMPFILT->( Eof() )
 	c1 = c1 + Trim( TEMPFILT->TEXTO ) + CRLF
     TEMPFILT->( DbSkip() )
     ENDDO
 */
	a1 := ASORT( a1,,,{ | x, y| Upper( x ) < Upper( y ) } ) 
for n = 1 to len( a1 )
 	c1 = c1 + Trim( a1[ n ] ) + CRLF
next
  // MsgList( a1 )
  //lGraf := memoedit( c1, "Listados de Pacientes", 10, 25, 40, 100 )
 		
 TEMPFILT->( DBCLOSEAREA() )		
  CursorArrow()     
      if lInforme
		if lOpen
			Paciente->( DbCloseArea() )
	     endif
      	Return( aInf )
      endif
   
  RETURN  .t.   // memoedit( c1, "Listados de Pacientes", 10, 30, 40, 110 ) 
//----------------------------------------------


static function InfoBase( aInf )

   local oDlg, oLbx, bSize, bCoorSv, bCoorLee, cFCoors := "INFOCOOR.DAT", cMemoCoors := ""
   local aCoors := Array( 4 ), bRect, oFont, oMsgBar, n := 0, oScr, cTool, lOpen := .f., uVac := 0
   local cBmpPath   := 'c:\FWH\bitmaps\backgrnd\', lInf := .f., aHea
   DEFAULT aInf := Nil 
   lInf := !( aInf == Nil )
   lArray := iif( lInf, .t., .f. )
   
       bSize := {||  oWnd:CoorsUpdate(), Eval( bCoorSv ), ;
       oLbx:nWidth   := oWnd:nWidth   - 30, ;  // -50
       oLbx:nHeight := oWnd:nHeight  - 100 ;  // -100
    }
    
    cTool :=  "Intro->Celda derecha" + CRLF + ;
                                       "Mays.->Inicial nombres"
//-------------------------------------------------
       bCoorSv := {||  ;
        MemoWrit(  cFCoors,  Str( ( oWnd:nTop ) ) + CRLF + ;
        Str( ( oWnd:nLeft ) ) + CRLF + ;
        Str( ( oWnd:nBottom ) ) + CRLF + ;
                 Str( ( oWnd:nRight  ) ) ) }
 
    bCoorLee := {|| ;
         cMemoCoors := Trim( MemoRead( cFCoors ) ),;
         cMemoCoors := iif( MLCount( cMemoCoors ) > 3,;   // Valor valido // En caso de error, valor original.. q s  establece en cada entrada
     cMemoCoors,  AllTrim( Str( 8*16 ) ) + CRLF + AllTrim( Str( 20*8 ) ) + CRLF + ;
  				                 AllTrim( Str( 35*16 ) ) + CRLF + AllTrim( Str( 100*8 ) ) ), ; // msginfo( cMemocoors, str(MLCount( cMemoCoors )))
                    aCoors[ 1 ] := ( Val( TRIM( Memoline( cMemoCoors,, 1 ) ) )*1.011 ),;
  				  aCoors[ 2 ] := ( Val( TRIM( Memoline( cMemoCoors,, 2 ) ) ) ),;
  				  aCoors[ 3 ] := ( Val( TRIM( Memoline( cMemoCoors,, 3 ) ) )*0.949 ),;
    				  aCoors[ 4 ] := ( Val( TRIM( Memoline( cMemoCoors,, 4 ) ) )*0.986 )  }
/*
// Lines Styles
#define LINES_NONE            0
#define LINES_BLACK           1
#define LINES_GRAY            2
#define LINES_3D              3
#define LINES_DOTED           4
#define LINES_V_BLACK         5
#define LINES_V_GRAY          6
#define LINES_H_BLACK         7
#define LINES_H_GRAY          8
*/
//-------------------------------------------------
     USE TempFilt INDEX TempFilt
 
if Ascan( aGetWorkAreas(), "PACIENTE" ) == 0
	DbUseArea( .t., , "PACIENTE", , .T. ) // modo compartido
	lOpen := .t.      
endif
     Paciente->( DBEVAL( {|| uVac := ;
        iif( EmpTy( AllTrim( Paciente->Nombre ) ) .or. Empty( AllTrim( Paciente->Historia ) ), uVac++, uVac )  } ) )
     uVac := AllTrim( Str( Paciente->( LastRec() ) -uVac ) )
if lOpen
	Paciente->( DbCloseArea() )
endif

   DEFINE DIALOG oWnd FROM 5,10 TO 44, 106  ;
      TITLE iif( !( lArray ), "Archivo: TempFilt.Dbf  ", "Fecha: " + dtoc(date()) + " - Hora:  "+ time() ) + ;
        " -Total Pacientes: " + uVac + " - Filtrados: " + AllTrim( Str( TempFilt->( LastRec() ) ) ) + ;
                           " = " + AllTrim( Str( TempFilt->( LastRec() )*100/Val( uVac ) ) ) + " %"
                           
      oWnd:nStyle := nOr( WS_VISIBLE, WS_OVERLAPPEDWINDOW )
      oWnd:SetFont( aFont[1] )
          // Fin Fuentes
  
     Eval( bCoorLee )
    bRect := {|| ;
    		oWnd:nTop := aCoors[1], oWnd:nLeft := aCoors[2], oWnd:nBottom := aCoors[3], oWnd:nRight := aCoors[4]    }
    Eval( bRect )
    
/* 
Pruebas primeras bloque1
    @ 0, 0 XBROWSE oLbx OF oDlg ;
      ALIAS 'TEMPFILT' AUTOCOLS ;
      CELL LINES  ;
      COLOR CLR_HBLUE, CLR_WHITE  //  CLR_WHITE, CLR_BLUE
   */

//  pruebas avanzadas
   oLbx := TXBrowse():New( oWnd )
   if lInf  // Para el informe no se usa base de datos sino un array de dos dimensiones
       aHea := { "TTULOS      ", "      DATOS" }
       oLbx:SetArray( aInf )
       oLbx:lRecordSelector := .f.
       oLbx:aCols[ 1 ]:nDataStrAlign   := AL_RIGHT  // AL_LEFT  // AL_CENTER
       n := 0
       aeval( oLbx:aCols, { |oCols| n++, oCols:cHeader := aHea[ n  ] } )   
   endif
   oLbx:SetRDD()
       
   oLbx:nMarqueeStyle       := MARQSTYLE_HIGHLCELL
   oLbx:nColDividerStyle    := LINESTYLE_BLACK
   // oLbx:nRowDividerStyle    := LINESTYLE_BLACK
   oLbx:lColDividerComplete := .t.
   // oLbx:nDataLines          := 3
   oLbx:lAutoSort              := .t.
   // oLbx:bSeek                    := {|c| DbSeek( Upper( c ) ), SysRefresh() }
//   oLbx:SetBackGround( cBmpPath + 'wood.bmp' )
 
//   oLbx:lFastEdit := .t.
   aeval( oLbx:aCols, { | c, n | oLbx:aCols[ n ]:bClrStd := {|| { CLR_HBLUE, CLR_WHITE  } } } )
   aeval( oLbx:aCols, { |oCols|  oCols:nEditType := 1, ;  // oCols:cToolTip := cTool  // EDIT_GET
  oCols:bOnPostEdit := {|o, v, n| iif( n != VK_ESCAPE, ( DBRLOCK(), FieldPut( o:nCreationOrder, v ), DBUNLOCK() ), ) } ;
 } )  
      
   
//   Pruebas primeras y avanzadas, vale en las dos
   oLbx:CreateFromCode()
   oWnd:oClient := oLbx

   
   oLbx:bKeyChar = { | nKey, nFlags | KeyChar( nKey, nFlags, oLbx ) }  //, oLbx:Refresh( .t. ) }
//   oLbx:LDblClick =     {| nKey, nFlags | oLbx:Edit( 1 ) }
   oWnd:lResize16 := {|| .t. }
   oWnd:bResiZed := {|| Eval( bSize ) }
   oWnd:cToolTip := {"LDblClick Izq.->Edita celda" + CRLF + ;
                                        "(En edicin celda) Intro->Salir de edicin" + CRLF + ;
                                      IIF( lInf, "", "Mays.->Inicial-Campo 1" ), "Teclas:" ,, }
   ACTIVATE DIALOG oWnd ;
   				    ON INIT ( Eval( bSize ), Barrita( oWnd, oLbx, lInf ) ) ;
   				    ON MOVE Eval( bSize )

return nil

static function Mver( oWnd )
local oMVer   // nSel = estatica

      MENU oMver POPUP 2007

     MENUITEM "Aos y meses" ACTION nSel := 4 WHEN !Empty( cBasico )  // !Empty( AllTrim( aValues[ 1 ] ) )
     
      MENUITEM "Nombres" ACTION nSel := 2 WHEN !Empty( AllTrim( aValues[ 1 ] ) )
                    
      MENUITEM "Ciudades" ACTION nSel := 1 WHEN  !Empty( AllTrim( aValues[ 3 ] ) )
      
      MENUITEM "Sexo"   ACTION nSel := 3  WHEN  !Empty( AllTrim( aValues[ 7 ] ) )
      
      ENDMENU
      
      ACTIVATE POPUP oMVer DIALOG oWnd AT 25, 50

return nSel

static function PreVerDat( nSel )
local nI, c1 := "", c2 := "", c3 := "", c4, c5, aDatMes := {}, a1, n1, n3
local aLMeses := { "Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic" }
   // Meses
   c3 := AllTrim( aGPer[ 1 ] )
   if at( ";", c3 ) > 0
     do While at( ";", c3 ) > 0
        c4 := SubsTr( c3, 1, at( ";", c3 )-1 )     
        c3 := SubsTr( c3, at( ";", c3 ) +1 )
        aadd( aDatMes, c4 )
     enddo
   else    
      if !Empty( AllTrim( aGPer[ 2 ] ) )
         aDatMes := { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12" }
      endif
   endif
   c5 := ""
    aEval( aDatMes, {| c, n | n1 := n, c5 += aLMeses[ Val( AllTrim( aDatMes[ n1 ] ) ) ] + ";"   } )
do case

case nsel == 1
  n3 := aN3[ 1 ]
  For nI = 1 To Len( aDatcels )
          a1 := aDatCels[ nI ]
   	 aEval( a1, {| c, n | n1 := n, c1 += iif( n1 == 1, a1[ n1 ], ;
   	          iif(   nRad != 2, AllTrim( Str( INT( Val( a1[ n1 ] ) ) ) ), AllTrim( Str( Val( a1[ n1 ] )*100/n3 ), 5, 0 ) )     ) ;
   	                             + ";" } )
   		c1 += CRLF 
  Next
          c1 := "Ciudad;" + c5 + CRLF + c1
  
case nsel == 2
  n3 := aN3[ 2 ]
  For nI = 1 To Len( aDatcels2 )
   	a1 := aDatCels2[ nI ]
   	 aEval( a1, {| c, n | n1 := n, c1 += iif( n1 == 1, a1[ n1 ], ;
   	          iif(   nRad != 2, AllTrim( Str( INT( Val( a1[ n1 ] ) ) ) ), AllTrim( Str( Val( a1[ n1 ] )*100/n3 ), 5, 0 ) )     ) ;
   	                             + ";" } )
   	c1 += CRLF	 
  Next
          c1 := "Nombre;" + c5 + CRLF + c1
          
case nsel == 3
  n3 := aN3[ 3 ]
  For nI = 1 To Len( aDatcels3 )
   	 a1 := aDatCels3[ nI ]
   	 aEval( a1, {| c, n | n1 := n, c1 += iif( n1 == 1, a1[ n1 ], ;
   	          iif(   nRad != 2, AllTrim( Str( INT( Val( a1[ n1 ] ) ) ) ), AllTrim( Str( Val( a1[ n1 ] )*100/n3 ), 5, 0 ) )     ) ;
   	                             + ";" } )
   	c1 += CRLF	 
 Next  	
            c1 := "Sexo;" + c5 + CRLF + c1

case nsel == 4
            c1 := cBasico


endcase

c1 := memoedit( c1, "Listados de Pacientes: " + SubsTr( c1, 1, at( ";", c1 )-1 ), 10, 25, 40, 100 )
  MemoWrit( "WOCGET.TXT", c1 )
  
return nil

static function Barrita( oWnd, oLbx, lInf )
local oBar, oMver  // , nColor := 0
local cInfo := "Si ha puesto filtro en nombres, ciudades o sexo pulse el botn <Lista parcial> y se abrir " + ;
                         "el men donde puede elegir el apartado que desee para obtener la lista correspon"  + ;
                         "diente y en la cual puede seleccionar las lneas que quiere convertir en grficas ya sea en"  + ;
                         "viando a EXCEL o a la ventana grfica del programa." 

  DEFINE BUTTONBAR oBar SIZE 25, 25 _3DLOOK OF oWnd 2007

if lInf
  DEFINE BUTTON OF oBar FILE ".\bitmaps\WHelp2.bmp"  ACTION  ;
  ( MsgInfo( cInfo, "Informacin" ), oLbx:SetFocus(), oLbx:Refresh() ) TOOLTIP "Informacin de la ventana" 

  if lSexos .or. lNombres .or. lCiudades .or. !Empty( cBasico )
    DEFINE BUTTON OF oBar FILE ".\bitmaps\Find4.bmp"  ACTION  ;
    ( nSel := MVer( oWnd ), oLbx:SetFocus(), oLbx:Refresh(), PreVerDat( nSel ) )  TOOLTIP ;
    "Elegir el grupo que se desea convertir en grfica"
  endif
endif  
 
 DEFINE BUTTON OF oBar FILE ".\bitmaps\fivetech3.bmp"  GROUP    MESSAGE "Previsualizar" ACTION  ;
  	iif( File( "TEMPFILT.DBF" ), ( MiReport( oLbx, lArray ), oLbx:Refresh(), oLbx:SetFocus() ), ;
  								MsgInfo( "Debe crear la lista", "Informacin" ) ) ;
  		TOOLTIP "Previsualizar"  

 DEFINE BUTTON OF oBar FILE ".\bitmaps\WPrinter.bmp"      MESSAGE "Imprimir" ACTION  ;
  	iif( File( "TEMPFILT.DBF" ), ( MiReport( oLbx, lArray ), oLbx:Refresh(), oLbx:SetFocus() ), ;
  								MsgInfo( "Debe crear la lista", "Informacin" ) ) ;
  		TOOLTIP "Imprimir la lista"   
  		
 DEFINE BUTTON OF oBar FILE ".\bitmaps\WExit3.bmp"   GROUP   MESSAGE "Cerrar" ;
          ACTION oWnd:End() ;
  		TOOLTIP "Cerrar sesin" 
   
Return .t.

Function MiReport( oLbx )

     LOCAL oFont1, oFont2, nItem := 1
     DEFAULT lArray := .f.
     
     SET _3DLOOK ON

     DEFINE FONT oFont1 NAME "ARIAL" SIZE 0,-10
     DEFINE FONT oFont2 NAME "ARIAL" SIZE 0,-10 BOLD
         
if lArray  // Statica
      oLbx:Report()
else     
     TEMPFILT->( DBSelectArea() )
      TEMPFILT->( DBGotop() )
        // oLbx:Report()
           
//     GO TOP

     REPORT oReport ;
          TITLE  "Lista final de filtrados","","Utilidad de Wocul3.Exe" ;
          FONT oFont1, oFont2 ;
          HEADER "Fecha: "+dtoc(date()),"Hora:  "+time() ;
          FOOTER OemtoAnsi("Pgina: ")+str(oReport:nPage,3) ;
          PREVIEW   // TO PRINTER
 
     COLUMN TITLE "NOMBRE" ;
          DATA TempFilt->NOMBRE
 
     COLUMN TITLE "CIUDAD","TELEFONO" ;
          DATA TempFilt->Poblacion, TempFilt->Telefono
  
    COLUMN TITLE "SEXO", "FECHANACI" ;
          DATA TempFilt->Sexo, TempFilt->FechaNaci

    COLUMN TITLE "ALERGIAS", "DPOSTAL" ;
          DATA TempFilt->Alergias, TempFilt->DPostal
          
     END REPORT

     ACTIVATE REPORT oReport


      TEMPFILT->( DBGotop() )
endif
     
RETURN NIL

//----------------------------------------------------------------//

static function FiltrarUno( aFiltrados, nPos, aListaFil, cMemo, nClave )  // nClave orienta campos numericos
local nI, n, n1, n2, n3, c1, c2, c3, c4, a1, a2, a3, lTomar := .f., aTomar := {}, DateTop := Year( Date() )
DEFAULT nPos := 1
  aL     := { 1, 2, 3, 4, 5, 8, 9, 10, 16 }   // recuerda ..
n1 := Len( aListaFil )
 
For nI = nPos To n1  // La lista de los campos de filiacion o de bases de expl. que se aplican
   // Paciente->( DbGoto( 1 ) )
   
   a1 := {} 
   c1 := Trim( memoLine( cMemo, , nI )  )
  if !Empty( c1 )  // Si el campo no tiene filtro se aligera saltandolo ya aqu 
  
  if nI == 5 .and. lListado .and. Empty( c1 )
	c1 := Str( Year( Date() ) -120 ) + ";"  // 120 aos
  endif
  do While at( ";", c1 ) > 0
       c2 := AllTrim( SubsTr( c1, 1, at( ";", c1 )-1 ) )
       c1 := SubsTr( c1,  at( ";", c1 ) + 1 )
       aadd( a1, c2 )  // Se crea array con las cadenas a procesar
  enddo

  if Len( a1 ) > 0  // Si no, es que no hay filtro presente 
  
    // Se comprueban los seleccionados tras el filtrado anterior
    For n3 = 1 to Len( aFiltrados )
          Paciente->( DbGoto( Val( AllTrim( aFiltrados[ n3 ] ) ) ) )         	
    if !Empty( Paciente->( FieldGet( aL[ nI ] ) ) )	
    	     lTomar := .f.
   for n2 = 1 to Len( a1 )
    	     a1[ n2 ] := StrTran( a1[ n2 ], ":", ";"  )
    	     a1[ n2 ] := StrTran( a1[ n2 ], "$", ""  )  // Se eliminan los dolares improcedentes          
    	     a1[ n2 ] := StrTran( a1[ n2 ], ";", ""  )
  	     a1[ n2 ] := AllTrim( a1[ n2 ] )
  	if !Empty( a1[ n2 ] )
  	    if aL[ nI ] == 5 // and. nClave == 5 //.and. at( "$", a1[ n2 ] ) > 0      // Fechanaci es para tomar el ao de nacimiento  	           	          
  	          DateTop := iif( Len( a1 ) > 1,  Val( AllTrim( a1[ n2 + 1 ] ) ), DateTop )
             	    if Year( Paciente->FechaNaci ) >= Val( AllTrim( a1[ n2 ] ) ) .and. ;   // ao igual o mayor a nacimiento
             	         Year( Paciente->FechaNaci ) < DateTop
  	          	 if Ascan( aTomar, Str( Paciente->( RecNo() ) ) ) == 0
  	          	       aadd( aTomar, Str( Paciente->( RecNo() ) ) )
                     endif
             	    endif
             	    n2 ++  // para que salga de fechanaci tras la primera evaluacin
  	   else  // los otros campos
  	       if aL[ nI ] == 9   // Sexo excluyente
               if !EmpTy( a1[ n2 ] )
               DO CASE
  	          // case  a1[ n2 ] == "HN" .or. a1[ n2 ] == "NH" .or. EmpTy( AllTrim( a1[ n2 ] ) )               
  	          case  EmpTy( AllTrim( a1[ n2 ] ) )
  	                     c4 := Upper( Paciente->( FieldGet( aL[ nI ] ) ) )  	                                    
               case  a1[ n2 ] == "H"
                          c4 := "V"
               case  a1[ n2 ] == "M"           
  	                      c4 := "H"
  	          endcase            
  	          if at(  AnsiToOem( c4 ), Paciente->( FieldGet( aL[ nI ] ) ) ) > 0
    	          	 if Ascan( aTomar, Str( Paciente->( RecNo() ) ) ) == 0
  	          	       aadd( aTomar, Str( Paciente->( RecNo() ) ) )
                     endif
  	          endif
  	          endif
  	       else  	       
  	       	if at(  AnsiToOem( a1[ n2 ] ), Paciente->( FieldGet( aL[ nI ] ) ) ) > 0  	         	       
  	          	 if Ascan( aTomar, Str( Paciente->( RecNo() ) ) ) == 0
  	          	       aadd( aTomar, Str( Paciente->( RecNo() ) ) )
                     endif
   	       	endif  	    
  	       endif
  	   endif
     endif // de si no esta vacio a1[ n2 ]
    next  
    endif  // de si el campo del paciente no est vacio
    Next 
   
  endif  
  
  if Len( aTomar ) > 0  // Se hacen filtrados sucesivos como se hizo en el primer 
  	aFiltrados := aClone( aTomar )  // filtrado desde pacientes.dbf
  	aTomar := {}  
  endif
  endif // de si el presente campo de cMemo contiene o no filtro
Next
 
Return( aFiltrados )

static function refra( cValor, nRecPac )
local n1, n2, n3, n4, n5, a2, a3, a4, a5, c1, c2, c3, c4, c5, nI := 0
local nRec := 0, lHay := .f., cMax := "200"
 local nValor := 0, nc5 := 0, nMax := 200 
c5         := SubsTr( cValor, at( "$", cValor ) + 1 ) ; n5 := at( "$", c5 )   
if n5 > 0          
		cValor := SubsTr( c5, 1, n5 - 1 )  ; c5 := ( SubsTr( c5, n5 +1 ) )
else
          cValor := c5   ; c5 := "" 		
endif
 nValor := Val( cValor )  ;  nc5 := Val( c5 )  ; nMax := Val( cMax )  
 if nValor < 0
     nMax := -200
 	nMax := Min( nValor, iif( nc5 == 0, nMax, nc5  )   )
     nValor := iif( nValor == nMax, nc5, nValor )
 else
 	nMax := 200
     nMax := Max( nValor, iif( nc5 == 0, nMax, nc5 ) )
     nValor := iif( nValor == nMax, nc5, nValor )
 endif
cValor := AllTrim( Str( nValor ) )   ; cMax := AllTrim( Str( nMax ) )

a2 := {}
   nRecPac := Val( AllTrim( nRecPac ) )
   Paciente->( DbGoto( nRecPac ) )
 
 Historic->( DbGoto( Paciente->primero ) )
 
 do while  Historic->( RecNo() )  <=  Paciente->Ultimo  .and. !lHay       // y se buscan los datos
     if Historic->Refraccion > 0
               Refrac->( DbGoto( Historic->Refraccion ) )
               for n1 = 9 to 12
                  if !Empty( cValToChar( Refrac->( FieldGet( n1 ) ) ) )
                 		 aadd( a2, cValToChar( Refrac->( FieldGet( n1 ) ) ) )
                  endif
               next
               
               if Refrac->Gafas > 0
                    Gafas->( DbGoto( Refrac->Gafas ) )
                    for n1 = 1 to 4
                  		if !Empty( cValToChar( Gafas->( FieldGet( n1 ) ) ) )
                 			 aadd( a2, cValToChar( Gafas->( FieldGet( n1 ) ) ) )                       
                  		endif                    
                    next
               endif
 
                        do case
                        case nValor < 0  // miopicos
        
                            lHay := ( Ascan( a2, { | x | ABS( Val( AllTrim( x ) ) ) >= ABS( Val( AllTrim( cValor ) ) ) .and. ;
                         									ABS( Val( AllTrim( x ) ) ) <= ABS( Val( AllTrim( cMax ) ) )	 } ) > 0 ) 
 
                        case Val( AllTrim( cValor ) ) > 0  // hipermetr 
                            lHay := ( Ascan( a2, { | x | Val( AllTrim( x ) ) >= Val( AllTrim( cValor ) ) .and. ;
                            									Val( AllTrim( x ) ) <= Val( AllTrim( cMax ) )	 } ) > 0 )
  
                        endcase
                   		if ( lHay ) 
                   		  Exit
                   		endif  
      
     endif

          if !lHay .and. Historic->Siguiente > 0
               Historic->( DbGoto( Historic->Siguiente ) )
          else
                            Exit     
          endif
 enddo

return lHay

static function BPIO( cValor, nRecPac )
local n1, n2, n3, n4, n5, a2, a3, a4, a5, c1, c2, c3, c4, c5, nI := 0
local nRec := 0, lHay := .f., cMax := "200"
 local nValor := 0, nc5 := 0, nMax := 200 
c5         := SubsTr( cValor, at( "$", cValor ) + 1 ) ; n5 := at( "$", c5 )   
if n5 > 0          
		cValor := SubsTr( c5, 1, n5 - 1 )  ; c5 := ( SubsTr( c5, n5 +1 ) )
else
          cValor := c5   ; c5 := "" 		
endif
 nValor := Val( cValor )  ;  nc5 := Val( c5 )  ; nMax := Val( cMax )  

  	nMax := 200
     nMax := MAX( nValor, iif( nc5 == 0, nMax, nc5 ) )
     nValor := iif( nValor == nMax, nc5, nValor )

cValor := AllTrim( Str( nValor ) )   ; cMax := AllTrim( Str( nMax ) )

a2 := {}
// cValor := StrTran( cValor, "$", "" )
// cValor := StrTran( cValor, ";", "" )

   nRecPac := Val( AllTrim( nRecPac ) )
   Paciente->( DbGoto( nRecPac ) )
  
 Historic->( DbGoto( Paciente->primero ) )

 do while  Historic->( RecNo() )  <=  Paciente->Ultimo  .and. !lHay       // y se buscan los datos
     if Historic->Tonometria > 0
     		Tonomet->( DbGoto( Historic->Tonometria ) )
     
               for n1 = 2 to 3
                  if !Empty( cValToChar( Tonomet->( FieldGet( n1 ) ) ) )
                 		 aadd( a2, cValToChar( Tonomet->( FieldGet( n1 ) ) ) )
                  endif
              next
                //  lHay := ( Ascan( a2, { | x | Val( AllTrim( x ) ) >= Val( AllTrim( cValor ) ) } ) > 0 )
                           lHay := ( Ascan( a2, { | x | Val( AllTrim( x ) ) >= Val( AllTrim( cValor ) ) .and. ;
                            									Val( AllTrim( x ) ) <= Val( AllTrim( cMax ) )	 } ) > 0 )
 
                   		if ( lHay ) 
                   		  Exit
                   		endif  
     endif

          if !lHay .and. Historic->Siguiente > 0
               Historic->( DbGoto( Historic->Siguiente ) )
          else
                            Exit     
          endif
 enddo

return lHay

static function Bases( nI, a1, nRecPac, lBasePac, Ide ) 
   local nRecBase := 1, mHistoria := Paciente->Historia
   local bqtabla   := {}   // array para archivar nombres de pacientes
   local bqcolorx  := setcolor(  )
   local bqcolespec
   local bqnombre  := space( 40 )
   local bqresp    := space( 1 )
   local bqrec1    := 0
   local bqorden   := 0, n2 := 1
 
   local bqlinea5  := ""
   local bqhist    := ""
   local bqbase, TempBase
   local resp, cFiltrado := " "
   local lHay := .f., mHis := '', cFMxpH, cF
   local cExt     := "000"  // PADL( AllTrim( str( nUsuario, 3 ) ), 3, "0" ) // 001, 2, 3..
   local cParMail := 'FRVMAIL.' + cExt   // parametro para llamar a mail
   
   Field Linea1, Linea2, Linea3, Linea4, amplia, Historia
 
   MemVar CampoH
   MemVar Base
   MemVar cInd

   DEFAULT lBasePac := .f., Ide := 0
   
   Base     := "B" + AllTrim( str( nI ) )
   CampoH   := "C" + AllTrim( str( nI ) )
   cF    := 'C' + AllTrim( Str( nI, 2 ) )
   nRecPac := Val( AllTrim( nRecPac ) )

   Paciente->( DbGoto( nRecPac ) )
  // if lBasePac
 
  // endif
 
 Historic->( DbGoto( Paciente->primero ) )

 do while  Historic->( RecNo() )  <=  Paciente->Ultimo  .and. !lHay       // y se buscan los datos
 
      IF Historic->( &CampoH ) > 2 
	      bqrec1 := Historic->( &CampoH )    
		 ( "&BASE" )->( DbGoto( bqrec1 ) ) 
	      bqlinea5 := ( "&BASE" )->( FieldGet( 1 ) ) + ;
			( "&BASE" )->( FieldGet( 2 ) ) + ;
			( "&BASE" )->( FieldGet( 3 ) ) + ;
			( "&BASE" )->( FieldGet( 4 ) )

			      if ( "&BASE" )->( FieldGet( 5 ) ) > 0 // Amplia
				 ( "&BASE" )->( DbGoto( FieldGet( 5 ) ) )
					     // hay 2 registros encadenados
				bqlinea5 += ( "&BASE" )->( FieldGet( 1 ) ) + ;
				( "&BASE" )->( FieldGet( 2 ) ) + ;
				( "&BASE" )->( FieldGet( 3 ) ) + ;
				( "&BASE" )->( FieldGet( 4 ) )
				 ( "&BASE" )->( dbgoto( bqrec1 ) )
                     endif
                                   
               if    ( "&BASE" )->( FCount() ) > 5 // Si hay campo memo se lee
                   bqlinea5 += ( "&BASE" )->( FieldGet( 6 ) ) 
               endif
			
			// y si hay archivo de texto en subdirectorio tambien se lee
               cFMxpH := HB_CurDrive() + ':\' + GetCurDir() + '\' + CampoH + '\F' + ;
                  PADL( alltrim( Str( ( "&Base" )->( Recno() ) ) ) , 7, '0' ) + '.' + cF			
			 if File( cFMxpH )
			 	bqlinea5 += MemoRead( cFMxpH )
			 endif       
      
      		for n2 = 1 to Len( a1 )  // cada elemento de filtro para cada cada base
                   if AllTrim( Upper(a1[ n2 ]) ) $ Upper( bqlinea5 )
                   		lHay := .t.  ;  Exit
                   endif
               next 
      endif
      
		     // bqlinea5 := upper( bqlinea5 )
          if !lHay .and. Historic->Siguiente > 0
               Historic->( DbGoto( Historic->Siguiente ) )
          else
                            Exit     
          endif

 enddo


Return  lHay

Static Function AbreBases()
	 DbUseArea( .t., , "PACIENTE", , .T. ) // modo compartido
/*
usa_base( "HISTORIC", .f., "historic, historia", 5, .t. )
//usa_base( "ANAL", .f., "", 5, .t. )
usa_base( "PACIENTE", .f., "paciente, fechault, nomhisto, iniciado", 5, .t. )
*/
	 DbUseArea( .t., , "HISTORIC", , .T. ) // modo compartido
      DbSetIndex( "Historia" )
      
	 DbUseArea( .t., , "B1", , .T. ) // modo compartido
	 DbUseArea( .t., , "B2", , .T. )
	 DbUseArea( .t., , "B3", , .T. )	 
	 DbUseArea( .t., , "B4", , .T. )	 
	 DbUseArea( .t., , "B5", , .T. )
	 DbUseArea( .t., , "B6", , .T. )	 
	 DbUseArea( .t., , "B7", , .T. )
	 DbUseArea( .t., , "B8", , .T. )
	 DbUseArea( .t., , "B9", , .T. )
	 DbUseArea( .t., , "B10", , .T. )
	 DbUseArea( .t., , "B11", , .T. )
	 DbUseArea( .t., , "B12", , .T. )
	 DbUseArea( .t., , "B13", , .T. )
	 DbUseArea( .t., , "B14", , .T. )
	 DbUseArea( .t., , "REFRAC", , .T. )
	 DbUseArea( .t., , "GAFAS", , .T. )
	 DbUseArea( .t., , "TONOMET", , .T. )
	
return Nil

#include "richedit.ch"



//----------------------------------------------------------------------------//

Static function MemoEdit( cText, cTitle, nTop, nLeft, nBottom, nRight )

   local oFont, oMemo, oBtnOk, oBtnCancel, oBtnHelp
   local hDLL
   local uTemp := '', aCoors, bCoorSv, bCoorLee, cMemoCoors := "", cFCoors := "FILTMEMO.DAT", bSize, bRect
   local lRich := .f., lOk   := .f.
   
    DEFAULT nTop := 9, nLeft := 9, nBottom := 23, nRight := 68.5,;
           cTitle := "MemoEdit"
   // cText := "{\rtf" + cText  en rtf no va bien.

   aCoors := Array( 4 )    
   bCoorSv := {||  ;
        MemoWrit(  cFCoors,  Str( ( oWnd:nTop ) ) + CRLF + ;
        Str( ( oWnd:nLeft ) ) + CRLF + ;
        Str( ( oWnd:nBottom ) ) + CRLF + ;
                 Str( ( oWnd:nRight  ) ) ) }
    
    bCoorLee := {|| ;
         cMemoCoors := Trim( MemoRead( cFCoors ) ),;
         cMemoCoors := iif( MLCount( cMemoCoors ) > 3,;   // Valor valido // En caso de error, valor original.. q s  establece en cada entrada
     cMemoCoors,  AllTrim( Str( 8*16 ) ) + CRLF + AllTrim( Str( 20*8 ) ) + CRLF + ;
  				                 AllTrim( Str( 35*16 ) ) + CRLF + AllTrim( Str( 100*8 ) ) ), ;  // msginfo( cMemocoors, str(MLCount( cMemoCoors )))
                    aCoors[ 1 ] := ( Val( TRIM( Memoline( cMemoCoors,, 1 ) ) )*1.011 ),;
  				  aCoors[ 2 ] := ( Val( TRIM( Memoline( cMemoCoors,, 2 ) ) ) ),;
  				  aCoors[ 3 ] := ( Val( TRIM( Memoline( cMemoCoors,, 3 ) ) )*0.949 ),;
    				  aCoors[ 4 ] := ( Val( TRIM( Memoline( cMemoCoors,, 4 ) ) )*0.986 )  }
  				                 
    // Eval( bCoorLee )
    // Fin Coordenadas
   
    bSize := {||  oWnd:CoorsUpdate(), Eval( bCoorSv ) }

   DEFINE FONT oFont NAME "Arial" SIZE 0, -12  BOLD

   DEFINE DIALOG oWnd FROM nTop, nLeft TO nBottom, nRight ;
      TITLE cTitle FONT oFont

    Eval( bCoorLee )
    bRect := {|| ;
    		oWnd:nTop := aCoors[1], oWnd:nLeft := aCoors[2], oWnd:nBottom := aCoors[3], oWnd:nRight := aCoors[4]    }
    Eval( bRect )
   /* 
   if IsRTF( cText )
      uTemp := "   "  // cText
      lRich := .t.
      hDLL  := LoadLibrary( 'riched20.dll' )
      @ 4, 3 RICHEDIT oMemo VAR uTemp OF oWnd PIXEL SIZE 100,100
   else
  */
      uTemp := "   "  // cText
      @ 15, 3 GET oMemo VAR uTemp MEMO OF oWnd PIXEL SIZE 100, 100 FONT oFont ;
      ON CHANGE  MemoWrit( "WOCGET.TXT", uTemp )
      
      oMemo:bGotFocus = { || oMemo:SetSel( 0, 0 ) }
  // endif
       oMemo:LimitText()
       oMemo:SetColor( CLR_HBLUE, CLR_WHITE )
       
 oWnd:nStyle := nOr( WS_VISIBLE, WS_OVERLAPPEDWINDOW )		// nOr( WS_CAPTION, WS_BORDER, WS_THICKFRAME )
 oWnd:lResize16 := {|| .t. }

/*
   @ 110,  70 BUTTON oBtnOk PROMPT "&Grficas" SIZE 70, 12 PIXEL ;
      ACTION ( If( lRich, cText := oMemo:SaveAsRTF(), cText := uTemp ), ;
               lOk := .t., oWnd:End() )

   @ 110, 110 BUTTON oBtnCancel PROMPT "&Cancelar" SIZE 70, 12 PIXEL ;
      ACTION ( lOk := .f., oWnd:End() )
*/
   oWnd:bResiZed := {|| Eval( bSize ), Eval( oWnd:bInit ), oWnd:Refresh() }   
   ACTIVATE DIALOG oWnd ;  // CENTERED 
      ON PAINT ( uTemp := cText, oMemo:Refresh() ) ;
      ON INIT ( CursorArrow(),  uTemp := cText, MemoWrit( "WOCGET.TXT", uTemp ), MiniBarr( oWnd, uTemp ), ;    
                oMemo:SetSize( oWnd:nWidth() - 30, oWnd:nHeight() - 87 ),;
                If( lRich, ( oMemo:SetText( cText ) ), oMemo:SetSel( 0,0 ) ) )
                
               /*
                oBtnCancel:nTop  := oWnd:nHeight() - 64,;
                oBtnCancel:nLeft := oWnd:nWidth() - 170,;
                oBtnOk:nTop      := oWnd:nHeight() - 64,;
                oBtnOk:nLeft     := oWnd:nWidth() - 313 ) 
 */
   oFont:End()
/*
   if hDLL != nil
      FreeLibrary( hDLL )
   endif
*/
return uTemp // lOk 

static function MiniBarr( oWnd, uTemp )
local oBar, oMver  // , nColor := 0
local cInfo := "Puede modificar las lneas pero respetando la estructura, de forma que todas las lneas " + ;
                         "tengan igual nmero de elementos, y todas las columnas igual nmero de lneas " + ;
                         "y por lo tanto puedes aadir o suprimir lneas completas o columnas completas "  + ;
                         "pero sin dejar lneas o columnas en blanco, tienen que estar adosadas " + ;
                         "y NO eliminar NUNCA la primera lnea o la primera columna, ni anteponer elementos a ellas"                          

  DEFINE BUTTONBAR oBar SIZE 25, 25 _3DLOOK OF oWnd 2007

  DEFINE BUTTON OF oBar FILE ".\bitmaps\WHelp2.bmp"  ACTION  ;
  ( MsgInfo( cInfo, "Informacin" ) ) TOOLTIP "Informacin de la ventana" 
  
  DEFINE BUTTON oBot OF oBar FILE ".\bitmaps\Chart.bmp"    MESSAGE "Grficas" ;
          ACTION (  ;
          iif( File( "WOCGRAPH.EXE" ), iif( File( ".\WOCGET.TXT" ), ;
                 WaitRun( "WOCGRAPH.EXE " + ".\WOCGET.TXT" ), MsgWait( "Sin archivo de grficas", "Atencin", 1 ) ),;
                        MsgStop( "WOCGRAPH.EXE" + " NO encontrado.", "Atencin" ) ) ) ; 
  	    TOOLTIP "Grficas "

  DEFINE BUTTON OF oBar FILE ".\bitmaps\Excel.bmp"     MESSAGE "Abrir grfica en Excel"  ;
  	    ACTION (  AExcel( oWnd )  ) ;
  	    TOOLTIP "Abrir en Excel"   NOBORDER
  
   DEFINE BUTTON OF oBar FILE ".\bitmaps\WExit3.bmp"   GROUP   MESSAGE "Cerrar" ;
          ACTION oWnd:End() ;
  		TOOLTIP "Cerrar sesin" 
  
Return .t.

//----------------------------------------------------------------------------//
static function KeyChar( nKey, nFlags, oLbx )
//*********************************************************************
   local nArea  := SELECT(), cAreaUso := ALIAS( nArea ), cTxt

   do case
//      case nKey == 13   //  K_ENTER
  //      oLbx:GoRight()          
       
      case nKey > 64 .and. nKey < 91  .or. ;  // A -> Z
                 nKey > 48 .and. nKey < 58   // 1 -> 9
      
        SET SOFTSEEK ON
	    ( cAreaUso )->( DbSeek( Chr( nKey ) ) )
 
  
      
     oTherWise
	MsgBeep()
   
   endcase

                oLbx:SetFocus()
                oLbx:Refresh() 

return nil
//---------
 static function Aexcel( oDlg, uValor )
   local oExcel // := CreateObject( "excel.application" )
   local oBook // := oExcel:Workbooks:Add()
   local oSheet // := oBook:Worksheets( 1 ) 
   local aLetras := Letras( 1 ), nLins, nCols, nI, n1, n2, a1, a2, a3, c1, c2, c3, lValor := .t.
   local cFile := "C\FWH\SAMPLES\GRAFICOS\Graf04.Txt"
 
  // local oWnd := GetWndDefault() // 	oWnd := GetWndApp()   //GetWndDefault() //Nil    //GetActiveWindow() 
   DEFAULT uValor := .t.  // .t. = llamada desde exponer que la lista est preparada
   // se crea la lista de los datos

c1 := MemoRead( "WOCGET.TXT" )
// ? c1
msgwait( "Cargando", "Datos", 0.2 )
if Empty( c1 )
	MsgInfo( "La lista no est preparada.", "Atencin"  )
     Return Nil
else
 
     a1 := {}
     nLins := MLCount( c1 )
     For nI := 1 to nLins
         a2 := {}
         c2   := MemoLine( c1,, nI )
         if nI > 1
              c2   := "S " + Ltrim( c2 )  
         endif 
         do while at( ";", c2 ) > 0
             aadd( a2, Substr( c2, 1, at( ";", c2 ) -1 ) )
             c2 := Substr( c2, at( ";", c2 ) +1 ) 
         enddo
         aadd( a1, a2 )
     Next
 
endif

   TRY
      oExcel := GetActiveObject( "Excel.Application" )
   CATCH
      TRY
         //oExcel := CreateObject( "Excel.Sheet" )
          oExcel := CreateObject( "Excel.Application" )
      CATCH
         Alert( "ERROR!, Excel no disponible. [" + Ole2TxtError() + "]" )
         RETURN Nil
      END
   END
 
   oBook  := oExcel:Workbooks:Add()
   oSheet := oBook:Worksheets( 1 ) 

   // Ahora se procesan para enviar a Excel
   nLins := Len( a1 ) ; nCols := Len( a1[1] )
  
   for nI = 1 to nLins  // filas una a una
   
         for n1 = 1 to nCols  // columnas ...    
               c1 := aLetras[ n1 ] + AllTrim( Str( nI ) )
               oSheet:Range( c1 ):Value = a1[ nI, n1 ]
         next
         if nI == 1
                    oSheet:Range(  "A1:" + aLetras[ nCols ] + "1" ):Font:Bold = .T.
         else
               oSheet:Columns( 1 ):Font:Bold := .T.     
         endif
   next
     oSheet:Cells( 2, 2 ):Select()
     oSheet:Cells:Font:Name := "Arial"
     oSheet:Cells:Font:Size := 12
    
     oDlg:Restore()     
     
     oExcel:Visible = .T.
 
return nil

static function Letras( nValor )
   local aValor := {}
do Case
case nValor == 1
    aValor := { "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", ;
    "X", "Y", "Z", "AA", "AB", "AC", "AD", "AE", "AF", "AG", "AH", "AI", "AJ", "AK", "AL", "AM", "AN", "AO", "AP", "AQ", ;
    "AR", "AS", "AT", "AU", "AV", "AX", "AY", "AZ", "BA", "BB", "BC", "BD", "BE"  } // 54 de momento
    
otherwise
     aValor := Array( 50 ) ; aEval( aValor, {|c,n| aValor[n] := n } )  
EndCase
     
return aValor
